<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class AuthRule extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/AuthRule/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/AuthRule/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/AuthRule/save',$this->getdata);
                $this->list_base['title'] = $this->request->action == 'create' ? '添加权限' : '编辑权限';
                $this->FormFile();
                break;
        }
    }
    //  打包表格显示信息
    protected function ListTable(){
        $this->list_base['button'] = [];
        if($this->user_auth['create']){
            array_push($this->list_base['button'],['title' => '添加权限','open' => true, 'url' => GetEruUrl('admin/AuthRule/create')]);
        }
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center', 'fixed' => 'left'],
            ['field' => 'title','title' => '权限名称','width' => '300','type' => $this->user_auth['edit'] ? 'edit' : 'text'],
            ['field' => 'model_name','title' => '所属模块','width' => '100','textalign' => 'center'],
            ['field' => 'name','title' => '权限地址','width' => '30%','type' => 'text'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];

        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','open' => true, 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-caozuo', 'url' => GetEruUrl('admin/AuthRule/edit',['id' => '__id__']), 'fixed' => 'right']
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file,
                ['field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','event' => 'del', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/AuthRule/del',['id' => '__id__']), 'fixed' => 'right']
            );
        }
    }
    //  打包表格显示信息
    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '权限名称','type' => 'text','boxwidth' => 'ery-xs6','required' => true],
            ['field' => 'name','title' => '权限地址','type' => 'text','boxwidth' => 'ery-xs6','required' => true],
            ['field' => 'model','title' => '所属模型','type' => 'text','tip' => '核心模型请留空'],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true]
        ];
        if($this->request->action == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }

}