<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class ConfigPart extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/ConfigPart/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/ConfigPart/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/ConfigPart/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加配置分类' : '编辑配置分类';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '分类名称','type' => $this->user_auth['edit'] ? 'edit' : 'text','width' => '30%'],
            ['field' => 'config_num','title' => '配置数量','width' => '120','textalign' => 'center'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        if($this->user_auth['edit']) {
            array_push($this->list_file, ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','open' => true, 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/ConfigPart/edit',['id' => '__id__']), 'fixed' => 'right']);
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, ['field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/ConfigPart/del',['id' => '__id__']), 'fixed' => 'right']);
        }
        if($this->user_auth['create']){
            $this->list_base['button'] = [['title' => '添加分类','open' => true, 'url' => GetEruUrl('admin/ConfigPart/create')]];
        }
        $this->list_search = [
            'input' => [
                ['field' => 'key','title' => '关键词']
            ]
        ];
    }
    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '分类名称','type' => 'text','required' => true],
            ['field' => 'icon','title' => '分类图标','type' => 'icon'],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
}