<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use think\facade\Cache;

class ConfigUp extends AdminBase
{
    protected $Read;
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel();
        $this->getup();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('admin/ConfigUp/create',$this->getdata);
                break;
        }
    }
    //  检测是否存在更新
    public function create()
    {
        //  查询是否存在未更新版本
        if(!empty($this->Read) && $this->Read['status'] != '1'){
            ResJson($this->Read,"有等待更新的版本，请更新",'2',GetEruUrl('edit',['id' => $this->Read['id']]));
        }
        //  查询现有版本
        $old = GetReadFile(base_path().'app.lock');
        $old = json_decode($old,true);
        //  查询远程版本
        $server = $this->model->GetServerNo($old['server'],['empower_no' => $old['version_no'],'empower_code' => $this->webdb['web_warrant'],'name' => $this->request->domain(true)]);
        //  如果没有更新，则返回
        if(empty($server['code']) || empty($server['data'])){
            ResJson([],$server['msg'],$server['code']);
        }
        //  保存更新信息
        $res = [
            'edition_no' => $server['data']['version'],
            'edition_uri' => $server['data']['dowurl'],
            'cont' => $server['data']['cont'],
            'status' => '0',
        ];
        $res = $this->model->EditAdd($res);
        if($this->Read = $this->model->SetOne($res)){
            Cache::set('upserver',$this->Read);
            ResJson($this->Read,"{$server['msg']} {$server['data']['title']}",'2',GetEruUrl('edit',['id' => $this->Read['id']]));
        }
        ResJson([],'升级失败，请重试','0');
    }
    //  获取远程文件‘
    public function edit()
    {
        if(!empty($this->Read['files'])){
            ResJson($this->Read,'获取升级文件成功，开始解压升级包...','2',GetEruUrl('unzip',['id' => $this->Read['id']]));
        }
        $res = $this->model->GetUpFile($this->Read);
        if(!$res){
            ResJson([],'获取升级文件失败，请稍后再试','0');
        }
        $this->Read['files'] = "update/{$this->Read['edition_no']}.zip";
        if($this->Read = $this->model->SetOne($this->Read)){
            Cache::set('upserver',$this->Read);
            ResJson($this->Read,'获取升级文件成功，开始解压升级包...','2',GetEruUrl('unzip',['id' => $this->Read['id']]));
        }
        ResJson([],'获取升级文件失败，请稍后再试','0');
    }
    //  解压文件
    public function unzip(){
        $_zip = new \ZipArchive();
        if($_zip->open(root_path().$this->Read['files'])){
            $dir = root_path("update/{$this->Read['edition_no']}");
            DelDir($dir);
            if (!file_exists($dir)) {
                @mkdir($dir,0755,true);
            }
            $_zip->extractTo($dir);
            $_zip->close();
            ResJson([],'升级包解压成功，读取升级文件...','2',GetEruUrl('read',['id' => $this->Read['id']]));
        }
        ResJson([],'升级包解压失败，请重试','0');
    }
    //  读取更新内容
    public function read(){
        $_list = ReadDirList("update/{$this->Read['edition_no']}");
        Cache::delete('update_fiellist');
        Cache::set('update_fiellist',$_list);
        ResJson([],'读取升级文件完成，开始备份原有文件...','2',GetEruUrl('backup',['id' => $this->Read['id']]));
    }
    //  备份原有文件
    public function backup(){
        $res = Cache::get('update_fiellist');
        if(empty($res)){
            Cache::delete('update_fiellist');
            ResJson([],'文件备份完成，开始升级文件...','2',GetEruUrl('upfile',['id' => $this->Read['id']]));
        }
        $backup = array_splice($res,0,1);
        $backup = str_replace("update/{$this->Read['edition_no']}",'',$backup['0']);
        if(is_file(root_path() . $backup)){
            $_res = CopyFiles(root_path() . $backup,"backup/{$this->Read['edition_no']}".$backup);
            if(!$_res){
                ResJson([],'文件备份失败，请重试...','0');
            }
        }
        if(empty($res)){
            Cache::delete('update_fiellist');
            ResJson([],'文件备份完成，开始升级文件...','2',GetEruUrl('upfile',['id' => $this->Read['id']]));
        }
        Cache::set('update_fiellist',$res);
        ResJson([],"备份文件：{$backup}",'2',GetEruUrl('backup',['id' => $this->Read['id']]));
    }
    //  开始复制升级文件
    public function upfile(){
        if(Cache::has('copy_fiellist')){
            $filelist = Cache::get('copy_fiellist');
        } else {
            $filelist = ReadDirList("update/{$this->Read['edition_no']}");
            Cache::set('copy_fiellist',$filelist);
        }
        if(empty($filelist)){
            Cache::delete('copy_fiellist');
            ResJson([],'文件升级完成，开始备份数据库...','2',GetEruUrl('backupsql',['id' => $this->Read['id']]));
        }

        $backup = array_splice($filelist,0,1);
        $backup = str_replace("update/{$this->Read['edition_no']}",'',$backup['0']);

        $filename = basename($backup,'.php');
        if($filename == 'updatesql'){
            $_list = require "update/{$this->Read['edition_no']}/$backup";
            Cache::set('update_sql',$_list);
            Cache::set('copy_fiellist',$filelist);
            ResJson([],"升级文件：{$backup}",'2',GetEruUrl('upfile',['id' => $this->Read['id']]));
        }
        $_res = CopyFiles("update/{$this->Read['edition_no']}" . $backup,$backup);
        if(!$_res){
            ResJson([],'文件升级失败，请重试...','0');
        }
        if(empty($filelist)){
            Cache::delete('copy_fiellist');
            ResJson([],'文件升级完成，开始备份数据库...','2',GetEruUrl('backupsql',['id' => $this->Read['id']]));
        }
        Cache::set('copy_fiellist',$filelist);
        ResJson([],"升级文件：{$backup}",'2',GetEruUrl('upfile',['id' => $this->Read['id']]));
    }
    //  备份数据库
    public function backupsql(){
        if(!Cache::has('update_sql')){
            ResJson([],"数据库升级完成，正在完成升级...",'2',GetEruUrl('end',['id' => $this->Read['id']]));
        }
        $_m = new \app\common\model\SqlManage();
        if(Cache::has('backupsql')){
            $res = Cache::get('backupsql');
        } else {
            $_tablename = $_m->GetList($this->getdata,false);
            $res = array_column($_tablename,'table_name');
        }
        if(count($res) < '1'){
            ResJson([],'数据库备份成功，开始升级数据库...','2',GetEruUrl('upsql',['id' => $this->Read['id']]));
        }
        $_tablename = array_splice($res,0,1);
        $_tablename = $_tablename['0'];
        $_sql = $_m->Backup($_tablename);
        //  写入文件
        $_res =$_m->SetFile($_sql);
        //  如果写入失败，则清除所有缓存
        if(empty($_res['code'])){
            Cache::delete('backupsql');
            ResJson([],"数据库备份失败，请重试",'0');
        }
        //  保存已备份的表结构
        if(Cache::has('backuplist')){
            $_tablelist = Cache::get('backuplist');
        }
        $_tablelist['table'] = empty($_tablelist['table']) ? [] : $_tablelist['table'];
        array_push($_tablelist['table'],$_tablename);
        Cache::set('backuplist',$_tablelist,3600);

        if(count($res) < '1'){
            Cache::delete('backupsql');
            ResJson([],"备份表结构成功，开始备份数据...",'2',GetEruUrl('backupsqllist',['id' => $this->Read['id']]));
        }
        Cache::set('backupsql',$res,3600);
        $res = count($res);
        ResJson([],"备份 {$_tablename} 表结构成功，剩余 {$res} ...",'2',GetEruUrl('backupsql',['id' => $this->Read['id']]));
    }
    public function backupsqllist(){
        //  保存已备份的表结构
        if(Cache::has('backuplist')){
            $_tablelist = Cache::get('backuplist');
        }
        if(count($_tablelist['table']) < '1'){
            Cache::delete('backuplist');
            ResJson([],'备份数据库成功,开始升级数据库...','2',GetEruUrl('upsql',['id' => $this->Read['id']]));
        }
        $_m = new \app\common\model\SqlManage();
        $limit = empty($_tablelist['set_limit']) ? '500' :  $_tablelist['set_limit'];
        $page = empty($_tablelist['set_page']) ? '1' :  $_tablelist['set_page'];
        $_tablename = $_tablelist['table']['0'];
        $_sql = $_m->GetDataList($_tablename,$limit,$page);

        if($_sql['total'] < '1'){
            unset($_tablelist['table']['0']);
            sort($_tablelist['table']);
            $_tablelist['set_limit'] = '500';
            $_tablelist['set_page'] = '1';
            Cache::set('backuplist',$_tablelist,3600);
            ResJson([],"备份 {$_tablename} 表数据成功1...",'2',GetEruUrl('backupsqllist',['id' => $this->Read['id']]));
        }

        foreach ($_sql['data'] as $v){
            $_v = $_m->SetFile($v);
            //  如果写入失败，则清除所有缓存
            if(empty($_v['code'])){
                Cache::delete('backuplist');
                DelDir($_tablelist['dir']);
                ResJson([],$_v['msg'],'0');
            }
        }

        if($_sql['current_page'] >= $_sql['last_page']){
            unset($_tablelist['table']['0']);
            sort($_tablelist['table']);
            $_tablelist['set_limit'] = '500';
            $_tablelist['set_page'] = '1';
            Cache::set('backuplist',$_tablelist,3600);
            ResJson([],"备份 {$_tablename} 表数据成功...",'2',GetEruUrl('backupsqllist',['id' => $this->Read['id']]));
        }
        $_tablelist['set_limit'] = '500';
        $_tablelist['set_page'] = $_sql['current_page'] + 1;
        Cache::set('backuplist',$_tablelist,3600);
        ResJson([],"正在备份 {$_tablename} 表，请等待...",'2',GetEruUrl('backupsqllist',['id' => $this->Read['id']]));
    }
    //  升级数据库
    public function upsql(){
        $_list = require "update/{$this->Read['edition_no']}/updatesql.php";
        $_m = new \app\common\model\SqlManage();

        if(!empty($_list['add_table'])){
            foreach ($_list['add_table'] as $v){
                $_v = [];
                foreach ($v['data'] as $v1){
                    $_v1 = $_m->EditCreateVal($v1);
                    array_push($_v,$_v1);
                }
                $v['sql_field'] = implode(",\n",$_v);
                if(!$_m->CreateTable($v)){
                    ResJson([],"数据库升级失败",'0');
                }
            }
        }
        if(!empty($_list['add_filed'])){
            foreach ($_list['add_filed'] as $v){
                foreach ($v['data'] as $v1){
                    $v1['sql_field'] = $_m->EditCreateVal($v1);
                    $v1['table_name'] = $v['table_name'];
                    if(!$_m->CreateField($v1)){
                        ResJson([],"数据库升级失败",'0');
                    }
                }
            }
        }
        if(!empty($_list['add_value'])){
            foreach ($_list['add_value'] as $v){
                $_m->CreateData($v);
            }
        }
        ResJson([],"数据库升级完成，正在完成升级...",'2',GetEruUrl('end',['id' => $this->Read['id']]));
    }
    //  完成升级
    public function end(){
        $update = [
            'id' => $this->Read['id'],
            'status' => '1',
        ];
        $update = $this->model->EditAdd($update);
        $this->model->SetOne($update);

        $old = GetReadFile(base_path().'app.lock');
        $old = json_decode($old,true);
        $old['version_no'] = $this->Read['edition_no'];
        $old['edit_time'] = date('Y-m-d H:i:s');
        WriteFile(base_path().'app.lock', json_encode($old,JSON_UNESCAPED_UNICODE));

        $dir = root_path("update/{$this->Read['edition_no']}");
        DelDir($dir);
        Cache::delete('upserver');
        Cache::delete('backuplist');
        Cache::delete('backupsql');
        Cache::delete('update_sql');
        Cache::delete('copy_fiellist');
        Cache::delete('update_fiellist');
        ResJson([],"系统升级完成");
    }
    //  查询更新信息
    public function getup(){
        if(Cache::has('upserver')){
            $this->Read = Cache::get('upserver');
        } else {
            $this->Read = $this->model->GetOne();
            Cache::set('upserver',$this->Read);
        }
    }
    //  查询是否存在更新
    public function checkempower(){
        $server = $this->model->GetServerNo($this->webdb['version_server'],['empower_no' => $this->webdb['version_no'],'empower_code' => $this->webdb['web_warrant'],'name' => $this->request->domain(true)]);
        if(empty($server['code']) || empty($server['data'])){
            ResJson([],$server['msg'],'0');
        }
        ResJson([],'有新版本');
    }
}