<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use app\common\hook\Upload;
use think\facade\{Cache,Event,View};
use app\common\model\Modular;
use app\common\model\ModularMod;

class Imtag extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        $this->CheckAuth(['read','create','edit','del'],'admin','Tag');
        $this->BaseModel('Tag');
    }
    public function index()
    {
        if(!empty($this->getdata['id'])){
            $res = $this->model->GetOne($this->getdata['id']);
        } else {
            $res = Cache::get("LABEL_{$this->getdata['name']}");
            $_res = $this->model->GetList(['TagName' => $res['TagName'], 'TagModular' => $res['TagModular'], 'TagMod' => $res['TagMod'], 'tempname' => $res['tempname']], false);
            if (empty($_res)) {
                $res['uid'] = $this->ImUser['uid'];
                $res['cid'] = $this->ImUser['cid'];
                $res = $this->model->EditAdd($res);
                $res = $this->model->SetOne($res);
            } else {
                $res = $_res['0'];
            }
        }
        //  查看是否需要重置
        if(!empty($this->getdata['init'])){
            $res['TagMod'] = $this->getdata['ename'] ?? $res['TagMod'];
            $res['TagModular'] = $this->getdata['emod'] ?? $res['TagModular'];
            unset($this->getdata['id'],$this->getdata['init'],$this->getdata['ename']);
            $res['template'] = '';
            $res['conf'] = array_merge($res['conf'],$this->getdata);
        }
        if(!empty($res['TagModular'])){
            if($res['TagModular'] == 'base'){
                if(in_array($res['TagMod'],['@text@','@pic@'])){
                    $read = $this->EditTextMod($res);
                    $read['TagType'] = '0';
                } else {
                    $read = $this->EditBaseMod($res);
                }
                $this->list_file = $read['homeread'];
            } else {
                $read = $this->EditModRes($res);
                if(empty($read)){
                    return $this->ResTagForm($res);
                }
            }
            $this->list_base['template'] = "tag:{$read['mod']['fid_name']}_{$read['mod']['name']}";
        }
        //  检测是否需要跳转
        switch ($res['TagModular']){
            case 'base':
                $url_mod = "\\app\\admin\\controller\\{$read['mod']['name_key']}";
                $url_base = "admin/{$read['mod']['name_key']}/tag";
                break;
            default:
                $url_mod = "\\app\\{$read['mod']['fid_name']}\\controller\\admin\\{$read['mod']['name_key']}";
                $url_base = "{$read['mod']['fid_name']}/admin.{$read['mod']['name_key']}/tag";
                break;
        }

        if(!empty(method_exists($url_mod,'tag'))){
            return redirect(url($url_base,['id' => $res['id']])->build());
        }
        if(!empty($res['conf'])){
            $res['conf'] = is_array($res['conf']) ? $res['conf'] : json_decode($res['conf'],true);
        } else {
            $res['conf'] = [];
        }
        View::assign(['model' => $read['mod']]);
        return $this->ResTagForm($res);
    }
    //  打包筛选条件
    protected function EditModRes($data){
        //  获取模型
        $_mod = Event::trigger('Mod',['type' => 'GetMod','data' => ['mod' => $data['TagMod'],'model' => $data['TagModular']]]);
        if($_mod['0']['code'] != '1'){
            return [];
        }
        $_mod = $_mod['0']['data'];
        //  获取字段
        $_homeread = Event::trigger('Mod',['type' => 'GetHomeRead','data' => ['mod' => $data['TagMod'],'model' => $data['TagModular']]]);
        if($_homeread['0']['code'] != '1'){
            return [];
        }
        $_homeread = $_homeread['0']['homeread'];
        return ['homeread' => $_homeread,'mod' => $_mod];
    }
    //  获取基础模型信息
    protected function EditBaseMod($data){
        //  获取模型信息
        $name = ToUnderScore($data['TagMod'],false);
        $_m = new \app\common\model\AuthRule();
        $mod = $_m->GetList(['name' => $name,'model' => '0'],false);
        if(empty($mod['0'])){
            return [];
        }
        $mod = $mod['0'];
        $mod['fid_name'] = $data['TagModular'];
        $mod['name'] = $data['TagMod'];
        $mod['name_key'] = $name;
        //  获取字段
        $_m = "app\\common\\model\\{$name}";
        $_m = new $_m;
        $homeread = $_m->GetFieldList();
        foreach ($homeread as &$v){
            $v = [
                'field' => $v['Field'],
                'title' => $v['Comment'],
                'default' => '',
                'unit' => '',
            ];
        }
        return ['homeread' => $homeread,'mod' => $mod];
    }
    //  打包文本及图片模型
    protected function EditTextMod($data){
        $name = str_replace('@', '', $data['TagMod']);
        $mod['fid_name'] = $data['TagModular'];
        $mod['name'] = $name;
        $mod['name_key'] = $name;

        $homeread = [];
        return ['homeread' => $homeread,'mod' => $mod];
    }
    //  保存前回调
    protected function SaveSelf($data,$old = ''){
        if(in_array($old['TagMod'],['@text@','@pic@'])){
            $img_data = [
                'oldimg' => empty($old['template']) ? null : $old['template'],
                'newimg' => $data['template'],
            ];
            $_m = new Upload();
            $data['template'] = $_m->SetEditOr($img_data);
        } else {
            $data['template'] = explode("&nbsp;",$data['template']);
            $data['template'] = DataTrim($data['template']);
            $data['template'] = implode('',$data['template']);
        }
        return $data;
    }
    //  标签导航
    public function getall(){
        $this->list_base['template'] = 'tag:tagmap';
        //  查询网站模块
        $_m = new Modular();
        $read = $_m->GetList(['GetFile' => 'title,id,name','order' => 'id asc'],false);
        //  查询模型
        $_m = new ModularMod();
        $fid = array_column($read,'id');
        $fid = $_m->GetList(['fid' => $fid,'GetFile' => 'id,fid,title,name,name_key','order' => 'id asc'],false);
        //  转换标签
        foreach ($read as $k => $v){
            $_v = DelFile($fid,'fid',$v['id']);
            if(empty($_v)){
                unset($read[$k]);
                continue;
            }
            foreach ($_v as $k1 => $v1){
                $url_mod = "\\app\\{$v['name']}\\controller\\admin\\{$v1['name_key']}";
                if(empty(method_exists($url_mod,'tag'))){
                    unset($_v[$k1]);
                    continue;
                }
                $v1['url'] = GetEruUrl("{$v['name']}/admin.{$v1['name_key']}/tag",['id' => $this->getdata['id'],'init' => $this->getdata['id']]);
                $_v[$k1] = $v1;
            }
            if(empty($_v)){
                unset($read[$k]);
                continue;
            }
            $v['mod_list'] = $_v;
            $read[$k] = $v;
        }
        return $this->ResAdminRead($read);
    }
}