<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use app\common\model\{Modular,ModularMod,User,LogUser};
use think\facade\{Cache,Event};

class Index extends AdminBase
{
    public function initialize()
    {
        parent::initialize();
        $this->list_base['template'] = $this->request->action();
    }

    public function menu(){
        $res = Event::trigger('Auth',['type' => 'UserAuth','data' => ['fid' => '1','model' => $this->space_name]]);
        return $this->ResAdminList($res['0']);
    }
    public function map(){
        $this->list_base['template'] = 'public:map';
        return $this->ResAdminRead();
    }
    public function delcache(){
        DelDir(root_path('runtime/sessions'));
        DelDir(root_path('runtime/views'));
        DelDir(root_path('runtime/cache'));
        Cache::clear();
        ResClient('删除缓存成功','1');
    }
    //  查询模型数据统计
    public function mod(){
        //  查询网站模块
        $_m = new Modular();
        $read = $_m->GetList(['GetFile' => 'title,id,name','order' => 'id asc'],false);
        //  查询模型
        $_m = new ModularMod();
        $fid = array_column($read,'id');
        $fid = $_m->GetList(['fid' => $fid,'GetFile' => 'id,fid,title,name,name_key','order' => 'id asc'],false);
        //  查询模型数据
        foreach ($read as $k => $v){
            $_v = DelFile($fid,'fid',$v['id']);
            if(empty($_v)){
                unset($read[$k]);
                continue;
            }
            foreach ($_v as &$v1){
                $_mod = "\\app\\{$v['name']}\\model\\{$v1['name_key']}";
                $_mod = new $_mod;
                $v1['cont_num'] = $_mod->CountList(['table_type' => 'count','count' => 'id']);
            }
            $v['mod_list'] = $_v;
            $read[$k] = $v;
        }
        return $this->ResAdminRead($read);
    }
    //  查询用户数据
    public function user(){
        //  查询用户总数量
        $_m = new User();
        $res['user_num'] = $_m->CountList(['table_type' => 'count','count' => 'uid']);
        $res['user_m_num'] = $_m->CountList(['table_type' => 'count','count' => 'uid','GetTimes' => 'addtime','addtime_m' => 'm']);
        $res['user_d_num'] = $_m->CountList(['table_type' => 'count','count' => 'uid','GetTimes' => 'addtime','addtime_d' => 'd']);
        //  查询今日登录用户
        $_m = new LogUser();
        $res['log_d_num'] = $_m->CountList(['table_type' => 'count','count' => 'uid','table_distinct' => 'uid','GetTimes' => 'addtime','addtime_d' => 'd']);
        return $this->ResAdminRead($res);
    }
    //  系统更新
    public function getupdate(){
        // 查询最新版本

    }

}