<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class Link extends AdminBase
{
    protected $PartModel;
    protected $PartDb;
    protected function initialize()
    {
        parent::initialize();
        if(empty($this->getdata['fid'])){
            ResClient('非法访问','0');
        }
        $this->BaseModel();
        $this->BaseModel('LinkPart','PartModel');
        $this->PartDb = $this->PartModel->GetOne($this->getdata['fid']);

        $this->list_base['page'] = false;
        $this->list_base['fold'] = !empty($this->PartDb['type']);
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/Link/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/Link/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'getlist':
                if($this->list_base['fold']){
                    $this->getdata['order'] = 'sort desc,id asc';
                }
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/Link/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加' : '编辑';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '添加', 'url' => GetEruUrl('admin/Link/create',$this->getdata),'open' => true],
            ];
        }

        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '名称','type' => 'text'],
            ['field' => 'url','title' => '链接地址','type' => $this->user_auth['edit'] ? 'edit' : 'text'],
            ['field' => 'target','title' => '打开方式','type' => 'radio','list' => ['当前窗口','新窗口'],'width' => '120','textalign' => 'center'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        //  判断是否需要增加下级链接
        if($this->list_base['fold'] && $this->user_auth['create']){
            array_push($this->list_file, [
                'field' => 'dons', 'title' => '子级', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-add', 'url' => GetEruUrl('admin/Link/create',['pid' => '__id__','fid' => '__fid__']),'open' => true
            ]);
        }
        if($this->user_auth['edit']) {
            //  这里要做判断
            array_push($this->list_file, [
                'field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/Link/edit',['id' => '__id__','fid' => '__fid__']),'open' => true
            ]);
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/Link/del',['id' => '__id__','fid' => '__fid__'])
            ]);
        }
        if(!$this->list_base['fold']){
            $this->list_search = [
                'input' => [
                    ['field' => 'key','title' => '关键词...'],
                ]
            ];
        }
    }

    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '标题','type' => 'text','required' => true],
            ['field' => 'url','title' => '链接地址','type' => 'text'],
            ['field' => 'icon_type','title' => '图标类型','type' => 'radio','list' => [['title' => 'ICON','value' => '0'],['title' => '图片','value' => '1']],'default' => '0','file_link' => [['icon'],['icon_img']],],
            ['field' => 'icon','title' => '菜单图标','type' => 'icon'],
            ['field' => 'icon_img','title' => '菜单图标','type' => 'image'],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'target','title' => '打开方式','type' => 'radio','list' => [['title' => '新窗口','value' => '1'],['title' => '当前窗口','value' => '0']],'default' => '1','required' => true],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
            ['field' => 'fid','title' => '分类','type' => 'hidden','default' => isset($this->getdata['fid']) ? $this->getdata['fid'] : ''],
        ];
        if(!empty($this->PartDb['type'])){
            $_partlist = $this->model->GetList(['status' => '1','fid' => $this->PartDb['id']],false);
            $_pid = ['id' => '','on' => false];
            if(!empty($this->getdata['id']) || !empty($this->getdata['pid'])){
                $_pid['id'] = $this->getdata['id'] ?? $this->getdata['pid'];
                $_pid['on'] = !empty($this->getdata['id']);
            }
            $_partlist = FormatPart($_partlist,$_pid,['title' => 'title_display']);
            $_partlist = array_merge([['title' => '顶级链接','value' => '0']],$_partlist);
            $this->list_file = array_merge([
                [
                    'field' => 'pid',
                    'title' => '上级链接',
                    'type' => 'select',
                    'required' => true,
                    'list' => $_partlist,
                    'default' => empty($this->getdata['pid']) ? '0' : $this->getdata['pid'],
                ]
            ],$this->list_file);
        }
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }

    protected function EditSelf($data){
        if(!empty($data['icon_type'])){
            $data['icon_img'] = $data['icon'];
            unset($data['icon']);
        }
        return $data;
    }
    protected function SaveSelf($data,$old = []){
        if(!empty($data['icon_type'])){
            foreach ($this->list_file as &$v){
                if($v['field'] == 'icon'){
                    $v['type'] = 'image';
                }
            }
            $data['icon'] = $data['icon_img'];
            unset($data['icon_img']);
        }
        return $data;
    }
}