<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class LinkPart extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/LinkPart/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/LinkPart/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/LinkPart/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加分类' : '编辑分类';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '添加分类', 'url' => GetEruUrl('admin/LinkPart/create',$this->getdata), 'open' => true],
            ];
        }
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '分类名称','type' => 'edit','width' => '30%'],
            ['field' => 'type','title' => '二级链接','type' => 'radio','list' => ['禁用','启用'],'textalign' => 'center','width' => '100'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        if($this->user_auth['edit']) {
            //  这里要做判断
            array_push($this->list_file, [
                'field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/LinkPart/edit',['id' => '__id__']), 'fixed' => 'right', 'open' => true
            ]);
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/LinkPart/del',['id' => '__id__']), 'fixed' => 'right'
            ]);
        }
    }

    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '分类名称','type' => 'text','required' => true],
            ['field' => 'type','title' => '二级链接','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '0','required' => true],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'class','title' => '类型','type' => 'hidden','default' => isset($this->getdata['class']) ? $this->getdata['class'] : ''],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
}