<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use think\facade\Cache;

class LogUser extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('admin/LogUser/getlist',$this->getdata);
                $this->ListTable();
                break;
        }
    }
    //  查询用户权限
    protected function ListTable(){
        $this->list_file = [
            ['type' => 'checkbox','width' => '80','textalign' => 'center', 'fixed' => 'left'],
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center', 'fixed' => 'left'],
            ['field' => 'u_name','title' => '用户名','width' => '150'],
            ['field' => 'u_niname','title' => '用户昵称','width' => '150'],
            ['field' => 'title','title' => '标题','width' => '200'],
            ['field' => 'cont','title' => '详情','width' => '300'],
            ['field' => 'type','title' => '模块','width' => '120','type' => 'radio','list' =>[
                ['title' => '系统后台','value' => 'admin'],
                ['title' => '前台登录','value' => 'home'],
                ['title' => 'API登录','value' => 'api'],
                ['title' => '会员中心','value' => 'memeber'],
            ],'textalign' => 'center'],
            ['field' => 'addtime','title' => '登录时间','width' => '180','textalign' => 'center'],
            ['field' => 'addip','title' => '登录IP','width' => '160'],
            ['field' => 'ropt','title' => '端口号','width' => '120','textalign' => 'center'],
        ];
        if($this->user_auth['del']) {
            array_push($this->list_file,
                ['field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','event' => 'del','class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/LogUser/del',['id' => '__id__']), 'fixed' => 'right']
            );
            $this->list_base['button'] = [
                ['title' => '批量删除', 'url' => GetEruUrl('admin/LogUser/del',['_d' => 'p','id' => '0']),'event' => 'del','tip' => '删除后不可恢复，是否确认删除？','class' => 'ery-bg-red ery-button']
            ];
        }
        $this->list_search = [
            'select' => [
                ['field' => 'type','title' => '系统模块','list' =>[
                    ['title' => '系统后台','value' => 'admin'],
                    ['title' => '前台登录','value' => 'home'],
                    ['title' => 'API登录','value' => 'api'],
                    ['title' => '会员中心','value' => 'memeber'],
                ]],
            ],
            'input' => [
                ['field' => 'user_key','title' => '用户名或手机'],
            ],
            'date' => [
                ['field' => 'addtime_add','title' => '开始时间'],
                ['field' => 'addtime_end','title' => '结束时间'],
            ],
        ];
    }
    protected function GetListDbSelf($data){
        if(!empty($data['user_key'])){
            $_m = new \app\common\model\User();
            $user = $_m->GetList(['key' => $data['user_key'],'GetFile' => 'uid'],false);
            $user = array_column($user,'uid');
            $data['uid'] = $user ?? 'a';
            unset($data['user_key']);
        }
        return $data;
    }

    public function getday(){
        //  获取当天时间
        $_time = time();
        $day = date('Ymd',$_time);
        $res = [];
        // 获取之前30天时间
        for ($i = 0;$i <= 29; $i++){
            $_day = date('Ymd',$_time - ((29 - $i) * 86400));
            if($_day != $day && Cache::has("Log_user_{$_day}")){
                $_v = Cache::get("Log_user_{$_day}");
                array_push($res,$_v);
                continue;
            }
            $_v = date('Y-m-d',$_time - ((29 - $i) * 86400));
            $_v = [
                'time' => $_v,
                'log_num' =>  $this->model->CountList(['GetTimes' => 'addtime','addtime_d' => $_v,'table_type' => 'count','count' => 'id']),
                'user_log_num' =>  $this->model->CountList(['GetTimes' => 'addtime','addtime_d' => $_v,'table_type' => 'count','table_group' => 'uid','count' => 'uid']),
            ];
            if($_day != $day){
                Cache::set("Log_user_{$_day}",$_v,86400 * 30);
            }
            array_push($res,$_v);
        }
        return $this->ResAdminRead($res);
    }
}