<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class MenuPart extends AdminBase
{
    protected $UGPModel;
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        $this->BaseModel('UserGroupPart','UGPModel');
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/MenuPart/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/MenuPart/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/MenuPart/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加菜单分类' : '编辑菜单分类';
                $this->FormFile();
                break;
        }
    }


    protected function ListTable(){
        $_grouplist = SelectEdit($this->UGPModel->GetList([],false),['title' => 'title','value' => 'id']);
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '分类名称','type' => $this->user_auth['edit'] ? 'edit' : 'text','width' => '30%'],
            ['field' => 'fid','title' => '分配角色','type' => 'checkbox','width' => '260','list' => $_grouplist],
            ['field' => 'model','title' => '所属模块','width' => '120','textalign' => 'center','type' => 'radio','list' => [
                'admin' => '后台模块','home' => '前台模块','member' => '用户中心','api' => 'API模块'
            ]],
            ['field' => 'menu_num','title' => '菜单数量','width' => '120','textalign' => 'center'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        if($this->user_auth['edit']) {
            array_push($this->list_file, ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','open' => true, 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/MenuPart/edit',['id' => '__id__']), 'fixed' => 'right']);
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, ['field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/MenuPart/del',['id' => '__id__']), 'fixed' => 'right']);
        }
        if($this->user_auth['create']){
            $this->list_base['button'] = [['title' => '添加分类','open' => true, 'url' => GetEruUrl('admin/MenuPart/create')]];
        }
        $this->list_search = [
           'input' => [
               ['field' => 'key','title' => '关键词']
           ]
        ];
    }
    protected function FormFile(){
        $_grouplist = SelectEdit($this->UGPModel->GetList([],false),['title' => 'title','value' => 'id']);
        $this->list_file = [
            ['field' => 'title','title' => '分类名称','type' => 'text','required' => true],
            ['field' => 'fid','title' => '分配角色','type' => 'checkbox','list' => $_grouplist,'required' => true],
            ['field' => 'model','title' => '所属模块','type' => 'select','required' => true,'list' =>  [['title' => '后台模块','value' => 'admin'],['title' => '前台模块','value' => 'home'],['title' => '会员中心模块','value' => 'member'],['title' => 'API接口模块','value' => 'api']],'text' => true],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
}