<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class Modular extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        $this->BaseValidate();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/Modular/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/Modular/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/Modular/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加模块' : '编辑模块';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '添加模块', 'url' => GetEruUrl('admin/Modular/create'),'open' => true],
            ];
        }
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center','fixed' => 'left'],
            ['field' => 'title','title' => '模块名称','width' => '40%'],
            ['field' => 'name','title' => '模块地址','width' => '20%'],
            ['field' => 'mod_num','title' => '模型数量','width' => '150','textalign' => 'center'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1'],
        ];
        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['field' => 'edit_cont', 'title' => '模型', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-caozuoxitong', 'url' => GetEruUrl('admin/ModularMod/index', ['fid' => '__id__']),'fixed' => 'right'],
                ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/Modular/edit', ['id' => '__id__']),'open' => true,'fixed' => 'right']
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '卸载', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-tuichu', 'url' => GetEruUrl('admin/Modular/del', ['id' => '__id__']),'tip' => '卸载后不可恢复，是否确认卸载？','fixed' => 'right']);
        }
    }
    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '模块名称','type' => 'text','required' => true],
            ['field' => 'name','title' => '模块URL','type' => 'text','tip' => '只能为小写字母，如: cms','required' => $this->request->action() != 'edit','disabled' => $this->request->action() == 'edit'],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true]
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
}