<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class ModularField extends AdminBase
{
    protected $ModModel;
    protected function initialize()
    {
        parent::initialize();
        $this->CheckAuth(['edit'],'admin','ModularMod');
        if(!$this->user_auth['edit']){
            ResClient('没有此权限','0');
        }
        $this->user_auth = ['create' => $this->user_auth['edit'],'edit' => $this->user_auth['edit'],'del' => $this->user_auth['edit']];
        $this->BaseModel();
        $this->BaseModel('ModularMod','ModModel');
        $this->BaseValidate();
        switch ($this->request->action()){
            case 'index':
                if(empty($this->getdata['fid'])){
                    ResClient('请选择模模型','0');
                }
                $this->list_base['fast_url'] = GetEruUrl('admin/ModularField/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/ModularField/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                if($this->request->action() == 'create'){
                    if(!$this->ModModel->CheckFile($this->getdata['fid'])){
                        ResClient('请先生成模型文件','0');
                    }
                }
                $this->list_base['url'] = GetEruUrl('admin/ModularField/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加字段' : '编辑字段';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '返回模型', 'url' => GetEruUrl('admin/ModularMod/index',['fid' => $this->getdata['mid']]),'class' => 'ery-button ery-mag-r10'],
                ['title' => '添加字段', 'url' => GetEruUrl('admin/ModularField/create',$this->getdata),'open' => true],
                ['title' => '生成文件', 'url' => GetEruUrl('admin/ModularMod/addfile',['id' => $this->getdata['fid']]), 'event' => 'addfile', 'check' => 'false', 'tip' => '生成文件会清除原有文件，请问是否生成','class' => 'ery-button ery-bg-yellow ery-mag-l10'],
            ];
        }
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'group','title' => '字段分组','width' => '120','type' => 'edit'],
            ['field' => 'title','title' => '字段名称','width' => '30%'],
            ['field' => 'field','title' => '变量','width' => '120'],
            ['field' => 'type','title' => '类型','width' => '120','type' => 'radio','list' => [
                'text' => '单行文本框',
                'textarea' => '多行文本框',
                'radio' => '单选框',
                'checkbox' => '多选框',
                'select' => '下拉菜单',
                'editor' => '富文本编辑器',
                'money' => '金额',
                'number' => '数字',
                'datetime' => '日期 + 时间',
                'date' => '日期',
                'time' => '时间',
                'image' => '单图片',
                'images' => '多图片',
                ['title' => '单视频','value' => 'video'],
                ['title' => '多视频','value' => 'videos'],
                'file' => '单文件',
                'files' => '多文件',
                'zip' => '单压缩包',
                'zips' => '多压缩包',
                'hidden' => '隐藏域',
                'icon' => '字体图标',
                'getmodel' => '模块调用',
                'rank' => '层级选择器',
                'chinafucode' => '行政区域选择',
            ]],
            ['field' => 'list_show','title' => '列表显示','width' => '120','type' => 'radio','list' => [
                '0' => '隐藏',
                '1' => '显示',
            ],'textalign' => 'center'],
            ['field' => 'search_show','title' => '搜索','width' => '120','type' => 'radio','list' => [
                '0' => '禁用',
                '1' => '启用',
            ],'textalign' => 'center'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1'],
            ['field' => 'addtime','title' => '添加时间','width' => '180','textalign' => 'center'],
        ];
        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/ModularField/edit', ['id' => '__id__','fid' => '__fid__','mid' => $this->getdata['mid']]),'fixed' => 'right','open' => true]
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '卸载', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/ModularField/del', ['id' => '__id__']),'fixed' => 'right']);
        }
    }
    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '字段标题','type' => 'text','required' => true],
            ['field' => 'field','title' => '字段键值','type' => 'text','required' => true,'tip' => '只能是字母或字母加数字,并且禁止修改','disabled' => $this->request->action() == 'edit' ? true : false,'boxwidth' => 'ery-xs6'],
            ['field' => 'sqlvalue','title' => '字段类型','type' => 'select','disabled' => $this->request->action() == 'edit' ? true : false,'list' => [
                ['title' => '255个字符串以内','value' => 'varchar'],
                ['title' => '10位以内纯数字','value' => "int"],
                ['title' => '20位以内纯数字','value' => "bigint"],
                ['title' => '2位以内纯数字','value' => "tinyint"],
                ['title' => '价格','value' => "decimal"],
                ['title' => '常用文本文档','value' => "text"],
                ['title' => '大型文本文档','value' => "mediumtext"],
                ['title' => '日期','value' => "date"],
                ['title' => '时间','value' => "time"],
                ['title' => '日期时间','value' => "datetime"],
            ],'tip' => '选择后禁止修改，容易出错','required' => true,'boxwidth' => 'ery-xs6'],
            ['field' => 'type','title' => '表单类型','type' => 'select','text' => true,'required' => true,'list' => [
                ['title' => '单行文本框','value' => 'text'],
                ['title' => '多行文本框','value' => 'textarea'],
                ['title' => '单选框','value' => 'radio'],
                ['title' => '多选框','value' => 'checkbox'],
                ['title' => '下拉菜单','value' => 'select'],
                ['title' => '富文本编辑器','value' => 'editor'],
                ['title' => '金额','value' => 'money'],
                ['title' => '数字','value' => 'number'],
                ['title' => '日期 + 时间','value' => 'datetime'],
                ['title' => '日期','value' => 'date'],
                ['title' => '时间','value' => 'time'],
                ['title' => '单图片','value' => 'image'],
                ['title' => '多图片','value' => 'images'],
                ['title' => '单视频','value' => 'video'],
                ['title' => '多视频','value' => 'videos'],
                ['title' => '单文件','value' => 'file'],
                ['title' => '多文件','value' => 'files'],
                ['title' => '单压缩包','value' => 'zip'],
                ['title' => '多压缩包','value' => 'zips'],
                ['title' => '隐藏域','value' => 'hidden'],
                ['title' => '字体图标','value' => 'icon'],
                ['title' => '模块调用','value' => 'getmodel'],
                ['title' => '层级选择器','value' => 'rank'],
                ['title' => '行政区域选择器','value' => 'chinafucode'],
            ],'file_link' => ['radio' => ['list'],'checkbox' => ['list'],'select' => ['list'],'rank' => ['fileddata'],'getmodel' => ['geturl','fileddata','gettype']]],
            ['field' => 'required','title' => '是否必填','type' => 'radio','list' => [
                ['title' => '必填项','value' => '1'],
                ['title' => '非必填项','value' => '0'],
            ],'default' => '0','required' => true,'file_link' => ['1' => ['required_list']]],
            ['field' => 'required_list','title' => '验证规则','type' => 'select','text' => true,'list' => [
                ['title' => '手机验证','value' => 'phone'],
                ['title' => '邮箱验证','value' => 'email'],
                ['title' => '网址验证','value' => 'url'],
                ['title' => '数字验证','value' => 'number'],
                ['title' => '日期验证','value' => 'date'],
                ['title' => '身份证验证','value' => 'identity'],
            ]],
            ['field' => 'default','title' => '默认值','type' => 'text'],
            ['field' => 'group','title' => '字段分组','type' => 'text'],

            ['field' => 'geturl','title' => '请求地址','type' => 'text','tip' => '数据请求地址，可使用站外地址'],
            ['field' => 'fielddata','title' => '自订义变量','type' => 'text','tip' => '请根据返回值填写，title和value必不可少'],
            ['field' => 'gettype','title' => '调用类型','type' => 'radio','list' => [['title' => '单选','value' => '0'],['title' => '多选','value' => '1'],['title' => '下拉菜单','value' => '2']],'default' => '0'],

            ['field' => 'list','title' => '可选值','type' => 'textarea','tip' => '每行一个可选值'],
            ['field' => 'unit','title' => '单位','type' => 'text'],
            ['field' => 'tip','title' => '提示信息','type' => 'text'],

            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'list_show','title' => '列表显示','type' => 'radio','list' => [['title' => '显示','value' => '1'],['title' => '隐藏','value' => '0']],'default' => '1','required' => true],
            ['field' => 'search_show','title' => '搜索','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '0','required' => true],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
            ['field' => 'fid','title' => '模型ID','type' => 'hidden','default' => isset($this->getdata['fid']) ? $this->getdata['fid'] : ''],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
}