<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class Money extends AdminBase
{
    protected $PartModel;
    protected $PartList;
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel();
        $this->BaseModel('MoneyPart','PartModel');
        $this->BaseValidate();
        $this->PartList = $this->PartModel->GetList(['GetFile' => 'id,title'],false);
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/Money/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/Money/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/Money/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加积分' : '编辑积分分类';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'oid','title' => '订单号','width' => '150'],
            ['field' => 'u_name','title' => '用户名','width' => '120'],
            ['field' => 'u_niname','title' => '昵称','width' => '120'],
            ['field' => 'u_phone','title' => '手机号','width' => '150','textalign' => 'center'],
            ['field' => 'pu_name','title' => '发放用户','width' => '150'],
            ['field' => 'money_type_name','title' => '单位','width' => '120'],
            ['field' => 'money','title' => '数量','width' => '120','textalign' => 'right'],
            ['field' => 'user_money','title' => '余额','width' => '120','textalign' => 'right'],
            ['field' => 'cont','title' => '备注','width' => '200'],
            ['field' => 'addtime','title' => '时间','width' => '180','textalign' => 'center'],
            ['field' => 'addip','title' => 'IP','width' => '150'],
        ];

        if($this->user_auth['create']){
            $this->list_base['button'] = [['title' => '用户充值/扣减','open' => true, 'url' => GetEruUrl('admin/Money/create',$this->getdata)]];
        }
        if($this->user_auth['read']) {
            array_push($this->list_file, [
                'field' => 'read', 'title' => '查看', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','open' => true, 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/Money/read',['id' => '__id__']), 'fixed' => 'right'
            ]);
        }

        $this->list_search = [];
        if(!isset($this->getdata['money_type'])){
            $partlist = array_merge([['id' => '0','title' => '元']],$this->PartList);
            $partlist = SelectEdit($partlist,['title' => 'title','value' => 'id']);
            $this->list_search['select'] = [
                ['field' => 'money_type','title' => '类型','list' => $partlist],
            ];
        }
        $this->list_search['input'] = [
            ['field' => 'user_key','title' => '用户名或手机'],
            ['field' => 'oid','title' => '订单号'],
        ];
        $this->list_search['date'] = [
            ['field' => 'addtime_add','title' => '开始时间'],
            ['field' => 'addtime_end','title' => '结束时间'],
        ];
    }
    protected function FormFile(){
        $partlist = array_merge([['id' => '0','title' => '元']],$this->PartList);
        $partlist = SelectEdit($partlist,['title' => 'title','value' => 'id']);

        $part = !isset($this->getdata['money_type']) ? [] : DelFile($partlist,'value',$this->getdata['money_type']);
        $part = $part['0'] ?? ['id' => '0','title' => '元'];
        $this->list_file = [
            ['field' => 'uid','title' => '用户名','type' => 'getmodel','gettype' => '0','geturl' => GetEruUrl('admin/User/getlist'),'fielddata' => 'title=u_name,value=uid','required' => true],
            ['field' => 'add_type','title' => '充值','type' => 'radio','list' => [['title' => '充值','value' => '13001001'],['title' => '扣除','value' => '22002']],'default' => '13001001','required' => true],
            ['field' => 'money','title' => '金额','type' => 'text','default' => '0','unit' => $part['title'] ?? '','tip' => "请输入{$part['title']}",'required' => true],
            ['field' => 'cont','title' => '备注','type' => 'textarea'],
        ];
        $partselect = ['field' => 'money_type','title' => '类型','type' => 'select','default' => $this->getdata['money_type'] ?? '0','list' => $partlist,'required' => true,'disabled' => '1'];
        if(!isset($this->getdata['money_type'])){
            unset($partselect['disabled']);
        }
        $this->list_file = ArraySpliceArray($this->list_file,'2',$partselect);
    }

    protected function SaveSelf($data,$old = [])
    {
        if($data['money'] < '0.01'){
            ResJson('','数值不得小于0.01','0');
        }
        if(empty($data['id']) && $data['add_type'] == '22002'){
            $old = $this->model->GetList(['money_type' => $data['money_type'],'uid' => $data['uid'],'page' => '1','limit' => '1']);
            $old = $old['data']['0']['user_money'] ?? '0';
            if($old < $data['money']){
                ResJson('','用户余额不足','0');
            }
        }
        $res = $this->model->NewAdd($data);
        if(!$res){
            ResJson('','处理失败','0');
        }
        ResJson($res,'处理成功');
    }
    protected function GetListDbSelf($data){
        if(!empty($data['user_key'])){
            $_m = new \app\common\model\User();
            $user = $_m->GetList(['key' => $data['user_key'],'GetFile' => 'uid'],false);
            $user = array_column($user,'uid');
            $data['uid'] = $user ?? 'a';
            unset($data['user_key']);
        }
        return $data;
    }
}