<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class MoneyPart extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/MoneyPart/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/MoneyPart/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/MoneyPart/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加积分分类' : '编辑积分分类';
                $this->FormFile();
                break;
        }
    }
    protected function ListTable(){
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '积分名称','width' => '30%'],
            ['field' => 'rmb_to','title' => '人民币兑换比例','width' => '300','textalign' => 'center'],
            ['field' => 'to_rmb','title' => '兑换人民币比例','width' => '300','textalign' => 'center'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        if($this->user_auth['create']){
            $this->list_base['button'] = [['title' => '添加分类','open' => true, 'url' => GetEruUrl('admin/MoneyPart/create')]];
        }
        if($this->user_auth['edit']) {
            array_push($this->list_file, [
                'field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','open' => true, 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/MoneyPart/edit',['id' => '__id__']), 'fixed' => 'right'
            ]);
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/MoneyPart/del',['id' => '__id__']), 'fixed' => 'right'
            ]);
        }
    }
    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '积分名称','type' => 'text','required' => true],
            ['field' => 'to_rmb','title' => '兑换人民币','type' => 'number','default' => '0','tip' => '请输入多少积分兑换1元人民币','required' => true],
            ['field' => 'rmb_to','title' => '人民币兑换','type' => 'number','default' => '0','tip' => '请输入1元人民币兑换多少积分','required' => true],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
}