<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use think\facade\Cache;

class SqlManage extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('admin/SqlManage/getlist',$this->getdata);
                $this->ListTable();
                break;
        }
    }

    protected function ListTable(){
        if($this->user_auth['edit']) {
            $this->list_base['button'] = [
                ['title' => '优化数据表', 'url' => GetEruUrl('admin/SqlManage/ropsql',['fun' => 'rep']),'open' => true,'reload' => 'no',],
                ['title' => '备份数据库', 'class' => 'ery-mag-l10 ery-button ery-bg-green', 'url' => GetEruUrl('admin/SqlManage/backup'),'open' => 'true','reload' => 'no',],
                ['title' => '还原数据库', 'class' => 'ery-mag-l10 ery-button ery-bg-green', 'url' => GetEruUrl('admin/SqlManage/revert'),'open' => 'true','reload' => 'no',],
            ];
        }
        if($this->user_auth['del']) {
            array_push($this->list_base['button'],
                ['title' => '删除备份', 'class' => 'ery-mag-l10 ery-button ery-bg-red', 'url' => GetEruUrl('admin/SqlManage/revert',['fun' => 'del']),'open' => 'true','reload' => 'no',]
            );
        }
        $this->list_file = [
            ['field' => 'title','title' => '数据表','width' => '30%'],
            ['field' => 'table_name','title' => '数据表名','width' => '30%'],
            ['field' => 'limit','title' => '行数','width' => '150','textalign' => 'center'],
            ['field' => 'data_size','title' => '大小','width' => '150','textalign' => 'center'],
            ['field' => 'type','title' => '引擎','width' => '150','textalign' => 'center'],
            ['field' => 'collation','title' => '字符集','width' => '150','textalign' => 'center'],
        ];
        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['field' => 'rep', 'title' => '优化', 'width' => '80', 'type' => 'btn','textalign' => 'center','reload' => '0', 'open' => true,'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-sitting', 'url' => GetEruUrl('admin/SqlManage/ropsql',['table_name' => '__table_name__','fun' => 'rep']), 'fixed' => 'right']
            );
        }
    }
    //  还原数据库
    public function revert(){
        $this->list_base['url'] =  empty($this->getdata['fun']) ? GetEruUrl('admin/SqlManage/revertlist',$this->getdata) : GetEruUrl('admin/SqlManage/delback',$this->getdata);
        $this->list_base['template'] = 'public:add_excel';
        $this->list_base['title'] = empty($this->getdata['fun']) ? '还原数据库' : '删除备份文件';

        $res = [];
        if(file_exists(public_path('backup/sql'))) {
            $res = GetDirlist(public_path('backup/sql'));
            if(count($res) > '0'){
                foreach ($res as $k => $v){
                    $res[$k] = ['title' => $v,'value' => $v];
                }
            }
        }
        $this->list_file = [
            ['field' => 'dirname','title' => '备份文件','type' => 'select','text' => true,'list' => $res],
        ];
        return $this->ResAdminForm();
    }
    public function revertlist(){
        $this->getdata['page'] = empty($this->getdata['page']) ? '0' : $this->getdata['page'];
        if(!file_exists(public_path('backup/sql/') . $this->getdata['dirname'] . '/' . $this->getdata['page'] . '.sql')) {
            ResJson([],"数据库还原完成");
        }
        $res = GetReadFile(public_path('backup/sql/') . $this->getdata['dirname'] . '/' . $this->getdata['page'] . '.sql');
        $res = explode("\n",$res);
        $res = DataTrim($res);
        $res = DelNull($res);

        foreach ($res as $k => $v){
            $_v = substr($v,0,4);
            if(strpos($_v,"#") !== false || strpos($_v,"--") !== false){
                unset($res[$k]);
            }
        }

        $res = implode("\n",$res);
        $res = str_replace("\r",'',$res);
        $res = explode(";\n",$res);
        foreach ($res as $k => $v){
            $_v = $this->model->RevertSql($v);
            if(!$_v){
                ResJson([],"数据库还原失败，请重试",'0');
            }
        }
        ResJson(['page' => $this->getdata['page'] + 1,'dirname' => $this->getdata['dirname']],"正在还原数据库，当前第 {$this->getdata['page']} 卷...",'2');
    }
    //  备份数据库
    public function backup(){
        $this->list_base['url'] = GetEruUrl('admin/SqlManage/backuplist',$this->getdata);
        $this->list_base['template'] = 'public:add_excel';
        $this->list_base['title'] = '备份数据库';
        return $this->ResAdminForm();
    }
    public function delback(){
        $this->getdata['page'] = empty($this->getdata['page']) ? '0' : $this->getdata['page'];
        if(!file_exists(public_path('backup/sql/') . $this->getdata['dirname'])) {
            ResJson([],"数据库备份文件已删除");
        }
        DelDir(public_path('backup/sql/') . $this->getdata['dirname']);
        ResJson([],"删除备份文件成功");
    }
    //  备份数据库
    public function backuplist(){
        if(!empty($this->getdata['fun'])){
            //  保存已备份的表结构
            if(Cache::has('backuplist')){
                $_tablelist = Cache::get('backuplist');
            }

            if(count($_tablelist['table']) < '1'){
                Cache::delete('backuplist');
                Cache::delete('backupsql');
                ResJson([],'备份数据库成功');
            }

            $limit = empty($_tablelist['set_limit']) ? '500' :  $_tablelist['set_limit'];
            $page = empty($_tablelist['set_page']) ? '1' :  $_tablelist['set_page'];
            $_tablename = $_tablelist['table']['0'];
            $_sql = $this->model->GetDataList($_tablename,$limit,$page);

            if($_sql['total'] < '1'){
                unset($_tablelist['table']['0']);
                sort($_tablelist['table']);
                $_tablelist['set_limit'] = '500';
                $_tablelist['set_page'] = '1';
                Cache::set('backuplist',$_tablelist,3600);
                ResJson(['fun' => 'database'],"备份 {$_tablename} 表数据成功...",'2');
            }

            foreach ($_sql['data'] as $v){
                $_v = $this->model->SetFile($v);
                //  如果写入失败，则清除所有缓存
                if(empty($_v['code'])){
                    Cache::delete('backuplist');
                    Cache::delete('backupsql');
                    DelDir($_tablelist['dir']);
                    ResJson([],$_v['msg'],'0');
                }
            }

            if($_sql['current_page'] >= $_sql['last_page']){
                unset($_tablelist['table']['0']);
                sort($_tablelist['table']);
                $_tablelist['set_limit'] = '500';
                $_tablelist['set_page'] = '1';
                Cache::set('backuplist',$_tablelist,3600);
                ResJson(['fun' => 'database'],"备份 {$_tablename} 表数据成功...",'2');
            }
            $_tablelist['set_limit'] = '500';
            $_tablelist['set_page'] = $_sql['current_page'] + 1;
            Cache::set('backuplist',$_tablelist,3600);
            ResJson(['fun' => 'database'],"正在备份 {$_tablename} 表，请等待...",'2');
        }

        if(Cache::has('backupsql')){
            $res = Cache::get('backupsql');
        } else {
            $_tablename = $this->model->GetList($this->getdata,false);
            $res = array_column($_tablename,'table_name');
        }

        if(count($res) < '1'){
            ResJson([],"暂无数据");
        }

        $_tablename = $res['0'];
        $_sql = $this->model->Backup($_tablename);
        //  写入文件
        $_res = $this->model->SetFile($_sql);
        //  如果写入失败，则清除所有缓存
        if(empty($_res['code'])){
            Cache::delete('backuplist');
            Cache::delete('backupsql');
            DelDir($_tablelist['dir']);
            ResJson([],$_res['msg'],'0');
        }
        //  保存已备份的表结构
        if(Cache::has('backuplist')){
            $_tablelist = Cache::get('backuplist');
        }
        $_tablelist['table'] = empty($_tablelist['table']) ? [] : $_tablelist['table'];
        array_push($_tablelist['table'],$_tablename);
        Cache::set('backuplist',$_tablelist,3600);
        //  删除已备份的表结构
        unset($res['0']);
        sort($res);

        if(count($res) < '1'){
            Cache::delete('backupsql');
            ResJson(['fun' => 'database'],"备份表结构成功，开始备份数据...",'2');
        }
        Cache::set('backupsql',$res,3600);
        $res = count($res);
        ResJson([],"备份 {$_tablename} 表结构成功，剩余 {$res} ...",'2');
    }
    //  优化数据库
    public function ropsql(){
        $this->list_base['url'] = GetEruUrl('admin/SqlManage/uprop',$this->getdata);
        $this->list_base['template'] = 'public:add_excel';
        $this->list_base['title'] = '优化数据表';
        return $this->ResAdminForm();
    }
    public function uprop(){
        if(Cache::has('ropsql')){
            $res = Cache::get('ropsql');
        } else {
            $_tablename = $this->model->GetList($this->getdata,false);
            $res = array_column($_tablename,'table_name');
        }
        if(count($res) < '1'){
            ResJson([],'优化完成',"1");
        }
        $this->model->Repair($res['0']);
        unset($res['0']);
        sort($res);

        if(count($res) < '1'){
            Cache::delete('ropsql');
            ResJson([],'优化完成',"1");
        }
        Cache::set('ropsql',$res,3600);
        $res = count($res);
        ResJson($this->getdata,"优化成功，剩余 {$res} 条...",'2');
    }
}