<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class Tag extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/Tag/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/Tag/getlist',$this->getdata);
                $this->ListTable();
                break;
        }
    }
    protected function ListTable(){
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center','fixed' => 'left',],
            ['field' => 'title','title' => '标签名称','type' => 'text'],
            ['field' => 'TagName','title' => '标签','type' => 'text'],
            ['field' => 'TagModular','title' => '调用模块','type' => 'text'],
            ['field' => 'TagMod','title' => '调用模型','type' => 'text'],
            ['field' => 'TagType','title' => '调用类型','type' => 'radio','list' => ['单条内容','列表']],
            ['field' => 'TagPub','title' => '是否公用','type' => 'radio','list' => ['公用','私有']],
            ['field' => 'tempname','title' => '模板','type' => 'text'],
            ['field' => 'contr','title' => '所属位置','type' => 'text'],
            ['field' => 'action','title' => '所属方法','type' => 'text'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        if($this->user_auth['edit']) {
            //  这里要做判断
            array_push($this->list_file, [
                'field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/Imtag/index',['id' => '__id__']),'fixed' => 'right','open' => true
            ]);
        }
        $this->list_search = [
            'input' => [
                ['field' => 'key','title' => '关键词...'],
            ]
        ];
    }
}