<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class User extends AdminBase
{
    protected $GroupModel;
    protected $GroupList;
    protected function initialize()
    {
        parent::initialize();
        //  需要去除首页判断
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        $this->BaseModel('UserGroup','GroupModel');
        $this->BaseValidate();
        $this->GroupList = $this->GroupModel->GetList([],false);
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('admin/User/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->validate_scene = ['add' => 'adminadd','edit' => 'adminedit'];
                $this->list_base['url'] = GetEruUrl('admin/User/save',$this->getdata);
                $this->FormFile();
                break;
        }
    }

    protected function ListTable(){
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '添加用户', 'open' => true, 'url' => GetEruUrl('admin/User/create')],
            ];
        }
        $this->list_file = [
            ['field' => 'uid','title' => 'ID','width' => '80','textalign' => 'center','fixed' => 'left'],
            ['field' => 'u_icon','title' => '头像','width' => '50','type' => 'image'],
            ['field' => 'group_name','title' => '用户角色','width' => '150'],
            ['field' => 'u_name','title' => '用户名','width' => '150'],
            ['field' => 'u_niname','title' => '用户昵称','width' => '150'],
            ['field' => 'u_phone','title' => '手机号','width' => '150','textalign' => 'center'],
            ['field' => 'u_sex','title' => '性别','width' => '150','textalign' => 'center','type' => 'radio','list' => ['未知','男','女']],
            ['field' => 'addtime','title' => '注册时间','width' => '180','textalign' => 'center'],
            ['field' => 'log_last_time','title' => '最后登录时间','width' => '180','textalign' => 'center'],
            ['field' => 'log_last_ip','title' => '最后登录IP','width' => '180','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'radio','list' => ['待审核','正常','禁用'],'textalign' => 'center','width' => '100'],
        ];
        if($this->user_auth['read']) {
            array_push($this->list_file,[
                'field' => 'read', 'title' => '查看','opentitle' => '查看用户信息', 'open' => true, 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-shenfenzhengzhengmian', 'url' => GetEruUrl('admin/User/read',['id' => '__uid__']), 'fixed' => 'right'
            ]);
        }
        if($this->user_auth['edit']) {
            array_push($this->list_file,[
                'field' => 'edit', 'title' => '编辑','opentitle' => '编辑用户信息', 'open' => true, 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-caozuo', 'url' => GetEruUrl('admin/User/edit',['id' => '__uid__']), 'fixed' => 'right'
            ]);
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/User/del', ['id' => '__uid__']), 'fixed' => 'right'
            ]);
        }
        $this->list_search = [
            'select' => [
                ['field' => 'u_groupid','title' => '角色','list' => SelectEdit($this->GroupList,['title' => 'title','value' => 'id'])],
                ['field' => 'status','title' => '状态','list' => [['title' => '待审核','value' => '0'],['title' => '已审核','value' => '1'],['title' => '已禁用','value' => '2']]],
            ],
            'input' => [
                ['field' => 'key','title' => '关键词...'],
            ]
        ];
    }
    protected function FormFile(){
        $_grouplist = SelectEdit($this->GroupList,['title' => 'title','value' => 'id']);
        $this->list_file = [
            ['field' => 'u_name','title' => '用户名','type' => 'text','required' => true],
            ['field' => 'u_groupid','title' => '用户角色','type' => 'select','list' => $_grouplist,'required' => true],
            ['field' => 'u_niname','title' => '用户昵称','type' => 'text','required' => true],
            ['field' => 'u_phone','title' => '手机','type' => 'text'],
            ['field' => 'u_mail','title' => '邮箱','type' => 'text'],
            ['field' => 'u_icon','title' => '头像','type' => 'image'],
            ['field' => 'u_password','title' => '密码','type' => 'text','type_edit' => 'password','required' => true],
            ['field' => 'u_sex','title' => '性别','type' => 'radio','list' => [['title' => '男','value' => '1'],['title' => '女','value' => '2'],['title' => '保密','value' => '0']],'default' => '0','required' => true],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
        ];
        if(!empty($this->getdata['fun']) && $this->getdata['fun'] == 'read'){
            $this->list_file = DelFile($this->list_file,'field','status',true);
            array_push($this->list_file,
                ['field' => 'status','title' => '是否启用','required' => true,'type' => 'hidden']
            );
        }
        if($this->request->action() == 'edit'){
            array_push($this->list_file,
                ['field' => 'uid','title' => 'ID','required' => true,'type' => 'hidden']
            );
            foreach ($this->list_file as &$v){
                if($v['field'] != 'u_password'){
                    continue;
                }
                $v['required'] = false;
                $v['tip'] = '如不修改密码，请留空';
            }
        }
    }

    protected function SaveSelf($data,$old = []){
        if(!empty($data['uid']) && $data['uid'] == '1'){
            if($data['status'] != '1'){
                ResClient('当前用户不可禁用','0');
            }
            if($data['u_groupid'] != '1'){
                ResClient('当前用户不可更改角色','0');
            }
        }
        return $data;
    }
    protected function DelSelf($uid){
        if(is_array($uid)){
            if(in_array('1',$uid)){
                ResClient('当前用户禁止删除','0');
            }
        } else if ($uid == '1'){
            ResClient('当前用户禁止删除','0');
        }
        return $uid;
    }
}