<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use app\common\hook\Common;

class UserCard extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        $this->CheckAuth(['read','create','edit','del'],'admin','User');
        //  需要去除首页判断
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('admin/UserCard/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->validate_scene = ['add' => 'adminadd','edit' => 'adminedit'];
                $this->list_base['url'] = GetEruUrl('admin/UserCard/save',$this->getdata);
                $this->FormFile();
                break;
        }
    }
    protected function FormFile(){
        $this->list_file = [
            ['field' => 'name','title' => '姓名','type' => 'text','required' => true],
            ['field' => 'card_no','title' => '身份证号','type' => 'text','required' => true],
            ['field' => 'card_add','title' => '详细地址','type' => 'text'],
            ['field' => 'card_img_front','title' => '身份证正面','type' => 'image'],
            ['field' => 'card_img_side','title' => '身份证背面','type' => 'image'],
        ];
        if($this->request->action() == 'edit') {
            array_push($this->list_file,
                ['field' => 'id', 'title' => 'ID', 'required' => true, 'type' => 'hidden']
            );
        }
    }
    protected function SaveSelf($data,$old = []){
        if(empty($old)){
            $old = $this->model->GetList(['card_no' => $data['card_no']],false);
            if(!empty($old)){
                $data['id'] = $old['0']['id'];
                array_push($this->list_file,
                    ['field' => 'id', 'title' => 'ID', 'required' => true, 'type' => 'hidden', 'default' => $data['id']]
                );
            }
        }
        return $data;
    }
    protected function SaveCallback($data){
        if(!empty($data['card_no']) && empty($data['constellation'])){
            $_m = new Common();
            $anal = $_m->GetCardAnal($data['card_no']);
            $anal['id'] = $data['id'];
            $anal = $this->model->EditAdd($anal);
            $this->model->SetOne($anal);
        }
        if(!empty($this->getdata['uid'])){
            $_m = new \app\common\model\User();
            $_m->SetOne(['uid' => $this->getdata['uid'],'cmid' => $data['id']]);
        }
        return $data;
    }
}