<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;
use app\common\model\{UserGroupPart,MoneyPart};

class UserGroup extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/UserGroup/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/UserGroup/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/UserGroup/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加角色' : '编辑角色';
                $this->FormFile();
                break;
        }
    }
    //  查询用户权限
    protected function ListTable(){
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '角色','width' => '200','type' => $this->user_auth['edit'] ? 'edit' : 'text'],
            ['field' => 'up_money','title' => '升级积分','width' => '150','textalign' => 'center','type' => $this->user_auth['edit'] ? 'edit' : 'text'],
            ['field' => 'user_num','title' => '用户数量','width' => '150','textalign' => 'center'],
            ['field' => '_auth_list','title' => '模块权限','width' => '30%'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];

        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['field' => 'auth', 'title' => '权限管理', 'width' => '100', 'type' => 'btn', 'textalign' => 'center','open' => true,'reload' => '0', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-yanzhengma', 'url' => GetEruUrl('admin/AuthRuleAccess/index',['fid' => '__id__']), 'fixed' => 'right'],
                ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','open' => true, 'reload' => '0', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-caozuo', 'url' => GetEruUrl('admin/UserGroup/edit',['id' => '__id__']), 'fixed' => 'right']
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file,
                ['field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','event' => 'del','class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/UserGroup/del',['id' => '__id__']), 'fixed' => 'right']
            );
        }
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '添加角色', 'open' => true, 'url' => GetEruUrl('admin/UserGroup/create')]
            ];
        }

    }
    protected function formfile(){
        //  查询用户角色分类
        $_m = new UserGroupPart();
        $_partlist = $_m->GetList([],false);
        $_partlist = SelectEdit($_partlist,['title' => 'title','value' => 'id']);

        $_m = new MoneyPart();
        $_moneylist = $_m->GetList([],false);
        $_moneylist = SelectEdit($_moneylist,['title' => 'title','value' => 'id']);
        $_moneylist = array_merge([['title' => '人民币','value' => '0']],$_moneylist);
        $this->list_file = [
            ['field' => 'title','title' => '角色名称','type' => 'text','required' => true],
            ['field' => 'fid','title' => '所属分类','type' => 'select','list' => $_partlist,'required' => true],
            ['field' => 'icon_type','title' => '角色图标类型','type' => 'radio','list' => [['title' => 'ICON','value' => '0'],['title' => '图片','value' => '1']],'default' => '0','file_link' => [['icon'],['icon_img']],],
            ['field' => 'icon','title' => '角色图标','type' => 'icon'],
            ['field' => 'icon_img','title' => '角色图标','type' => 'image'],
            ['field' => 'up_auto','title' => '自动升级','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '0','required' => true,'file_link' => ['1' => ['up_money','up_type']]],
            ['field' => 'up_type','title' => '升级积分类型','type' => 'select','text' => true,'list' => $_moneylist,'required' => true],
            ['field' => 'up_money','title' => '升级积分','type' => 'number','required' => true,'default' => '0'],
            ['field' => 'group_admin','title' => '是否开放后台','type' => 'radio','list' => [['title' => '开放','value' => '1'],['title' => '禁用','value' => '0']],'default' => '0','required' => true],
            ['field' => 'group_space','title' => '角色上传容量','type' => 'hidden','required' => true,'default' => '0','unit' => 'MB','tip' => '0为不限制'],
            ['field' => 'sort','title' => '排序值','type' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
    protected function SaveSelf($data,$old = []){
        if(!empty($data['id']) && $data['id'] == '1'){
            if($data['status'] != '1'){
                ResClient('当前角色不可禁用','0');
            }
        }
        return $data;
    }
    //  删除前处理
    protected function DelSelf($id){
        if(is_array($id)){
            if(in_array('1',$id)){
                ResClient('当前角色禁止删除','0');
            }
        } else if ($id == '1'){
            ResClient('当前角色禁止删除','0');
        }
        return $id;
    }
}