<?php
declare(strict_types = 1);
namespace app\admin\controller;

use app\common\controller\AdminBase;

class UserGroupPart extends AdminBase
{
    protected function initialize()
    {
        parent::initialize();
        if(!$this->user_auth['index']){
            ResClient('没有此权限','0');
        }
        $this->BaseModel();
        switch ($this->request->action()){
            case 'index':
                $this->list_base['fast_url'] = GetEruUrl('admin/UserGroupPart/fastedit',$this->getdata);
                $this->list_base['url'] = GetEruUrl('admin/UserGroupPart/getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('admin/UserGroupPart/save',$this->getdata);
                $this->list_base['title'] = $this->request->action() == 'create' ? '添加角色分类' : '编辑角色分类';
                $this->FormFile();
                break;
        }
    }
    //  用户角色分类列表
    protected function ListTable(){
        $this->list_file = [
            ['field' => 'id','title' => 'ID','width' => '80','textalign' => 'center'],
            ['field' => 'title','title' => '分类名称','width' => '30%','type' => $this->user_auth['edit'] ? 'edit' : 'text'],
            ['field' => '_auth_list','title' => '模块','width' => '30%'],
            ['field' => 'sort','title' => '排序值','width' => '80','type' => $this->user_auth['edit'] ? 'edit' : 'text','textalign' => 'center'],
            ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','disabled' => $this->user_auth['edit'] ? '0' : '1']
        ];
        if($this->user_auth['edit']) {
            array_push($this->list_file, [
                'field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'open' => 'true', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('admin/UserGroupPart/edit', ['id' => '__id__']), 'fixed' => 'right']
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'textalign' => 'center','event' => 'del', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('admin/UserGroupPart/del',['id' => '__id__']), 'fixed' => 'right']
            );
        }
        $this->list_base['button'] = [
            ['title' => '添加角色分类', 'url' => GetEruUrl('admin/UserGroupPart/create'),'open' => true]
        ];
    }

    protected function FormFile(){
        $this->list_file = [
            ['field' => 'title','title' => '分类名称','type' => 'text','required' => true],
            ['field' => 'auth_list','title' => '权限模块','type' => 'checkbox','list' => [['title' => '后台模块','value' => 'eru'],['title' => '前台模块','value' => 'home'],['title' => '会员中心模块','value' => 'member'],['title' => 'API接口模块','value' => 'api']],'default' => ['home'],'required' => true],
            ['field' => 'sort','title' => '排序值','type' => 'text','type_edit' => 'number','default' => '0'],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '禁用','value' => '0']],'default' => '1','required' => true],
        ];
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden']);
        }
    }
    protected function SaveSelf($data,$old = []){
        if(!empty($data['id']) && $data['id'] == '1'){
            if($data['status'] != '1'){
                ResClient('当前角色分类不可禁用','0');
            }
        }
        return $data;
    }
    //  删除前处理
    protected function DelSelf($id){
        if(is_array($id)){
            if(in_array('1',$id)){
                ResClient('当前角色分类禁止删除','0');
            }
        } else if ($id == '1'){
            ResClient('当前角色分类禁止删除','0');
        }
        return $id;
    }
}