<?php
declare(strict_types = 1);
namespace app\advert\controller\member;

use think\facade\Event;

class Ad extends Base
{
    
    protected $conf;
    protected function initialize()
    {
        parent::initialize();
        $this->CheckAuth(['read','create','edit','del'],'member','advert.Ad');
        $this->BaseModel('Ad','model','advert');
        $this->GetConf();
        $this->list_base['base_part'] = 'advert:ad';
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('getlist',$this->getdata);
                $this->ListTable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('save',$this->getdata);
                $this->FormFile();
                break;
        }

    }
    protected function ListTable(){
        $list_file = Event::trigger('Mod',['type' => 'GetMemberList','data' => ['mod' => 'Ad','model' => 'advert']]);
        if(empty($list_file['0']['code'])){
            ResClient($list_file['0']['msg'],'0');
        }
        $this->list_file = $list_file['0']['filelist'];
        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['field' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('edit', ['id' => '__id__']),'fixed' => 'right']
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'field' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('del', ['id' => '__id__']),'fixed' => 'right']);
        }
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '新增', 'url' => GetEruUrl('create')],
            ];
        }

        if(!empty($list_file['0']['data']['listsearch'])){
            $this->list_search['select'] = DelFile($list_file['0']['data']['listsearch'],'type','select');
            $this->list_search['input'] = DelFile($list_file['0']['data']['listsearch'],'type','text');
            $this->list_search['date'] = DelFile($list_file['0']['data']['listsearch'],'type','date');
        }
    }
    protected function FormFile(){
        $form_file = Event::trigger('Mod',['type' => 'GetAdminForm','data' => ['mod' => 'Ad','model' => 'advert']]);
        if(empty($form_file['0']['code'])){
            ResClient($form_file['0']['msg'],'0');
        }
        $this->list_file = $form_file['0']['filelist'];
        array_push($this->list_file,
            ['field' => 'uid','title' => 'UID','required' => true,'type' => 'hidden','default' => $this->ImUser['uid']],
            ['field' => 'cid','title' => 'CID','required' => true,'type' => 'hidden','default' => $this->ImUser['cid']],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '草稿','value' => '0'],['title' => '禁用','value' => '2']],'default' => '1','required' => true]
        );
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['filed' => 'id','title' => 'ID','required' => true,'type' => 'hidden'],
                ['field' => '_method','title' => 'METHOD','default' => 'PUT','required' => true,'type' => 'hidden']);
        }
    }
    protected function GetListDbSelf($data){
        $list_file = Event::trigger('Mod',['type' => 'GetAdminList','data' => ['mod' => 'Ad','model' => 'advert']]);
        if(empty($list_file['0']['code'])){
            ResClient($list_file['0']['msg'],'0');
        }
        $data['GetFile'] = array_column($list_file['0']['filelist'],'field');
        array_push($data['GetFile'],'uid');
         if(!empty($this->ImUser['cid'])){
            $data['cid'] = $this->ImUser['cid'];
        } else {
            $data['uid'] = $this->ImUser['uid'];
        }
        if($this->conf['pages'] == '2'){
            array_push($data['GetFile'],'pid');
        }
        return $data;
    }
    protected function GetConf(){
        $res = Event::trigger('Mod',['type' => 'GetMod','data' => ['mod' => 'ad','model' => 'advert']]);
        if($res['0']['code'] != '1'){
            ResClient($res['0']['msg'],'0');
        }
        $this->conf = $res['0']['data'];
        switch ($this->conf['pages']){
            case '1':
                $this->list_base['page'] = false;
                break;
            case '2':
                $this->list_base['page'] = false;
                $this->list_base['fold'] = true;
                break;
        }
    }
}