<?php
declare(strict_types = 1);
namespace app\cms\controller;
use app\common\hook\NodeFormat;
use think\facade\Event;
use think\facade\Session;
use think\facade\View;

class Article extends Base
{
    protected $PartModel;
    protected $conf;
    protected $Part;
    protected function initialize()
    {
        parent::initialize();
        $this->BaseModel('Article','model','cms');
        $this->BaseModel('Part','PartModel','cms');
        $this->list_base['base_part'] = 'cms:article';
        $this->GetConf();
        $this->GetPartList();
    }
    protected function ReadCallback($data){
        if(empty($data) || $data['status'] != '1'){
             ResClient('内容不存在','0','',GetEruUrl('home/Index/index'));
        }
        $this->GetPartRead($data['fid']);
        if(!empty($this->Part['password']) && !Session::get("cms_part_{$data['fid']}_pwd")){
            Redirect(GetEruUrl("/cms/part/check",['id' => $data['fid']]));
        }
        if(!empty($this->Part['temp_cont'])){
            $this->list_base['template'] = $this->Part['temp_cont'];
        }
        $this->EditTdk($data);
        $pnpage = $this->model->PNPage($data);
        //  增加点击量
        $this->model->whereId($data['id'])->inc('hist')->update();
        View::assign(['pnpage' => $pnpage]);
        return $data;
    }
    protected function GetConf(){
        $res = Event::trigger('Mod',['type' => 'GetMod','data' => ['mod' => 'article','model' => 'cms']]);
        if($res['0']['code'] != '1'){
            ResClient($res['0']['msg'],'0');
        }
        $this->conf = $res['0']['data'];
        switch ($this->conf['pages']){
            case '1':
                $this->list_base['page'] = false;
                break;
            case '2':
                $this->list_base['page'] = false;
                $this->list_base['fold'] = true;
                break;
        }
    }
    //  查询栏目列表
    protected function GetPartList()
    {
        $this->PartList = $this->PartModel->GetList(['status' => '1'],false);
        $this->PartList = $this->PartModel->UntList($this->PartList);
        $this->PartList = NodeFormat::toList($this->PartList);
        $this->PartList = FileEditAdd($this->PartList,false,true);
        View::assign(['partlist' => $this->PartList]);
    }
    //  查询当前栏目
    protected function GetPartRead($id)
    {
        $this->Part = DelFile($this->PartList,'id',$id);
        if(empty($this->Part['0'])){
            ResClient('栏目不存在','0','',GetEruUrl('Index.index'));
        }
        $this->Part = $this->Part['0'];
        $this->Part['node'] = NodeFormat::toLayer($this->PartList,$this->Part['id']);
        $_menu = NodeFormat::getParents($this->PartList,$this->Part['id']);
        foreach ($_menu as $v){
            if(empty($this->Part['banner'])){
                $this->Part['banner'] = empty($v['banner']) ? $this->Part['banner'] : $v['banner'];
            }
            if(empty($this->Part['logo'])){
                $this->Part['logo'] = empty($v['logo']) ? $this->Part['logo'] : $v['logo'];
            }
            if(empty($this->Part['list_num'])){
                $this->Part['list_num'] = empty($v['list_num']) ? $this->Part['list_num'] : $v['list_num'];
            }
            if(empty($this->Part['title_num'])){
                $this->Part['title_num'] = empty($v['title_num']) ? $this->Part['title_num'] : $v['title_num'];
            }
            if(empty($this->Part['cont_num'])){
                $this->Part['cont_num'] = empty($v['cont_num']) ? $this->Part['cont_num'] : $v['cont_num'];
            }
            if(empty($this->Part['temp_late'])){
                $this->Part['temp_late'] = empty($v['temp_late']) ? $this->Part['temp_late'] : $v['temp_late'];
            }
        }
        $this->Part['temp_late'] = empty($this->Part['temp_late']) ? 'eru_piece/list/default' : $this->Part['temp_late'];
        $this->Part['temp_late'] = "view/home/default/template/{$this->Part['temp_late']}.htm";
        View::assign(['partdb' => $this->Part,'menu' => $_menu]);
    }
}