<?php
declare(strict_types = 1);
namespace app\cms\controller\api;

use think\facade\Event;

class Show extends Base
{
    protected $conf;
    protected function initialize()
    {
        parent::initialize();
        $this->CheckAuth(['create','edit','del'],'api','cms.Show');
        $this->BaseModel('Show','model','cms');
        $this->list_base['base_part'] = 'cms:show';
        $this->GetConf();
        switch ($this->request->action()){
            case 'create':
            case 'edit':
            case 'save':
                if(!$this->IsLogin()){
                      ResJson('','非法访问','0');
                }
                $this->FormFile();
                break;
        }
    }
    protected function FormFile(){
        $form_file = Event::trigger('Mod',['fun' => 'GetAdminList','data' => ['mod' => 'Show','model' => 'cms']]);
        if(empty($form_file['0']['code'])){
             ResClient($form_file['0']['msg'],'0');
        }
        $this->list_file = $form_file['0']['filelist'];
        array_push($this->list_file,
            ['field' => 'uid','title' => 'UID','required' => true,'type' => 'hidden','default' => $this->ImUser['uid']],
            ['field' => 'cid','title' => 'CID','required' => true,'type' => 'hidden','default' => $this->ImUser['cid']],
            ['field' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '草稿','value' => '0'],['title' => '禁用','value' => '2']],'default' => '1','required' => true]
        );
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['field' => 'id','title' => 'ID','required' => true,'type' => 'hidden'],
                ['field' => '_method','title' => 'METHOD','default' => 'PUT','required' => true,'type' => 'hidden']);
        }
    }
    protected function GetConf(){
        $res = Event::trigger('Mod',['type' => 'GetMod','data' => ['mod' => 'show','model' => 'cms']]);
        if($res['0']['code'] != '1'){
            ResClient($res['0']['msg'],'0');
        }
        $this->conf = $res['0']['data'];
        switch ($this->conf['pages']){
            case '1':
                $this->list_base['page'] = false;
                break;
            case '2':
                $this->list_base['page'] = false;
                $this->list_base['fold'] = true;
                break;
        }
    }
}