<?php
declare(strict_types = 1);
namespace app\cms\controller\member;

use think\facade\Event;

class Article extends Base
{
    protected function initialize()
    {
        parent::initialize();
        $this->CheckAuth(['create','edit','del'],'member','cms.article');
        $this->BaseModel('Article','model','cms');
        $this->list_base['base_part'] = 'cms:article';
        switch ($this->request->action()){
            case 'index':
                $this->list_base['url'] = GetEruUrl('getlist',$this->getdata);
                $this->listtable();
                break;
            case 'create':
            case 'edit':
            case 'save':
                $this->list_base['url'] = GetEruUrl('save',$this->getdata);
                $this->formfile();
                break;
        }

    }
    protected function listtable(){
        $list_file = Event::trigger('AutoFun',['fun' => 'EruTableList','data' => ['mod' => 'Article','model' => 'cms']]);
        if(empty($list_file['0']['code'])){
            $this->error($list_file['0']['msg']);
        }
        $this->list_file = $list_file['0']['data']['tablelist'];
        if($this->user_auth['edit']) {
            array_push($this->list_file,
                ['filed' => 'edit', 'title' => '编辑', 'width' => '80', 'type' => 'btn', 'textalign' => 'center', 'class' => 'ery-text-green ery-text-f16', 'icon' => 'im-icon im-edit', 'url' => GetEruUrl('edit', ['id' => '__id__']),'fixed' => 'right']
            );
        }
        if($this->user_auth['del']) {
            array_push($this->list_file, [
                'filed' => 'del', 'title' => '删除', 'width' => '80', 'type' => 'btn', 'event' => 'del', 'textalign' => 'center', 'class' => 'ery-text-red ery-text-f16', 'icon' => 'im-icon im-delete', 'url' => GetEruUrl('del', ['id' => '__id__']),'fixed' => 'right']);
        }
        if($this->user_auth['create']) {
            $this->list_base['button'] = [
                ['title' => '新增', 'url' => GetEruUrl('create')],
            ];
        }

        if(!empty($list_file['0']['data']['listsearch'])){
            $this->list_search['select'] = DelFile($list_file['0']['data']['listsearch'],'type','select');
            $this->list_search['input'] = DelFile($list_file['0']['data']['listsearch'],'type','text');
            $this->list_search['date'] = DelFile($list_file['0']['data']['listsearch'],'type','date');
        }
    }
    protected function formfile(){
        $form_file = Event::trigger('AutoFun',['fun' => 'EruFormList','data' => ['mod' => 'Article','model' => 'cms']]);
        if(empty($form_file['0']['code'])){
            $this->error($form_file['0']['msg']);
        }
        $this->list_file = $form_file['0']['data']['filelist'];
        array_push($this->list_file,
            ['filed' => 'uid','title' => 'UID','required' => true,'type' => 'hidden','default' => $this->ImUser['cid']],
            ['filed' => 'cid','title' => 'CID','required' => true,'type' => 'hidden','default' => $this->ImUser['cid']],
            ['filed' => 'status','title' => '是否启用','type' => 'radio','list' => [['title' => '启用','value' => '1'],['title' => '草稿','value' => '0'],['title' => '禁用','value' => '2']],'default' => '1','required' => true]
        );
        if($this->request->action() == 'edit'){
            array_push($this->list_file,['filed' => 'id','title' => 'ID','required' => true,'type' => 'hidden'],
                ['filed' => '_method','title' => 'METHOD','default' => 'PUT','required' => true,'type' => 'hidden']);
        }
    }
    protected function GetListSelf($data){
        if(!empty($this->ImUser['cid'])){
            $data['cid'] = $this->ImUser['cid'];
        } else {
            $data['uid'] = $this->ImUser['uid'];
        }
        return $data;
    }
}