<?php
declare(strict_types = 1);
namespace app\cms\model;

use app\common\hook\NodeFormat;
use app\common\model\R;
use app\common\model\User;

class Article extends R
{
    protected $name = 'cms_article';

    protected function UntModel($data){
        $uid = array_unique(array_column($data,'uid'));
        $_m = new User();
        $uid = $_m->GetList(['uid' => $uid],false);

        $fid = array_unique(array_column($data,'fid'));
        $_m = new Part();
        $fid = $_m->GetList(['id' => $fid],false);

        foreach ($data as &$v){
            $_v = DelFile($uid,'uid',$v['uid']);
            $v['u_name'] = $_v['0']['u_name'] ?? '-';
            $v['u_niname'] = $_v['0']['u_niname'] ?? '-';
            $v['u_phone'] = $_v['0']['u_phone'] ?? '-';
            $v['u_icon'] = $_v['0']['u_icon'] ?? '-';

            $_v = DelFile($fid,'id',$v['fid']);
            $v['fid_title'] = $_v['0']['title'] ?? '-';
            $v['fid_url'] = "/cms/part-{$v['fid']}.html";
            $v['url'] = "/cms/article-{$v['id']}.html";
        }
        return $data;
    }
    public function PNPage($data){
        $_data = $this->whereFid($data['fid'])->whereId('<',$data['id'])->whereStatus('1')->whereNull('del_time')->order('id desc')->find();
        $articlepage['prev'] = empty($_data) ? [] : $this->GetOne($_data['id']);
        $_data = $this->whereFid($data['fid'])->whereId('>',$data['id'])->whereStatus('1')->whereNull('del_time')->order('id asc')->find();
        $articlepage['next'] = empty($_data) ? [] : $this->GetOne($_data['id']);
        return $articlepage;
    }
    public function TagMap($data){
        if(empty($data['fid'])){
            return $data;
        }
        $_m = new Part();
        $PartList = $_m->GetList(['status' => '1'],false);
        $data['fid'] = is_array($data['fid']) ? $data['fid'] : explode(',',$data['fid']);
        $fid = [];
        foreach ($data['fid'] as $v){
            $_v = [];
            $_v = NodeFormat::getChildsId($PartList,$v);
            array_push($_v,$v);
            $fid = array_unique(array_merge($fid,$_v));
        }
        $data['fid'] = $fid;
        return $data;
    }
}