<?php
use think\exception\HttpResponseException;
use think\facade\Route;
use think\Response;
//  这个是原有文件
/**
 * 系统标签
 * @param null $tofunction
 * @return false|mixed
 * @throws ReflectionException
 */
function IMTAG($tofunction = null){
    static $fun_array = [];
    list($class_name,$action) = explode('@',$tofunction);
    $class = "app\\common\\imtrait\\".ucfirst($class_name);
    $obj = empty($fun_array[$class_name]) ? null : $fun_array[$class_name];
    if(empty($obj)){
        if(!class_exists($class)){
            return false;
        }
        $obj = $fun_array[$class_name] = new $class;
    }
    if(!method_exists($obj, $action)){
        return false;
    }
    $params = func_get_args();
    unset($params[0]);
    $params = array_values($params);
    static $default_params_array = [];
    $_params = empty($default_params_array[$tofunction]) ? null : $default_params_array[$tofunction];
    if (!isset($_params)) {
        $_params = [];
        $_obj = new \ReflectionMethod($obj, $action);
        $_array = $_obj->getParameters();
        foreach($_array as $key=>$value){
            if($value->isOptional()){
                $_params[$key] = $value->getDefaultValue();
            }else{
                $_params[$key] = null;
            }
        }
        $default_params_array[$tofunction] = $_params;
    }
    foreach($_params as $key=>$value){
        if(isset($params[$key])){
            $_params[$key] = $params[$key];
        }
    }
    return call_user_func_array([$obj, $action], $_params);
}
/**
 * Here is your custom functions.
 */
function ToUnderScore($str,$tolower = true,$sep = '_'){
    if(is_array($str)){
        foreach ($str as $k => $v){
            $str[$k] = toUnderScore($v,$sep,$tolower);
        }
        return $str;
    }
    if($tolower){
        $str = strtolower(preg_replace('/([a-z])([A-Z])/', "$1" . $sep . "$2", $str));
    }else{
        $str = explode($sep, $str);
        foreach ($str as $k => $v){
            $str[$k] = trim(ucfirst($v));
        }
        $str = implode('',$str);
    }
    return $str;
}
/**
 * 数据集转数组
 * @param $data
 * @return array|mixed
 */
function JobArray($data){
    if (is_array($data)) {
        if (empty($data)){
            return array();
        }
        if (is_object(current($data))) {
            $new_data = array();
            foreach ($data as $k => $v) {
                $new_data[$k] = $v->toArray();
            }
            return $new_data;
        }
        return $data;
    }
    if (is_object($data)) {
        return $data->toArray();
    }
    return $data;
}
/**
 * 删除空数据字段
 * @array  $data 要处理的数组
 * @return array
 */
function DelNull($data){
    $_data = [];
    foreach ($data as $k => $v) {
        if (is_array($v)) {
            $v = DelNull($v);
        } else {
            $v = (string) $v;
            if ($v === "" || trim($v) === "") {
                continue;
            }
        }
        $_data[$k] = $v;
    }
    return $_data;
}
/**
 * 格式化数据
 * @array $data 要处理的数据
 * @return array 处理完毕的数据
 */
function DataTrim($data){
    $trim = array();
    foreach ($data as $key => $val){
        if(is_array($val)){
            $trim[$key] = DataTrim($val);
        }else{
            $val = empty($val) && !isset($val) ? '' : (string) $val;
            $val = trim($val);
            $val = str_replace("\t","   &nbsp;  &nbsp;",$val);
            $val = str_replace("   ","&nbsp;",$val);
            $val = trim($val);
            $trim[$key] = empty($val) && !isset($val) ? null : $val;
        }
    }
    return $trim;
}
/**
 * 删除数组中不需要的字段信息
 * @param $data
 * @param $filed
 * @param false $eqfile
 * @return array
 */
function DelArrayFile($data,$filed,$eqfile = false){
    foreach ($data as $k => $v){
        if($eqfile){
            if(in_array($k,$filed)){
                unset($data[$k]);
            }
        }else{
            if(!in_array($k,$filed)){
                unset($data[$k]);
            }
        }
    }
    $data = array_merge([],$data);
    return $data;
}
/**
 * 格式化表单多选项，如下拉菜单，单选，多选
 */
function SelectEdit($data, $files = []):array{
    if (empty($data)){
        return $data;
    }
    $res = [];
    $_title = $files['title'] ?? 'title';
    $_value = $files['value'] ?? 'value';
    foreach ($data as $k => $v){
        array_push($res,['title' => $v[$_title],'value' =>  $v[$_value]]);
    }
    return $res;
}
/**
 * 格式化栏目列表，去除自身及下级栏目
 * @param array $data 要处理的数据
 * @param array $pid   要移除的下级ID,id为下级ID,on为是否移除自身
 * @param array $ToFile 指定递归字段，默认标题为title,值为id
 * @return array 返回处理好的数组
 */
function FormatPart($data,$pid = [],$ToFile = []){
    if (empty($data)){
        return $data;
    }
    $data = \app\common\hook\NodeFormat::toList($data);
    $ToFile['title'] = empty($ToFile['title']) ? 'title' : $ToFile['title'];
    $ToFile['value'] = empty($ToFile['value']) ? 'id' : $ToFile['value'];
    if(!empty($pid['id'])){
        $_ids = \app\common\hook\NodeFormat::getChildsId($data,$pid['id']);
        if(!empty($pid['on'])){
            array_push($_ids,$pid['id']);
        }
        $data = DelFile($data,$ToFile['value'],$_ids,true);
    }
    return SelectEdit($data,$ToFile);
}
/**
 * @param string $msg 响应提示
 * @param string $code 响应码
 * @param string|array $data  返回数据
 * @param string $url 返回链接
 * @param string $wait  等待时间
 * @param false $json   返回数据格式
 * @param string $temp 使用模板
 * @param int $browser_code 浏览器响应码
 * @throws Exception
 */
function ResClient($msg = '', $code = '1',$data = '', $url = '', $wait = '3', array $header = []){
    if (is_null($url) && isset($_SERVER["HTTP_REFERER"])) {
        $url = $_SERVER["HTTP_REFERER"];
    } elseif ($url) {
        $url = (strpos($url, '://') || 0 === strpos($url, '/')) ? $url : Route::buildUrl($url);
    }
    $result = [
        'code' => $code,
        'msg' => $msg,
        'data' => $data,
        'url' => $url,
        'wait' => $wait,
    ];
    $type = request()->isJson() || request()->isAjax() ? 'json' : 'html';
    if(strtolower($type) == 'html'){
        $type = 'view';
        $response = Response::create(config('app.error_tmpl'), $type)->assign($result)->header($header);
    }else{
        $response = Response::create($result, $type)->header($header);
    }
    throw new HttpResponseException($response);
}
//  返回JSON信息
function ResJson($data,$msg = '查询成功',$code = '1',$url = ''){
    $result = [
        'code' => $code,
        'msg' => $msg,
        'time' => time(),
        'data' => $data,
    ];
    if(!empty($url)){
        $result['url'] = $url;
    }
    ksort($result);
    $response = Response::create($result, 'json')->header([]);
    throw new HttpResponseException($response);
}
function Redirect($url,$code = '302',$with = []){
    $response = Response::create($url, 'redirect');
    $response->code($code)->with($with);
    throw new HttpResponseException($response);
}
/**
 * 数组指定位置插入元素
 */
function ArraySpliceArray(array &$data, $index, $add)
{
    $c = count($data);//总长度
    if ($c <= $index) {
        $data[] = $add;
        return $data;
    };
    for ($i = ($c - 1); $i >= 0; $i--) {//循环转移数组元素
        $data[($i + 1)] = $data[$i];
        if ($index == $i) {
            $data[$i] = $add;
            break;
        }
    }
    return $data;
}
// 增加数组前缀
function AddArrayPrefix($data,$prefix){
    if(!empty($data) && !empty($prefix)){
        $res = [];
        foreach ($data as $k => $v){
            $res[$prefix . '_' . $k] = $v;
        }
    } else {
        $res = $data;
    }
    return $res;
}
//  数组排序
function ArraySort($arr, $keys, $type = 'desc') {
    $keysvalue = $new_array = array();
    foreach ($arr as $k => $v){
        $keysvalue[$k] = empty($v[$keys]) ? '0' : $v[$keys];
    }
    $type == 'asc' ? asort($keysvalue) : arsort($keysvalue);
    reset($keysvalue);
    foreach ($keysvalue as $k => $v) {
        if(!is_array($arr[$k])){
            $arr[$k] = $arr[$k]->toArray();
        }
        $new_array[] = $arr[$k];
    }
    return $new_array;
}
/**
 * 隐藏真实网址
 * @param $data
 * @param bool $adds 隐藏或显示
 * @param false $api 如果是api则返回带网址的地址
 * @return array|mixed|string|string[]
 */
function FileEditAdd($data,$adds = true,$api = false){
    if(empty($data)){
        return $data;
    }
    if(is_array($data)){
        foreach ($data as $k => $v){
            $data[$k] = FileEditAdd($v,$adds,$api);
        }
        return $data;
    }
    if($api){
        $confModel = new \app\common\model\Config();
        $webdb['web_url'] = $confModel->where('field','web_url')->value('conf_value');
    }
    if($adds == true){
        if($api){
            $data = str_replace($webdb['web_url'].'/upload_file/','/upload_file/',(string) $data);
        }
        $data = str_replace('/upload_file/','http://www_zhaoyan_net/Ls_dir/',(string) $data);
    }else{
        $data = str_replace('http://www_zhaoyan_net/Ls_dir/','/upload_file/',(string) $data);
        if($api){
            $data = str_replace('/upload_file/',$webdb['web_url'].'/upload_file/',$data);
        }
    }
    return $data;
}
/**
 * 处理新老数据
 * @param $data
 * @param $old
 * @param $file
 * @return array
 */
function CompareFile($data,$old,$file){
    $newdata = [];
    $newfiledata = (empty($data) && !isset($data)) ? [] : array_column($data,$file);
    $oldfiledata = empty($old) ? [] : array_column($old,$file);
    //  处理新图片
    if(!empty($oldfiledata) && !empty($data)){
        foreach ($data as $k => $v){
            if(!empty($v[$file])){
                if(in_array($v[$file],$oldfiledata)){
                    unset($data[$k]);
                    continue;
                }
            }
            array_push($newdata,$v);
        }
    }else{
        $newdata = $data;
    }
    //  处理老图片
    if(!empty($newfiledata) && !empty($old)){
        foreach ($old as $k => $v){
            if(!empty($v[$file])){
                if(in_array($v[$file],$newfiledata)){
                    unset($old[$k]);
                }
            }
        }
    }
    $res = [
        'new' => $newdata,
        'old' => $old,
    ];
    return $res;
}
/**
 * 删除文件
 * @param string $dirname 文件路径
 * @return bool
 */
function DelWebFile($data){
    if(!empty($data) && is_array($data)){
        foreach ($data as $key => $val){
            DelWebFile($val);
        }
    }else if(!empty($data) && is_file(str_replace('//','/',root_path().$data))){
        $filedir = explode('/upload_file',$data);
        if(count($filedir) > '1'){
            @unlink(root_path().$data);
        }
    }
    return true;
}
/**
 * 去除不需要的字段
 * @param array $data 要处理的数组
 * @param string $file 处理字段
 * @param array|string $value 对比值
 * @param bool $eqfile 等于为true
 * @return array mixed 返回处理完成的数组
 */
function DelFile($data,$file,$value,$eqfile = false){
    foreach ($data as $k => $v){
        $v = is_array($v) ? $v : (array) $v;
        if(is_array($value)){
            if($eqfile){
                if(in_array($v[$file],$value)){
                    unset($data[$k]);
                }
            }else{
                if(!in_array($v[$file],$value)){
                    unset($data[$k]);
                }
            }
        }else{
            if($eqfile){
                if(!isset($v[$file]) || $v[$file] == $value){
                    unset($data[$k]);
                }
            }else{
                if(!isset($v[$file]) || $v[$file] != $value){
                    unset($data[$k]);
                }
            }
        }
    }
    $data = array_merge([],$data);
    return $data;
}
/**
 * 清空/删除 文件夹
 * @param string $dirname 文件夹路径
 * @param bool $self 是否删除当前文件夹
 * @return bool
 */
function DelDir($dirname, $self = true)
{
    if (!file_exists($dirname)) {
        return false;
    }
    if (is_file($dirname) || is_link($dirname)) {
        return unlink($dirname);
    }
    $dir = dir($dirname);
    if ($dir) {
        while (false !== $entry = $dir->read()) {
            if ($entry == '.' || $entry == '..') {
                continue;
            }
            DelDir($dirname . '/' . $entry);
        }
    }
    $dir->close();
    $self && rmdir($dirname);
}
/**
 * 获取站点配置
 * @return array|mixed|string|string[]
 * @throws \think\db\exception\DataNotFoundException
 * @throws \think\db\exception\DbException
 * @throws \think\db\exception\ModelNotFoundException
 */
function GetWebDb(){
    $res = ['public' => [],'private' => []];
    if(\think\facade\Cache::has("webdb")){
        $res = \think\facade\Cache::get("webdb");
    } else {
        $_m = new \app\common\model\Config();
        $confList = $_m->GetList(['status' => '1','GetFile' => 'field,conf_value,private'],false);
        foreach ($confList as $v) {
            if(empty($v['private'])){
                $res['public'][$v['field']] = $v['conf_value'];
            } else {
                $res['private'][$v['field']] = $v['conf_value'];
            }
        }
        $res = FileEditAdd($res,false);
        $lock = GetReadFile(base_path().'app.lock');
        $lock = json_decode($lock,true);
        $res['public']['version_no'] = $lock['version_no'];
        $res['public']['version_server'] = $lock['server'] ?? 'https://www.wormcms.com';
        \think\facade\Cache::set("webdb",$res,86400);
    }
    return $res;
}
function GetServer($data,$private = true){
    $res = $private ? array_merge($data['public'],$data['private']) : $data;
    $u = EmpowerUrl(request()->domain());
    $set = [
        'url' => $u['url'],
        'pack' => 'tp',
        'empower' => '1',
        'version' => 'V3',
    ];
    $_ecode = GetEruSing(GetEruPwd($set,$u['url']),$u['url']);
    $res['web_footbq'] = $res['web_footbq'] ?? '';
    $res['web_warrant'] = $res['web_warrant'] ?? '';
    if($_ecode != $res['web_warrant']){
        $_Y = date('Y');
        $res['web_footbq'] .= "<div class='layout ery-fex-l'>Powered by <a style='margin: 0 5px;' href='//wormcms.com' title='EruCMS' target='_blank'>EruCMS</a> © 2012-{$_Y}</div>";
    }
    return $res;
}
function EmpowerUrl($url):array
{
    $url = str_replace(['http://','https://'],'',$url);
    $_empower = explode('.',$url);
    if(count($_empower) > '2' && $_empower['0'] == 'www'){
        unset($_empower['0']);
    }
    $res = implode('.',$_empower);
    $res = explode('/',$res);
    $_res = explode('.',$res['0']);
    return ['url' => $res['0'],'url_size' => count($_res)];
}
function GetEruPwd($data,$key,$decrypt = false){
    if(!is_array($key)){
        $key = [
            'key' => $key
        ];
        $key['iv'] = substr(md5($key['key']),0,16);
    } else {
        if(empty($key['key']) || empty(key(['iv']))){
            return false;
        }
    }
    if($decrypt){
        $res = openssl_decrypt($data,'AES-128-CBC',$key['key'],0,$key['iv']);
        $res = json_decode($res,true);
    } else {
        $res = openssl_encrypt(json_encode($data,JSON_UNESCAPED_UNICODE),'AES-128-CBC',$key['key'],0,$key['iv']);
    }
    return $res;
}
function GetEruSing($data,$key){
    $key = str_pad($key, 64, chr(0));
    $ipad = substr($key,0, 64) ^ str_repeat(chr(0x36), 64);
    $opad = substr($key,0, 64) ^ str_repeat(chr(0x5C), 64);
    return strtoupper(md5($opad.pack('H32', md5($ipad.$data))));
}
/**
 * 生成url地址
 */
function GetEruUrl($fun,$getdata = []){
    if(filter_var($fun, FILTER_VALIDATE_URL)){
        return $fun;
    }
    if(empty($getdata)){
        $_fun = explode('?',$fun);
        $fun = count($_fun) > 1 ? $_fun['0'] : $fun;
        $getdata = count($_fun) > 1 ? $_fun['1'] : $getdata;
    }
    if(!empty($getdata) && !is_array($getdata)) {
        $getdata = explode('&', $getdata);
        $_getdata = [];
        foreach ($getdata as $v) {
            $v = explode('=', $v);
            $_getdata[$v['0']] = $v['1'];
        };
        $getdata = $_getdata;
    }
    return url($fun,$getdata)->domain(true)->build();
}
/**
 * 提取内容图片列表
 * @param $data
 * @return array
 */
function GetImgList($data){
    if(empty($data)){
        return [];
    }
    $imgps = "/<[img|IMG].*?src=[\'|\"](.*?)[\'|\"].*?[\/]?>/";
    preg_match_all($imgps, $data, $imgdata);
    return $imgdata[1];
}
/**
 * @param $_dir 要读取的文件目录
 * @param array $getfile
 * @return array|mixed
 */
function GetDirlist($_dir){
    $getfile = [];
    if(file_exists($_dir)){
        $dir = opendir($_dir);
        while ($_file = readdir($dir)) {
            if($_file =='.' || $_file =='..'){
                continue;
            }
            $getfile[] = $_file;
        }
        closedir($dir);
    }
    return $getfile;
}
/**
 * 读取目录内所有文件
 * @param $_dir
 * @param array $getfile
 * @return array|mixed
 */
function ReadDirList($_dir,$getfile = []){
    if(file_exists($_dir)){
        $dir = scandir($_dir);
        foreach ($dir as $k => $v){
            if($v =='.' || $v =='..'){
                continue;
            }
            if(is_dir($_dir.'/'.$v)){
                $_v = ReadDirList($_dir.'/'.$v);
                $getfile = array_merge($getfile,$_v);
            }else{
                $getfile[] = $_dir.'/'.$v;
            }
        }
    }
    return $getfile;
}
/**
 * 复制文件
 * @param $old
 * @param $new
 * @return bool
 */
function CopyFiles($old,$new){
    $_nname = basename($new);
    $_dir = explode(DIRECTORY_SEPARATOR,$new);
    $_newdir = '';
    if(count($_dir) > '1'){
        foreach ($_dir as $k => $v){
            if(empty($v) || $v == $_nname){
                unset($_dir[$k]);
                continue;
            }
        }
        $_newdir = empty($_dir) ? $_newdir : implode(DIRECTORY_SEPARATOR,$_dir);
    }
    if (!file_exists($_newdir)) {
        @mkdir($_newdir,0755,true);
    }
    if(!@copy($old,$_newdir.'/'.$_nname)){
        return false;
    }
    return true;
}
/**
 * 查询验证码是否正确
 * @param string $code
 * @return bool
 */
function CheckCaptcha($code){
    $captcha = request()->session()->pull('captcha');
    return $captcha == $code;
}
/** 大小单位转换  **/
function CountSize($size)
{
    $KB = 1024;
    $MB = 1024 * $KB;
    $GB = 1024 * $MB;
    $TB = 1024 * $GB;
    if ($size < $KB) {
        return $size . "B";
    } elseif ($size < $MB) {
        return round($size / $KB, 2) . " KB";
    } elseif ($size < $GB) {
        return round($size / $MB, 2) . " MB";
    } elseif ($size < $TB) {
        return round($size / $GB, 2) . " GB";
    } else {
        return round($size / $TB, 2) . " TB";
    }
}
/**
 * 生成随机字符
 */
function GetRange($endnum = '8',$numbers = []){
    $numbers = empty($numbers) ? range (1,50) : $numbers;
    shuffle ($numbers);
    $num = 8;
    $result = array_slice($numbers,0,$num);
    $result = implode('',$result);
    $newname = '';
    for ( $i = 0; $i < $endnum; $i++ ) {
        $newname .= substr($result, mt_rand(0, strlen($result) - 1), 1);
    }
    return $newname;
}
/**
 * 产生随机字符串，不长于32位
 * @param int $length
 * @return 产生的随机字符串
 */
function GetNonceStr($length = 32): string
{
    $chars = "abcdefghijklmnopqrstuvwxyz0123456789";
    $str = "";
    for ($i = 0; $i < $length; $i++) {
        $str .= substr($chars, mt_rand(0, strlen($chars) - 1), 1);
    }
    return $str;
}
function GetWordNum(string $string,$length,$more=1,$dot = '..'){
    $more || $dot='';
    if(strlen($string) <= $length) {
        return $string;
    }
    $pre = chr(1);
    $end = chr(1);
    $string = str_replace(array('&amp;', '&quot;', '&lt;', '&gt;'), array($pre.'&'.$end, $pre.'"'.$end, $pre.'<'.$end, $pre.'>'.$end), $string);
    $strcut = '';
    if( 1 ) {
        $n = $tn = $noc = 0;
        while($n < strlen($string)) {

            $t = ord($string[$n]);
            if($t == 9 || $t == 10 || (32 <= $t && $t <= 126)) {
                $tn = 1; $n++; $noc++;
            } elseif(194 <= $t && $t <= 223) {
                $tn = 2; $n += 2; $noc += 2;
            } elseif(224 <= $t && $t <= 239) {
                $tn = 3; $n += 3; $noc += 2;
            } elseif(240 <= $t && $t <= 247) {
                $tn = 4; $n += 4; $noc += 2;
            } elseif(248 <= $t && $t <= 251) {
                $tn = 5; $n += 5; $noc += 2;
            } elseif($t == 252 || $t == 253) {
                $tn = 6; $n += 6; $noc += 2;
            } else {
                $n++;
            }
            if($noc >= $length) {
                break;
            }
        }
        if($noc > $length) {
            $n -= $tn;
        }
        $strcut = substr($string, 0, $n);
    } else {
        $_length = $length - 1;
        for($i = 0; $i < $length; $i++) {
            if(ord($string[$i]) <= 127) {
                $strcut .= $string[$i];
            } else if($i < $_length) {
                $strcut .= $string[$i].$string[++$i];
            }
        }
    }
    $strcut = str_replace(array($pre.'&'.$end, $pre.'"'.$end, $pre.'<'.$end, $pre.'>'.$end), array('&amp;', '&quot;', '&lt;', '&gt;'), $strcut);
    $pos = strrpos($strcut, chr(1));
    if($pos !== false) {
        $strcut = substr($strcut,0,$pos);
    }
    return $strcut.$dot;
}
/**
 * 读取文件内容
 */
function GetReadFile($filename, $method = "rb")
{
    if ($handle = @fopen($filename, $method)) {
        @flock($handle, LOCK_SH);
        $filedata = @fread($handle, @filesize($filename));
        @fclose($handle);
    }
    return $filedata;
}
/**
 * 写入文件内容
 */
function WriteFile($filename, $data, $method = "rb+", $lock = true)
{
    @touch($filename);
    $handle = @fopen($filename,$method);
    if(!$handle){
        return ['code' => '0','msg' => $filename . '文件不可写，请检查权限'];
    }
    if($lock){
        @flock($handle,LOCK_EX);
    }
    @fputs($handle,$data);
    if($method == "rb+"){
        @ftruncate($handle,strlen($data));
    }
    @fclose($handle);
    @chmod($filename,0755);
    if(is_writable($filename) ){
        return ['code' => '1','msg' => '文件写入成功'];
    }else{
        return ['code' => '0','msg' => '文件不可写，请检查权限'];
    }
}
/**
 * 远程Curl请求
 */
function RequestCurl($url = '', $post_data = [], $headers=null){
    $curl = curl_init(); // 启动一个CURL会话
    curl_setopt($curl, CURLOPT_CUSTOMREQUEST, 'POST');
    curl_setopt($curl, CURLOPT_URL, $url);
    if(!empty($headers)){
        curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
    }
    curl_setopt($curl, CURLOPT_FAILONERROR, false);
    curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($curl, CURLOPT_HEADER, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); // 跳过证书检查
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);  // 从证书中检查SSL加密算法是否存在
    $file_contents = curl_exec($curl);     //返回api的json对象
    $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);
    $httpCode = curl_getinfo($curl,CURLINFO_HTTP_CODE);
    $rheader = substr($file_contents, 0, $header_size);
    $rbody = substr($file_contents, $header_size);
    //关闭URL请求
    curl_close($curl);
    if($httpCode != 200){
        return $rbody;
    }
    return $rbody;
}