<?php
declare(strict_types = 1);
namespace app\common\hook;

class Common
{
    /**
     *  解析身份证
     * @return $birthday
     */
    public function GetCardAnal($idcard)
    {
        //  获取性别
        $sexint = (int)substr($idcard, 16, 1);
        $res['sex'] = $sexint % 2 === 0 ? '2' : '1';
        // 获取生日
        $bir = substr($idcard, 6, 8);
        $res['birthday_y'] = (int)substr($bir, 0, 4);
        $res['birthday_m'] = (int)substr($bir, 4, 2);
        $res['birthday_d'] = (int)substr($bir, 6, 2);
        //  获取年龄
        #  获得今日的时间戳
        $date = strtotime($bir);
        $today = strtotime('today');
        #  得到两个日期相差的大体年数
        $diff = floor(($today - $date) / 86400 / 365);
        #  strtotime加上这个年数后得到那日的时间戳后与今日的时间戳相比
        $res['age'] = strtotime($bir . ' + ' . $diff . 'years') > $today ? $diff + 1 : $diff;

        //  获取生肖
        $x = (1901 - $res['birthday_y']) % 12;
        if ($x == 1 || $x == -11) {
            $res['zodiac'] = '鼠';
        } else if ($x == 0){
            $res['zodiac'] = '牛';
        } else if ($x == 11 || $x == -1){
            $res['zodiac'] = '虎';
        } else if ($x == 10 || $x == -2){
            $res['zodiac'] = '兔';
        } else if ($x == 9 || $x == -3){
            $res['zodiac'] = '龙';
        } else if ($x == 8 || $x == -4){
            $res['zodiac'] = '蛇';
        } else if ($x == 7 || $x == -5){
            $res['zodiac'] = '马';
        } else if ($x == 6 || $x == -6){
            $res['zodiac'] = '羊';
        } else if ($x == 5 || $x == -7){
            $res['zodiac'] = '猴';
        } else if ($x == 4 || $x == -8){
            $res['zodiac'] = '鸡';
        } else if ($x == 3 || $x == -9){
            $res['zodiac'] = '狗';
        } else if ($x == 2 || $x == -10) {
            $res['zodiac'] = '猪';
        }

        //  获取星座
        if(($res['birthday_m'] == 1 && $res['birthday_d'] <= 21) || ($res['birthday_m'] == 2 && $res['birthday_d'] <= 19)){
            $res['constellation'] = '水瓶座';
        }else if (($res['birthday_m'] == 2 && $res['birthday_d'] > 20) || ($res['birthday_m'] == 3 && $res['birthday_d'] <= 20)){
            $res['constellation'] = '双鱼座';
        }else if (($res['birthday_m'] == 3 && $res['birthday_d'] > 20) || ($res['birthday_m'] == 4 && $res['birthday_d'] <= 20)){
            $res['constellation'] = '白羊座';
        }else if (($res['birthday_m'] == 4 && $res['birthday_d'] > 20) || ($res['birthday_m'] == 5 && $res['birthday_d'] <= 21)){
            $res['constellation'] = '金牛座';
        }else if (($res['birthday_m'] == 5 && $res['birthday_d'] > 21) || ($res['birthday_m'] == 6 && $res['birthday_d'] <= 21)){
            $res['constellation'] = '双子座';
        }else if (($res['birthday_m'] == 6 && $res['birthday_d'] > 21) || ($res['birthday_m'] == 7 && $res['birthday_d'] <= 22)){
            $res['constellation'] = '巨蟹座';
        }else if (($res['birthday_m'] == 7 && $res['birthday_d'] > 22) || ($res['birthday_m'] == 8 && $res['birthday_d'] <= 23)){
            $res['constellation'] = '狮子座';
        }else if (($res['birthday_m'] == 8 && $res['birthday_d'] > 23) || ($res['birthday_m'] == 9 && $res['birthday_d'] <= 23)){
            $res['constellation'] = '处女座';
        }else if (($res['birthday_m'] == 9 && $res['birthday_d'] > 23) || ($res['birthday_m'] == 10 && $res['birthday_d'] <= 23)){
            $res['constellation'] = '天秤座';
        }else if (($res['birthday_m'] == 10 && $res['birthday_d'] > 23) || ($res['birthday_m'] == 11 && $res['birthday_d'] <= 22)){
            $res['constellation'] = '天蝎座';
        }else if (($res['birthday_m'] == 11 && $res['birthday_d'] > 22) || ($res['birthday_m'] == 12 && $res['birthday_d'] <= 21)){
            $res['constellation'] = '射手座';
        }else if (($res['birthday_m'] == 12 && $res['birthday_d'] > 21) || ($res['birthday_m'] == 1 && $res['birthday_d'] <= 20)){
            $res['constellation'] = '摩羯座';
        }

        //  查询所属城市
//        $_m = new \app\common\model\Chinacode();

        return $res;
    }


}