<?php
declare(strict_types = 1);
namespace app\common\hook;

class Upload
{
    protected $UpDir = 'upload_file';
    protected $LinshiDir = 'upload_file/linshi';
    public function __construct(){
        if (!file_exists($this->UpDir)) {
            @mkdir($this->UpDir,0755,true);
        }
        if (!file_exists($this->LinshiDir)) {
            @mkdir($this->LinshiDir,0755,true);
        }
    }
    //  查询文件是否存在
    public function CheckFile($data){
        if(is_file("{$this->LinshiDir}/{$data}")){
            return true;
        }
        return false;
    }
    //  大文件分割上传
    public function SetBig($data,$base = []){
        $name = !empty($base) ? "{$base['md5']}.{$base['prefix']}" : md5($data->getOriginalName()) . ".{$data->getOriginalExtension()}";
        $setname = $this->LinshiDir . '/' . $name;
        $data->move($this->LinshiDir. '/',$name);
        $res = array(
            'title' => !empty($base['name']) ? $base['name'] : $name,
            'size' => filesize($setname),
            'url' => '/' . $this->LinshiDir . '/' . $name,
        );
        return $res;
    }
    //  合并文件
    public function PushFiles($data){
        $file_prefix = explode('.',$data['name']);
        $prefix = array_pop($file_prefix);
        if($prefix == 'gz'){
            $prefix = 'tar.' . $prefix;
        }
        $add_file = @fopen("{$this->LinshiDir}/{$data['md5']}.{$prefix}","a");
        $data['file_list'] = array_unique($data['file_list']);
        foreach ($data['file_list'] as $v){
            $newv = fopen($this->LinshiDir . '/' . $v,'r');
            flock($newv,LOCK_EX);
            fwrite($add_file,file_get_contents($this->LinshiDir . '/' . $v));
            flock($newv,LOCK_UN);
            @unlink($this->LinshiDir . '/' . $v);
        }
        @fclose($add_file);
        $res = array(
            'title' => $data['name'],
            'size' => filesize("{$this->LinshiDir}/{$data['md5']}.{$prefix}"),
            'url' => "/{$this->LinshiDir}/{$data['md5']}.{$prefix}"
        );
        return $res;
    }
    //  处理编辑器文件
    public function SetEditOr($data,$img_dir = '',$geturl = true){
        $oldimg = GetImgList($data['oldimg']);
        $newimg = GetImgList($data['newimg']);
        if(!empty($newimg)){
            $newimg = array_flip($newimg);
            $newimg = array_flip($newimg);
        }
        if(!empty($oldimg)){
            foreach ($oldimg as $v){
                $oldimgname[] = basename($v);
            }
        }
        //  处理新图片
        $newimgname = [];
        if(!empty($newimg)){
            foreach ($newimg as $k => $v){
                if(!empty($oldimgname)){
                    if(in_array(basename($v),$oldimgname)){
                        unset($newimg[$k]);
                    }
                }
                $newimgname[] = basename($v);
            }
        }
        //  处理老图片
        if(!empty($oldimg)){
            foreach ($oldimg as $k => $v){
                if(!empty($newimgname)){
                    if(in_array(basename($v),$newimgname)){
                        unset($oldimg[$k]);
                    }
                }
            }
        }
        //  检测目录是否存在
        $img_dir = $img_dir ?: date('Y-m');
        if(!file_exists($this->UpDir. '/' .$img_dir)){
            @mkdir($this->UpDir. '/' .$img_dir,0755,true);
        }
        //  开始移动
        if(!empty($newimg)){
            if($geturl == true){
                foreach ($newimg as $k => $v){
                    if(preg_match('/http:\/\/*\??[\w=&\+\%]*/is',$v) || preg_match('/https:\/\/*\??[\w=&\+\%]*/is',$v)){
                        $newname = $this->range($v,$img_dir);
                    }elseif(preg_match('/^(data:\s*image\/(\w+);base64,)/',$v,$type)){
                        $newname = $this->base64($v,$type,$img_dir);
                    }elseif(preg_match("/{$this->UpDir}/",$v)){
                        $newname = $this->fileMove($v,$img_dir);
                    }
                    if(isset($newname)){
                        $data['newimg'] = str_ireplace($v,$newname,$data['newimg']);
                    }
                }
            }else{
                foreach ($newimg as $k => $v){
                    if(preg_match("{$this->UpDir}",$v)){
                        $newname = $this->fileMove($v,$img_dir);
                    }
                    if(isset($newname)){
                        $data['newimg'] = str_ireplace($v,$newname,$data['newimg']);
                    }
                }
            }
        }
        //  删除原有图片
        if(!empty($oldimg)){
            DelWebFile(FileEditAdd($oldimg,false));
        }
        return $data['newimg'];
    }
    /**
     * @param array|string $data 要处理的数据
     * @param string $file_dir 目标地址
     * @param string $moves 处理方式：copy为复制，rename为移动
     * @param bool $dels 是否删除源文件
     * @return array|string 返回文件地址
     */
    public function fileMove($data,$file_dir = null,$moves = 'rename',$dels=true){
        if(is_array($data)){
            foreach ($data as $key => $val){
                $newdata[$key] = $this->fileMove($val,$file_dir,$moves,$dels);
            }
            return $newdata;
        }
        if(empty($data)){
            return '';
        }
        //  查询当前用户
        $file_dir = empty($file_dir) ? date('Y-m') : $file_dir;
        /*重命名*/
        $saveName = $this->newname($data);
        $fileFix = pathinfo((string) $data, PATHINFO_EXTENSION);
        $fileName = $saveName.'.'.$fileFix;
        /*  检测文件夹是否存在 */
        if (!file_exists("{$this->UpDir}/{$file_dir}")) {
            @mkdir("{$this->UpDir}/{$file_dir}",0755,true);
        }
        /*移动文件*/
        if($moves == 'rename'){
            @rename(root_path() .$data,root_path() . $this->UpDir.'/'.$file_dir.'/'.$fileName);
        }else{
            @copy(root_path() .$data,root_path() . $this->UpDir.'/'.$file_dir.'/'.$fileName);
        }
        if($dels && $moves != 'rename'){
            @unlink(root_path().$data);
        }
        return '/'.$this->UpDir.'/'.$file_dir.'/'.$fileName;
    }
    /**
     * 定义新名称
     * @param $data
     * @return string
     */
    protected function newname($data){
        $imgmd5 = substr(md5($data.time()),0,8);
        $saveName = '';
        for ( $i = 0; $i < 10; $i++ ) {
            $saveName .= substr($imgmd5, mt_rand(0, strlen($imgmd5) - 1), 1);
        }
        return $saveName;
    }
    /**
     * 获取远程图片
     * @param $img
     * @param $imgurl
     * @return mixed|string
     */
    protected function range($img,$imgurl){
        $mimes = array(
            'image/bmp'=>'bmp',
            'image/gif'=>'gif',
            'image/jpg'=>'jpg',
            'image/jpeg'=>'jpeg',
            'image/png'=>'png',
            'image/x-icon'=>'ico'
        );
        if(($headers=get_headers($img, true))!==false) {
            // 获取响应的类型
            $type = $headers['Content-Type'];
            // 如果符合类型
            if (isset($mimes[$type])) {
                $imgmimes = $mimes[$type];
                $newname = $this->newname($img);
                $newname = $imgurl.'/'.$newname.'.'.$imgmimes;
                // 获取数据并保存
                file_put_contents("{$this->UpDir}/{$newname}", file_get_contents($img));
                return "/{$this->UpDir}/{$newname}";
            }
        }
        return $img;
    }
    /**
     * 保存BASE64图片
     * @param $img
     * @param $type
     * @param $imgurl
     * @return string
     */
    public function base64($img,$type,$imgurl){
        $imgpng = $type[2];
        $newname = $this->newname($img);
        $newname = $imgurl.'/'.$newname.'.'.$imgpng;
        if (!file_exists("{$this->LinshiDir}/{$imgurl}")) {
            @mkdir("{$this->LinshiDir}/{$imgurl}",0755,true);
        }
        file_put_contents("{$this->LinshiDir}/{$newname}", $img);
        return "/{$this->LinshiDir}/{$newname}";
    }
    public function SaveBase64($img,$img_dir = ''){
        $img_dir = empty($img_dir) ? date('Y-m',time()) : $img_dir;
        if (!file_exists($this->UpDir.$img_dir)) {
            @mkdir($this->UpDir,0777,true);
        }
        $base64_body = substr(strstr($img,','),1);
        $data = base64_decode($base64_body);
        preg_match('/^(data:\s*image\/(\w+);base64,)/',$img,$type);
        $res = $this->base64($data,$type,$img_dir);
        $res = [
            'url' => $res,
            'size' => filesize(root_path() . $res),
            'title' => basename($res),
        ];
        return $res;
    }

}