<?php
declare(strict_types = 1);
namespace app\common\imtrait;

use app\common\model\Tag;
use think\facade\Cache;
use think\template\TagLib;

class Im extends TagLib
{
    /**
     * 定义标签列表
     */
    protected $tags   =  [
        'mod'      =>    ['attr' => 'name'],
    ];
    public function tagMod($name,$content){
        if(empty($name['name'])){
            return "____请输入标签名____".$content;
        }
        //  检测是否为文本及图片模块
        if(in_array($name['mod'],['text','pic'])){
            $name['mod'] = "@{$name['mod']}@";
        }
        //  查询label条件
        $_label = $this->EditLabel($name);
        //  获取标签名称
        $_resname = $this->autoBuildVar($name['name']);
        //  重新定义标签名称
        $_label['vname'] = $_label['data']['title'] ?? $_label['data']['TagName'];
        //  如果存在用户定义模板，则注释默认模板
        $_content = $content;
        //  重新定义模板变量
        if(!empty($_label['data']['template'])){
            //  如果是调用单条数据，则为_READ_,如果是列表，则为_LIST_
            $_resname = empty($_label['data']['TagType']) ? '$_READ_' : '$_LIST_';
            $_content = "{$_label['data']['template']}<?php  /** {$content} **/ ?>";
        }
        //  处理数据条件
        $_ldata = $_label['data'];
        unset($_ldata['template']);
        //  转换条件
        $_ldata = $this->ArrayToString($_ldata);
        //  处理返回数据，检测标签是否禁用，如果禁用，则去除所有标签内容
        $_parse = " {$_resname} = IMTAG('ImTag@GetMod',[{$_ldata},'setname' => '{$_label['name']}']);";
        $_parse = isset($_label['data']['status']) && $_label['data']['status'] == '0' ?  " {$_resname} = '';" : $_parse;
        $_content = isset($_label['data']['status']) && $_label['data']['status'] == '0' ?  " <?php  /** {$content} **/ ?>" : $_content;
        return $this->ResView($_parse,$_content,$_label);
    }

    /**
     * 渲染数据到前台
     * @param $resview
     * @param $content
     * @param $label
     * @return string
     */
    protected function ResView($resview,$content,$label){
        $parse = '<?php ';
        $parse .= " {$resview}";
        $parse .= ' ?>';
        //  查询是否登录后台
        if(session('?_eru_') && cookie('__LABEL__')){
            $user = session('userdb');
            $_url = GetEruUrl('admin/Imtag/index',empty($label['data']['id']) ? ['name' => $label['name'],'t' => $label['data']['tempname']] : ['id' => $label['data']['id']]);
            $label = " {eq name=\"imuser.uid|default='0'\" value=\"{$user['uid']}\"}<div class='layout ery-pos-r'><div class='layout ery-pos-a ery-fex-c' style='top：0;z-index: 19841220'><div data-title='【{$label['vname']}】' data-uri='{$_url}' class='ery-button-s ery-bg-yellow ery-label' data-type='editlabel'>编辑【{$label['vname']}】</div></div></div>{/eq}";
            $parse .= $label;
        }
        $parse .= $content;
        return $parse;
    }

    /**
     * 格式化标签信息
     * @param $data // TagName=>标签名 TagModular=>模块名 TagMod=>模型名 TagField=> 调用字段 TagType=>调用0为单篇1为列表 TagPub=>标签是否为公用标签0为公用1为私有 TagLimit=>内容条数 TagOrder=>排序规则 conf=>更多附加规则  pages => 是否分页，如果不分页则为0
     * @return mixed
     */
    protected function EditLabel($data){
        $_tagdata = [
            'TagName' => $data['name'],
            'TagModular' => $data['modular'] ?? 'base',
            'TagMod' => $data['mod'] ?? '',
            'TagField' => $data['field'] ?? '',
            'TagType' => $data['imtype'] ?? '1',
            'TagPub' => $data['public'] ?? '0',
            'TagLimit' => $data['limit'] ?? '',
            'TagOrder' => $data['order'] ?? '',
            'conf' => []
        ];
        unset($data['name'],$data['modular'],$data['mod'],$data['field'],$data['limit'],$data['order'],$data['public'],$data['imtype']);
        $_tagdata['conf'] = $data;
        //  检测是否为标签
        $_label = $this->GetTagRead($_tagdata);
        return $_label;
    }

    /**
     * 读取标签信息，处理筛选条件
     * @param array $tagdata 获取标准标签格式
     * @param false $_label 是否为编辑模式，如果是编辑模式，则将缓存数据清除
     * @return array   返回打包好的数据
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     */
    protected function GetTagRead($tagdata){
        $request = request();
        $cname = $request->controller();
        $map = [
            'TagName' => $tagdata['TagName'],
            'TagModular' => $tagdata['TagModular'],
            'TagMod' => $tagdata['TagMod'],
            'TagType' => $tagdata['TagType'],
            'TagPub' => $tagdata['TagPub'],
            'tempname' => $request->viewconf['default_dir'],
            'model' => $request->viewconf['app'],
            'contr' => $cname,
            'action' => $request->action(),
        ];
        //  获取标签缓存  模块名-模板名-所属模块-所属模型-标签名
        $res['name'] = "{$map['model']}_{$map['tempname']}_{$map['TagModular']}_{$map['TagMod']}_{$map['TagName']}";
        if(!empty($map['TagPub'])){
            $res['name'] .= '_1';
        }
        $_tpname = Cache::has("LABEL_{$res['name']}") ? Cache::get("LABEL_{$res['name']}") : [];
        if(cookie('__LABEL__')){
            Cache::delete("LABEL_{$res['name']}");
            Cache::delete($res['name']);
            unset($_tpname);
        }
        //  读取数据库
        if(empty($_tpname)){
            unset($map['model'],$map['TagType']);
            $_m = new Tag();
            $_old = $_m->GetList($map,false);
            //  根据当前位置获取当前标签
            if(!empty($_old)){
                $_old = $_m->UntList($_old);
                $_old = !empty($map['TagModular']) ? DelFile($_old,'TagModular',$map['TagModular']) : $_old;
                $_old = DelFile($_old,'TagMod',$map['TagMod']);
                $_old = DelFile($_old,'contr',$map['contr']);
                $_old = DelFile($_old,'action',$map['action']);
                $_old = count($_old) < '1' ? [] : $_old['0'];
            } else {
                $_old = [
                    'status' => '1'
                ];
            }
            if(empty($_old['conf'])){
                unset($_old['conf']);
            }
            $_tpname = array_merge($tagdata,$map,$_old);
            switch ($_tpname['TagMod']){
                case '@text@':
                case '@pic@':
                    $_tpname['template'] = empty($_tpname['template']) ? '' : FileEditAdd($_tpname['template'],false,true);
                    break;
            }
            Cache::set("LABEL_{$res['name']}",$_tpname,3600);
        }
        $res['data'] = $_tpname;
        return $res;
    }

    /**
     * 数组转换为字符串
     * @param array $data 要处理的数组
     * @return string   返回拼接字符串
     */
    protected function ArrayToString($data){
        $res = [];
        foreach ($data as $k => $v){
            if(is_array($v)){
                $v = $this->ArrayToString($v);
                array_push($res,"'{$k}' => [{$v}]");
            } else {
                array_push($res,"'{$k}' => '{$v}'");
            }
        }
        $res = implode(',',$res);
        return $res;
    }
}