<?php
declare(strict_types = 1);
namespace app\common\imtrait;

use think\facade\{Cache,Event};

class ImTag
{
    public function GetMod($data){
        if(!empty($data['setname']) && Cache::has($data['setname'])){
            return Cache::get($data['setname']);
        }
        return $this->TagMod($data);
    }
    //  获取数据
    protected function TagMod($data){
        if($data['TagModular'] == 'base'){
            if(in_array($data['TagMod'],['@text@','@pic@'])){
                $res = $data['template'] ?? '';
            } else {
                $res = $this->GetBaseData($data);
            }
        } else {
            $res = $this->GetModData($data);
        }
        $res = FileEditAdd($res,false,true);
        if(!empty($data['setname'])){
            Cache::set($data['setname'],$res,3600);
        }
        return $res;
    }
    //  获取基本模块信息
    protected function GetBaseData($data){
        //  引入模型
        $_m = ToUnderScore($data['TagMod'],false);
        $_m = "app\\common\\model\\{$_m}";
        $_m = new $_m;
        //  获取条件
        $map = $this->EditFiledList($data);
        $res = $_m->GetList($map, (isset($data['conf']['pages']) && $data['conf']['pages'] == '0'));
        //  解压数据
        if(isset($res['total'])){
            $res['data'] = $_m->UntList($res['data']);
            if(!empty($data['TagField'])) {
                foreach ($res['data'] as $k => $v) {
                    $res['data'][$k] = DelArrayFile($v, explode(',', $data['TagField']));
                }
            }
            if(empty($data['TagType'])){
                $res = empty($res['data']['0']) ? [] : $res['data']['0'];
            }
        } else {
            $res = $_m->UntList($res);
            if(!empty($data['TagField'])) {
                foreach ($res as $k => $v) {
                    $res[$k] = DelArrayFile($v, explode(',', $data['TagField']));
                }
            }
            if(empty($data['TagType'])){
                $res = $res['0'];
            }
        }
        return $res;
    }
    //  获取指定模块信息
    protected function GetModData($data){
        $_mod = Event::trigger('Mod',['type' => 'GetMod','data' => ['mod' => $data['TagMod'],'model' => $data['TagModular']]]);
        if($_mod['0']['code'] != '1'){
            return [];
        }
        $_mod = $_mod['0']['data'];
        $_homelist = Event::trigger('Mod',['type' => 'GetHomeList','data' => ['mod' => $data['TagMod'],'model' => $data['TagModular']]]);
        if($_homelist['0']['code'] != '1'){
            return [];
        }
        $map = $this->EditFiledList($data);
        //  引入模型
        $_m = "app\\{$_mod['fid_name']}\\model\\{$_mod['name_key']}";
        $_m = new $_m;
        if(method_exists($_m,'TagMap')){
            $map = $_m->TagMap($map);
        }
        $res = $_m->GetList($map,in_array($_mod['pages'],['0']));
        //  解压数据
        if(isset($res['total'])){
            $res['data'] = $_m->UntList($res['data']);
            if(!empty($data['TagField'])) {
                foreach ($res['data'] as $k => $v) {
                    $res['data'][$k] = DelArrayFile($v, explode(',', $data['TagField']));
                }
            }
            if(empty($data['TagType'])){
                $res = empty($res['data']['0']) ? [] : $res['data']['0'];
            }
        } else {
            $res = $_m->UntList($res);
            if(!empty($data['TagField'])) {
                foreach ($res as $k => $v) {
                    $res[$k] = DelArrayFile($v, explode(',', $data['TagField']));
                }
            }
            if(empty($data['TagType'])){
                $res = $res['0'];
            }
        }
        return $res;
    }
    //  打包筛选条件
    protected function EditFiledList($data){
        $res = $data['conf'];
        $res['status'] = '1';

        if(!empty($data['TagField'])){
            $res['GetFile'] = $data['TagField'];
        }
        if(!empty($data['TagLimit'])){
            $res['limit'] = $data['TagLimit'];
        }
        if(!empty($data['TagOrder'])){
            $res['order'] = $data['TagOrder'];
        }
        return $res;
    }
}