<?php
declare(strict_types = 1);
namespace app\common\model;

class AuthRuleAccess extends R
{
    public function SetOne($data)
    {
        if(!empty($data['type']) && $data['type'] == 'del'){
            if(!$this->whereModel($data['model'])->whereFid($data['fid'])->delete()){
                return false;
            }
            return true;
        }
        $model = array_unique(array_column($data,'model'));
        $fid = array_unique(array_column($data,'fid'));
        $oldlist = $this->GetList(['model' => $model,'fid' => $fid],false);
        if(!empty($oldlist)){
            $del = [];
            foreach ($oldlist as $k => $v){
                $_v = DelFile($data,'mid',$v['mid']);
                if(empty($_v)){
                    array_push($del,$v['id']);
                    unset($oldlist[$k]);
                    continue;
                }
                $_v['0']['id'] = $v['id'];
                $oldlist[$k] = $_v['0'];
                $data = DelFile($data,'mid',$v['mid'],true);
            }
            if(!empty($oldlist)){
                if(!$this->saveAll($oldlist)){
                    return false;
                }
            }
            if(!empty($del)){
                $this->whereIn('id',$del)->delete();
            }
        }
        if(!empty($data)){
            if(!$this->saveAll($data)){
                return false;
            }
        }
        return true;
    }
    /**
     * 获取用户组全部权限
     * @param array $data 要处理的菜单项
     * @param array $auth 要处理的权限组
     * @param string $model 要处理的模块组
     * @return array|object
     */
    public function AuthList($data,$auth,$model){
        foreach ($data as &$v){
            switch ($v['type']){
                case '1':
                    $_v = DelFile($auth,'id',$v['aid']);
                    $v['base_part'] = $_v['0']['name'];
                    $v['base_part'] = empty($_v['0']['model']) ? $v['base_part'] : "{$_v['0']['model']}.{$v['base_part']}";
                    $_base_part = empty($_v['0']['model']) ? $_v['0']['name'] : "{$model}.{$_v['0']['name']}";
                    $_base_part = empty($_v['0']['model']) ? "/{$model}/{$_base_part}" : "{$_v['0']['model']}/{$_base_part}";
                    $condtion = [];
                    if(!empty($v['condtion'])){
                        $v['condtion'] = explode(',',$v['condtion']);
                        foreach ($v['condtion'] as $v1){
                            $_v1 = explode('=',$v1);
                            $condtion[$_v1['0']] = $_v1['1'];
                        }
                    }
                    $v['url'] = GetEruUrl("{$_base_part}/index",$condtion);
                    if(!empty($v['action'])){
                        $_v = explode(',',$v['action']);
                        foreach ($_v as $v1){
                            $v['action_part'][$v1] = GetEruUrl("{$_base_part}/{$v1}");
                        }
                    }
                    break;
                case '2':
                    if(!empty($v['url']) && !filter_var($v['url'],FILTER_VALIDATE_URL)){
                        $_v = explode('?',$v['url']);
                        $arr = [];
                        if(!empty($_v['1'])){
                            $_v['1'] = explode('&',$_v['1']);
                            foreach ($_v['1'] as $v1){
                                $v1 = explode('=',$v1);
                                $arr[$v1['0']] = $v1['1'] ?? '';
                            }
                        }
                        $v['url'] = GetEruUrl($_v['0'],$arr);
                    }
                    break;
            }
            unset($v['addtime'],$v['addip'],$v['sort'],$v['status']);
        }
        return $data;
    }
}