<?php
declare(strict_types = 1);
namespace app\common\model;

class Modular extends R
{
    protected function UntModel($data){
        $_m = new ModularMod();
        foreach ($data as &$v){
            $v['mod_num'] = $_m->CountList(['fid' => $v['id'],'table_type' => 'count']);
        }
        return $data;
    }
    protected function SetOneCallback($data,$Create){
        if(!$Create){
            return $data;
        }
        $webdb = GetWebdb();
        $this->AddDir($data['name'],$webdb);
        $res = $this->AddFile($data['name'],$webdb);
        if(empty($res['code'])){
            $this->whereId($data['id'])->delete();
            return false;
        }
        return $res;
    }
    //  创建项目目录
    protected function AddDir($name,$webdb){
        $_homedir = $webdb['web_template'] ?? 'default';
        $_admindir = $webdb['web_template_admin'] ?? 'default';
        $_memberdir = $webdb['web_template_member'] ?? 'default';

        $_dirlist = [
            "app/{$name}/controller/admin",
            "app/{$name}/controller/api",
            "app/{$name}/controller/member",
            "app/{$name}/model",
            "app/{$name}/config",
            "app/{$name}/route",
            "public/home/{$_homedir}/template/{$name}",
            "public/admin/{$_admindir}/template/{$name}",
            "public/member/{$_memberdir}/template/{$name}",
        ];
        foreach ($_dirlist as $v){
            if(!file_exists($v)) {
                @mkdir($v,0755,true);
            }
        }
        return true;
    }
    //  创建默认文件
    protected function AddFile($name,$webdb){
        $_homedir = $webdb['web_template'] ?? 'default';
        //  创建配置文件
        if(!file_exists("app/{$name}/config/app.php")) {
            $_php_file = "<?php \n\nreturn [ \n\n    'default_app'      => '{$name}',\n\n];";
            $res = WriteFile(base_path("{$name}/config") . 'app.php', $_php_file);
            if(empty($res['code'])){
                return $res;
            }
        }
        //  创建路由文件
        if(!file_exists("app/{$name}/route/app.php")) {
            $_php_file = "<?php
use think\\facade\\Route;

Route::get('admin$','admin.Index/index')->ext('html');
Route::get('admin/<controller>$','cms/admin.:controller/index')->ext('html');
Route::get('admin/<controller>/index$','admin.:controller/index')->ext('html');
Route::get('admin/<controller>/getlist$','admin.:controller/getlist')->ext('html');
Route::get('admin/<controller>/read$','admin.:controller/read')->ext('html');
Route::get('admin/<controller>-<id>/edit$','admin.:controller/edit')->ext('html')->pattern(['id' => '\\d+']);
Route::get('admin/<controller>-<id>$','admin.:controller/read')->ext('html')->pattern(['id' => '\\d+']);
Route::delete('admin/<controller>-<id>$','admin.:controller/del')->ext('html')->pattern(['id' => '\\d+']);
Route::put('admin/<controller>$','admin.:controller/save')->ext('html');
Route::post('admin/<controller>$','admin.:controller/save')->ext('html');
Route::rule('admin/<controller>/<action>$','admin.:controller/:action')->ext('html');

Route::get('member$','member.Index/index')->ext('html');
Route::get('member/<controller>$','member.:controller/index')->ext('html');
Route::get('member/<controller>/index$','member.:controller/index')->ext('html');
Route::get('member/<controller>/getlist$','member.:controller/getlist')->ext('html');
Route::get('member/<controller>/read$','member.:controller/read')->ext('html');
Route::get('member/<controller>-<id>/edit$','member.:controller/edit')->ext('html')->pattern(['id' => '\\d+']);
Route::get('member/<controller>-<id>$','member.:controller/read')->ext('html')->pattern(['id' => '\\d+']);
Route::delete('member/<controller>-<id>$','member.:controller/del')->ext('html')->pattern(['id' => '\\d+']);
Route::put('member/<controller>$','member.:controller/save')->ext('html');
Route::post('member/<controller>$','member.:controller/save')->ext('html');
Route::rule('member/<controller>/<action>$','member.:controller/:action')->ext('html');

Route::get('api/<controller>$','api.:controller/index')->ext('html');
Route::get('api/<controller>/index$','api.:controller/index')->ext('html');
Route::get('api/<controller>/getlist$','api.:controller/getlist')->ext('html');
Route::get('api/<controller>/read$','api.:controller/read')->ext('html');
Route::get('api/<controller>-<id>$','api.:controller/read')->ext('html')->pattern(['id' => '\\d+']);
Route::delete('api/<controller>-<id>$','api.:controller/del')->ext('html')->pattern(['id' => '\\d+']);
Route::put('api/<controller>$','api.:controller/save')->ext('html');
Route::post('api/<controller>$','api.:controller/save')->ext('html');
Route::rule('api/<controller>/<action>$','api.:controller/:action')->ext('html');

Route::get('','Index/index')->ext('html');
Route::get('<controller>$',':controller/index')->ext('html');
Route::get('<controller>/index$',':controller/index')->ext('html');
Route::get('<controller>/getlist$',':controller/getlist')->ext('html');
Route::get('<controller>/read$',':controller/read')->ext('html');
Route::get('<controller>-<id>$',':controller/read')->ext('html')->pattern(['id' => '\d+']);
Route::rule('<controller>/<action>$',':controller/:action')->ext('html');
";
            $res = WriteFile(base_path("{$name}/route") . 'app.php', $_php_file);
            if(empty($res['code'])){
                return $res;
            }
        }
        //  创建前台公用文件
        if(!file_exists("app/{$name}/controller/Base.php")) {
            $res = WriteFile(base_path("{$name}/controller") . 'Base.php', self::_phpBase($name));
            if(empty($res['code'])){
                return $res;
            }
        }
        if(!file_exists("app/{$name}/controller/Index.php")) {
            $res = WriteFile(base_path("{$name}/controller") . 'Index.php', self::_phpDefault($name));
            if(empty($res['code'])){
                return $res;
            }
        }
        //  创建后台公用文件
        if(!file_exists("app/{$name}/controller/admin/Base.php")) {
            $res = WriteFile(base_path("{$name}/controller/admin") . 'Base.php', self::_phpBase($name,'admin'));
            if(empty($res['code'])){
                return $res;
            }
        }
        //  创建API公用文件
        if(!file_exists("app/{$name}/controller/api/Base.php")) {
            $res = WriteFile(base_path("{$name}/controller/api") . 'Base.php', self::_phpBase($name,'api'));
            if(empty($res['code'])){
                return $res;
            }
        }
        //  创建会员中心公用文件
        if(!file_exists("app/{$name}/controller/member/Base.php")) {
            $res = WriteFile(base_path("{$name}/controller/member") . 'Base.php', self::_phpBase($name,'member'));
            if(empty($res['code'])){
                return $res;
            }
        }
        //  创建前台默认文件
        if(!file_exists("public/home/{$_homedir}/template/{$name}/index_index.htm")) {
            $res = WriteFile(public_path("home/{$_homedir}/template/{$name}") . 'index_index.htm', self::_htmltemp());
            if(empty($res['code'])){
                return $res;
            }
        }
        return ['code' => '1'];
    }
    // 模板文件
    protected static function _htmltemp(){
        $res = '<!doctype html>
<html lang="zh-cn">
<head>
    <meta charset="utf-8" />
    <title>{$webdb.web_title}</title>
    <meta name="keywords" content="{$webdb.web_keywords}">
    <meta name="description" content="{$webdb.web_description}" />
    <meta name="renderer" content="webkit|ie-comp|ie-stand">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <meta name="author" content="eruyun.com!ZhaoYan" />
    <link rel="shortcut icon" href="__PUBLIC__/image/favicon.png" type="image/x-icon">
    {load href="__PUBLIC__/css/eru.css"}
</head>
<body class="ery-bg-white-1">
    <div class="layout ery-fex-c ery-fex-itemsc" style="height: 100vh">
        <div class="ery-cont ery-pad-a50 ery-bg-white">
            <h1 class="ery-text-center">模块创建成功</h1>
            <h2 class="ery-text-center ery-mag-t20">{$webdb.web_title_min}</h2>
        </div>
    </div>
</body>
</html>';
        return $res;
    }
    // 基础文件
    protected static function _phpBase($dir,$name = ''){
        $_res = "namespace app\\{$dir}\\controller;";
        if(!empty($name)){
            $_res = "namespace app\\{$dir}\\controller\\{$name};";
        }
        $_use = 'HomeBase';
        switch ($name){
            case 'admin':
                $_use = 'AdminBase';
                break;
            case 'api':
                $_use = 'ApiBase';
                break;
            case 'member':
                $_use = 'MemberBase';
                break;
        }
        $res = "<?php
declare(strict_types = 1);
{$_res}

use app\\common\\controller\\{$_use};

class Base extends {$_use}
{
    protected function initialize()
    {
        parent::initialize();
    }
}";
        return $res;
    }
    protected static function _phpDefault($dir,$name = ''){
        $_res = "namespace app\\{$dir}\\controller;";
        if(!empty($name)){
            $_res = "namespace app\\{$dir}\\controller\\{$name};";
        }
        $res = "<?php
declare(strict_types = 1);
{$_res}

class Index extends Base
{
    protected function initialize()
    {
        parent::initialize();
        
       \$this->list_base['base_part'] = \"{$dir}:index\";
    }
}";
        return $res;
    }
}