<?php
declare(strict_types = 1);
namespace app\common\model;

use think\facade\{Cache,Db};

class ModularField extends R
{
    protected $_order = 'sort desc,id asc';
    protected function UntModel($data){
        //  查询所属模型
        $_fid = array_unique(array_column($data,'fid'));
        $_m = new ModularMod();
        $_fid = $_m->GetList(['id' => $_fid],false);
        $_fid = $_m->UntList($_fid);

        foreach ($data as &$v){
            $_v = DelFile($_fid,'id',$v['fid']);
            $v['fid_name'] = $_v['0']['name'] ?? '';
            $v['fid_title'] = $_v['0']['title'] ?? '';
            $v['mid'] = $_v['0']['fid'] ?? '';
            $v['mid_title'] = $_v['0']['fid_title'] ?? '';
            $v['mid_name'] = $_v['0']['fid_name'] ?? '';
        }
        return $data;
    }
    //  写入字段
    protected function SetOneCallback($data,$newadd){
        $data = $this->UntModel([$data]);
        $data = $data['0'];

        $file_list = Db::name("{$data['mid_name']}_{$data['fid_name']}")->getTableFields();
        if(in_array($data['field'],$file_list)){
            return $data;
        }
        $database = config('database');
        $DbPre = $database['connections'][$database['default']]['prefix'];

        switch ($data['sqlvalue']){
            case 'varchar':
                $sqlvalue = "varchar(255) DEFAULT NULL";
                break;
            case 'int':
                $sqlvalue = "int(11) NOT NULL DEFAULT '0'";
                break;
            case 'bigint':
                $sqlvalue = "bigint(20) NOT NULL DEFAULT '0'";
                break;
            case 'tinyint':
                $sqlvalue = "tinyint(2) NOT NULL DEFAULT '0'";
                break;
            case 'decimal':
                $sqlvalue = "decimal(32,2) unsigned NOT NULL DEFAULT '0'";
                break;
            case 'text':
                $sqlvalue = "text DEFAULT NULL";
                break;
            case 'mediumtext':
                $sqlvalue = "mediumtext DEFAULT NULL";
                break;
            case 'date':
                $sqlvalue = "date DEFAULT NULL";
                break;
            case 'time':
                $sqlvalue = "time DEFAULT NULL";
                break;
            case 'datetime':
                $sqlvalue = "datetime DEFAULT NULL";
                break;
        }

        $sql = "ALTER TABLE `{$DbPre}{$data['mid_name']}_{$data['fid_name']}` ADD `{$data['field']}` {$sqlvalue} COMMENT '{$data['title']}';";
        try {
            Db::execute($sql);
            //  查询缓存是否存在
            $tbname = ToUnderScore("{$data['mid_name']}_{$data['fid_name']}",false);
            if(Cache::has("SQLFILED_{$tbname}")){
                Cache::delete("SQLFILED_{$tbname}");
            }
        } catch(\Exception $e) {
            $this->whereId($data['id'])->delete();
            return false;
        }
        return $data;
    }
}