<?php
declare(strict_types = 1);
namespace app\common\model;

class Money extends R
{
    /**
     * 积分类型
     * 一，收入
     *      1。 注册赠送 / 活动赠送 / 推广赠送
     *          11001 注册赠送
     *          11001001 签到赠送
     *          11002001 一级推广
     *          11002002 二级推广
     *          11002003 三级推广
     *          11003001 一级返佣
     *          11003002 二级返佣
     *          11003003 三级返佣
     *          11004 活动赠送-具体活动增加对应活动码
     *      2。 发表内容 / 评论 / 加精
     *          12001 发表内容赠送-具体增加对应内容模块码
     *          12002 发表评论赠送-具体增加对应内容模块码
     *          12003 加精赠送-具体增加对应内容模块码
     *      3。 充值 / 交易收入
     *          13001 用户充值
     *          13001001 管理员充值
     *          13001002 积分互换
     *          13002 交易收入
     * 二，支出
     *      1。 提现
     *          21001 用户申请提现
     *          21001001 用户申请提现成功
     *          21001002 拒绝提现
     *      2。 交易支出 / 扣除
     *          22001 交易支出
     *          22002 管理员扣除
     */
    protected $_order = 'id desc';
    protected function UntModel($data){
        $uid = array_unique(array_column($data,'uid'));
        $puid = array_unique(array_column($data,'puid'));
        $uid = array_merge($uid,$puid);
        $_m = new User();
        $uid = $_m->GetList(['uid' => $uid],false);

        $_m = new MoneyPart();
        $part = $_m->GetList(['status' => 'a','GetFile' => 'id,title'],false);

        foreach ($data as &$v){
            $_v = DelFile($uid,'uid',$v['uid']);
            $v['u_name'] = $_v['0']['u_name'] ?? '';
            $v['u_niname'] = $_v['0']['u_niname'] ?? '';
            $v['u_phone'] = $_v['0']['u_phone'] ?? '';
            $v['u_icon'] = $_v['0']['u_icon'] ?? '';
            if(!empty($v['puid'])){
                $_v = DelFile($uid,'uid',$v['puid']);
                $v['pu_name'] = $_v['0']['u_name'] ?? '';
                $v['pu_niname'] = $_v['0']['u_niname'] ?? '';
                $v['pu_phone'] = $_v['0']['u_phone'] ?? '';
            } else {
                $v['pu_name'] = '系统消息';
                $v['pu_niname'] = '系统消息';
                $v['pu_phone'] = '';
            }

            if($v['money_type'] > '0'){
                $_v = DelFile($part,'id',$v['money_type']);
                $v['money_type_name'] = $_v['0']['title'] ?? '历史积分';
            } else {
                $v['money_type_name'] = '元/人民币';
            }
        }
        return $data;
    }
    public function NewAdd($data){
        $resdata = $this->GetMoney($data);
        $resdata['addtime'] = $data['addtime'] ?? date('Y-m-d H:i:s');
        $resdata = $this->EditAdd($resdata);
        if($res = $this->SetOne($resdata)){
            return $res;
        }
        return false;
    }
    //  用户积分计算
    public function GetMoney($data){
        $end_old = $this->whereUid($data['uid'])->whereMoneyType($data['money_type'])->order('id desc')->find();
        $old = $this->whereUid($data['uid'])->whereMoneyType($data['money_type'])->whereAddType($data['add_type'])->order('id desc')->find();
        if(empty($old)){
            $old = [
                'user_money' => '0',
                'all_money' => '0',
                'money' => '0',
            ];
        }

        if(in_array($data['add_type'],['21001','22001','22002'])){
            $old['user_money'] = empty($end_old['user_money']) ? 0 - $data['money'] : $end_old['user_money'] - $data['money'];
        } else if(in_array($data['add_type'],['21001002'])){
            $old['user_money'] = empty($end_old['user_money']) ? '0' : $end_old['user_money'];
        } else {
            $old['user_money'] = empty($end_old['user_money']) ? $data['money'] : $end_old['user_money'] + $data['money'];
        }
        $old['all_money'] = $old['all_money'] + $data['money'];
        $old = is_array($old) ? $old : $old->toArray();
        unset($old['id']);
        return array_merge($old,$data);
    }
}