<?php
declare(strict_types = 1);
namespace app\common\model;

class User extends R
{
    protected $pk = 'uid';
    protected function EditOneCallback($data){
        unset($data['u_password'],$data['u_paypassword']);
        return $data;
    }
    protected function EditAddCallback($data){
        if(!empty($data['u_password'])){
            $this->filed_list['data']['u_password'] = GetEruPwd($data['u_password'],$data['u_password']);
        }else{
            unset($this->filed_list['data']['u_password']);
        }
        return true;
    }

    protected function UntModel($data){
        //  查询用户组信息
        $_m = new UserGroup();
        $_groupid = array_unique(array_column($data,'u_groupid'));
        $_groupid = $_m->GetList(['id' => $_groupid],false);
        //  查询用户实名信息
        $_m = new UserCard();
        $_cmid = array_unique(array_column($data,'cmid'));
        $_cmid = $_m->GetList(['id' => $_cmid],false);

        //  获取用户登录信息
        $_m = new LogUser();

        foreach ($data as $k => $v){
            //  查询用户组
            $_v = DelFile($_groupid,'id',$v['u_groupid']);
            $v['group_name'] = empty($_v['0']['title']) ? '' : $_v['0']['title'];
            $v['group_icon_type'] = empty($_v['0']['icon_type']) ? '0' : $_v['0']['icon_type'];
            $v['group_icon'] = empty($_v['0']['icon']) ? '' : $_v['0']['icon'];
            //  获取用户实名信息
            $_v = empty($v['cmid']) ? [] : DelFile($_cmid,'id',$v['cmid']);
            if(!empty($_v['0'])){
                $_v = AddArrayPrefix($_v['0'],'user');
                unset($_v['user_id'],$v['user_addtime'],$v['user_edittime'],$v['user_del_time']);
                $v = array_merge($v,$_v);
            }
            //  获取用户登录信息
            $_v = $_m->GetList(['uid' => $v['uid'],'GetFile' => 'addip,addtime','limit' => '1','page' => '1']);
            $v['log_last_time'] = $_v['data']['0']['addtime'] ?? '-';
            $v['log_last_ip'] = $_v['data']['0']['addip'] ?? '-';
            unset($v['u_password'],$v['u_paypassword']);
            $data[$k] = $v;
        }

        return $data;
    }
    /**
     * 用户登录
     * @param $data 用户名或手机号码
     * @param bool $login 是否写入登录信息
     * @return array
     */
    public function Login($data,$login = true){
        $_res = $this->GetList(empty($data['u_phone']) ? ['u_name' => $data['u_name'],'status' => '1'] : ['u_phone' => $data['u_phone'],'status' => '1'],false);
        if(count($_res) < '1'){
            return ['code' => '0','msg' => '用户名或密码不正确'];
        }
        //  如果存在多个账号绑定一个手机的情况，则让用户进行选择登录
        if(!empty($data['u_phone']) && count($_res) > '0'){
            foreach ($_res as $k => $v){
                if(!empty($data['u_password'])){
                    $_v = GetEruPwd($v['u_password'],$data['u_password'],true);
                    if($_v == $data['u_password']){
                        $_res = [$v];
                        $data['u_name'] = $v['u_name'];
                        unset($data['u_phone']);
                        break;
                    }
                } else {
                    $_res[$k] = [
                        'uid' => $v['uid'],
                        'u_name' => $v['u_name'],
                        'u_niname' => $v['u_niname'],
                        'u_icon' => $v['u_icon'],
                    ];
                }
            }
            if(count($_res) > '1' && !empty($data['u_code'])){
                return ['code' => '2','msg' => '请选择要登录的账号','data' => $_res];
            }
        }
        $_res = $_res['0'];
        if(empty($data['u_phone'])){
            $_old = GetEruPwd($_res['u_password'],$data['u_password'],true);
            if($_old != $data['u_password']){
                return ['code' => '0','msg' => '用户名或密码不正确'];
            }
        }
        $_res = $this->UntList([$_res]);
        $_res = $_res['0'];
        if($_res['status'] != '1' || !empty($_res['del_time'])){
            return ['code' => '0','msg' => '用户名或密码不正确'];
        }
        return ['code' => '1','msg' => '查询成功','data' => $_res];
    }
}