<?php
declare(strict_types = 1);
namespace app\common\subscribe;

use app\common\model\{AuthRule,AuthRuleAccess,Menu};
use think\Event;
use think\facade\Cache;

class Auth
{
    public function onAll($data){
        $type = $data['type'];
        if(!method_exists($this,$type)){
            return true;
        }
        $res = $this->$type($data['data']);
        return $res;
    }
    public function subscribe(Event $event)
    {
        $event->listen('Auth', [$this,'onAll']);
    }
    //  获取用户所有权限
    /**
     * @param $data 'fid'=用户组ID,'model'=模块
     * @return array
     */
    protected function UserAuth($data)
    {
        if(!Cache::has("Auth_{$data['model']}_{$data['fid']}")){
            $_m = new AuthRuleAccess();
            $user_auth = $_m->GetList(['fid' => $data['fid'],'model' => $data['model']],false);

            $menu = array_unique(array_column($user_auth,'mid'));
            $MenuModel = new Menu();
            $menu = $MenuModel->GetList(['id' => $menu],false);
            //  查询已分配菜单
            $auth = array_unique(array_column($menu,'aid'));
            $AuthModel = new AuthRule();
            $auth = $AuthModel->GetList(['id' => $auth],false);

            $res = $_m->AuthList($menu,$auth,$data['model']);
            foreach ($res as &$v){
                $_v = DelFile($user_auth,'mid',$v['id']);
                if(empty($_v)){
                    continue;
                }
                $v['action'] = $_v['0']['artion'] ?? '';
                if(!empty($v['action'])){
                    $_v = explode(',',$v['action']);
                    $action = [];
                    foreach ($_v as $v1){
                        if(empty($v['action_part'][$v1])){
                            continue;
                        }
                        $action[$v1] = $v['action_part'][$v1];
                    }
                    $v['action_part'] = $action;
                }
            }
            Cache::set("Auth_{$data['model']}_{$data['fid']}",$res);
        }

        $res = Cache::get("Auth_{$data['model']}_{$data['fid']}");
        return $res;
    }

    /**
     * 验证权限
     * @param $data
     */
    protected function CheckAuth($data){
        $auth = $this->UserAuth(['fid' => $data['fid'],'model' => $data['model']]);
        $auth = DelFile($auth,'base_part',$data['cname']);
        $auth = $auth['0'] ?? [];
        $res = ['index' => false];
        if(empty($auth)){
            foreach ($data['check'] as $v){
                $res[$v] = false;
            }
            return $res;
        }
        $res['index'] = true;
        $action = explode(',',$auth['action']);
        foreach ($data['check'] as $v){
            $res[$v] = in_array($v,$action);
        }
        return $res;
    }
}