<?php
declare(strict_types = 1);
namespace app\common\subscribe;

use app\common\model\{Modular,ModularField,ModularMod};
use think\Event;
use think\facade\Cache;

class Mod
{
    public function onAll($data){
        $type = $data['type'];
        if(!method_exists($this,$type)){
            return true;
        }
        $res = $this->$type($data['data']);
        return $res;
    }
    public function subscribe(Event $event)
    {
        $event->listen('Mod', [$this,'onAll']);
    }
    //  后台获取模型列表
    protected function GetAdminList($data){
        $filelist = $this->GetBase($data);
        if(empty($filelist['code'])){
            return $filelist;
        }
        $res = Cache::get("MOD_{$this->modular['name']}_{$this->mod['name']}_field") ?? [];
        if(empty($res['adminlist'])){
            //  获取列表字段
            $filelist = DelFile($this->filelist,'list_show','1');
            $filelist = $this->FormatFiled($filelist,'adminlist');
            $_pk = $this->GetModPk();
            $filelist = array_merge(
                [['field' => $_pk,'title' => 'ID','width' => '80','textalign' => 'center','fixed' => 'left']],
                $filelist
            );
            if(!empty($this->mod['see_sort'])){
                array_push($filelist,
                    ['field' => 'sort','title' => '排序','type' => 'text','textalign' => 'center','width' => '100']
                );
            }
            array_push($filelist,
                ['field' => 'status','title' => '状态','type' => 'switch','text' => '启用|禁用','textalign' => 'center','width' => '100','pk' => 'id','default' => '1','list_show' => '1']
            );
            if(!empty($this->mod['see_addtime'])){
                array_push($filelist,
                    ['field' => 'addtime','title' => '添加时间','type' => 'text','textalign' => 'center','width' => '180']
                );
            }
            if(!empty($this->mod['see_addip'])){
                array_push($filelist,
                    ['field' => 'addip','title' => '添加IP','type' => 'text','textalign' => 'center','width' => '150']
                );
            }
            $searchlist = DelFile($this->filelist,'search_show','1');
            $res['adminlist'] = $filelist;
            $res['searchlist'] = $this->FormatFiled($searchlist,'adminsearch');
            Cache::set("MOD_{$this->modular['name']}_{$this->mod['name']}_field",$res);
        }
        return ['code' => '1','filelist' => $res['adminlist'],'searchlist' => $res['searchlist']];
    }
    //  后台获取模型表单
    protected function GetAdminForm($data){
        $filelist = $this->GetBase($data);
        if(empty($filelist['code'])){
            return $filelist;
        }
        $res = Cache::get("MOD_{$this->modular['name']}_{$this->mod['name']}_field") ?? [];
        if(empty($res['adminform'])){
            //  获取列表字段
            $filelist = $this->FormatFiled($this->filelist,'adminform');
            $res['adminform'] = $filelist;
            Cache::set("MOD_{$this->modular['name']}_{$this->mod['name']}_field",$res);
        }
        return ['code' => '1','filelist' => $res['adminform']];
    }
    //  前台获取模型列表
    protected function GetHomeList($data){
        $filelist = $this->GetBase($data);
        if(empty($filelist['code'])){
            return $filelist;
        }
        $res = Cache::get("MOD_{$this->modular['name']}_{$this->mod['name']}_field") ?? [];
        if(empty($res['homelist'])) {
            //  获取列表字段
            $filelist = DelFile($this->filelist, 'list_show', '1');
            $filelist = $this->FormatFiled($filelist, 'homelist');

            $_pk = $this->GetModPk();
            $filelist = array_merge(
                [['field' => $_pk, 'title' => 'ID', 'default' => '', 'unit' => '']],
                $filelist
            );
            array_push($filelist,
                ['field' => 'addtime', 'title' => '添加时间', 'default' => '', 'unit' => '']
            );
            $res['homelist'] = $filelist;
            Cache::set("MOD_{$this->modular['name']}_{$this->mod['name']}_field",$res);
        }
        return ['code' => '1','homelist' => $res['homelist']];
    }
    //  前台获取模型详情
    protected function GetHomeRead($data){
        $filelist = $this->GetBase($data);
        if(empty($filelist['code'])){
            return $filelist;
        }
        $res = Cache::get("MOD_{$this->modular['name']}_{$this->mod['name']}_field") ?? [];
        if(empty($res['homeread'])) {
            //  获取字段
            $filelist = $this->FormatFiled($this->filelist, 'homeread');

            $_pk = $this->GetModPk();
            $filelist = array_merge(
                [['field' => $_pk, 'title' => 'ID', 'default' => '', 'unit' => '']],
                $filelist
            );
            array_push($filelist,
                ['field' => 'addtime', 'title' => '添加时间', 'default' => '', 'unit' => '']
            );
            $res['homeread'] = $filelist;
            Cache::set("MOD_{$this->modular['name']}_{$this->mod['name']}_field",$res);
        }
        return ['code' => '1','homeread' => $res['homeread']];
    }
    //  后台获取模型列表
    protected function GetMemberList($data){
        $filelist = $this->GetBase($data);
        if(empty($filelist['code'])){
            return $filelist;
        }
        $res = Cache::get("MOD_{$this->modular['name']}_{$this->mod['name']}_field") ?? [];
        if(empty($res['memberlist'])){
            //  获取列表字段
            $filelist = DelFile($this->filelist,'list_show','1');
            $filelist = $this->FormatFiled($filelist,'adminlist');
            $_pk = $this->GetModPk();
            $filelist = array_merge(
                [['field' => $_pk,'title' => 'ID','width' => '80','textalign' => 'center','fixed' => 'left']],
                $filelist
            );

            array_push($filelist,
                ['field' => 'status','title' => '状态','type' => 'radio','list' => [
                    ['title' => '审核中','value' => '0'],
                    ['title' => '正常','value' => '1'],
                    ['title' => '禁用','value' => '2'],
                ],'textalign' => 'center','width' => '100','pk' => 'id','default' => '1','list_show' => '1'],
                ['field' => 'addtime','title' => '添加时间','type' => 'text','textalign' => 'center','width' => '180'],
                ['field' => 'addip','title' => '添加IP','type' => 'text','textalign' => 'center','width' => '150']
            );

            $searchlist = DelFile($this->filelist,'search_show','1');
            $res['memberlist'] = $filelist;
            $res['membersearchlist'] = $this->FormatFiled($searchlist,'memberlist');
            Cache::set("MOD_{$this->modular['name']}_{$this->mod['name']}_field",$res);
        }
        return ['code' => '1','filelist' => $res['memberlist'],'searchlist' => $res['membersearchlist']];
    }
    //  查询模型
    protected function GetMod($data){
        $mod = $this->GetBase($data);
        if(empty($mod['code'])){
            return $mod;
        }
        return ['code' => '1','data' => $this->mod];
    }
    //  查询基本信息
    protected function GetBase($data){
        $this->modular = $this->CheckModular($data['model']);
        if(empty($this->modular)){
            return ['code' => '0','msg' => '模块不存在或已禁用'];
        }
        //  查询模型信息
        $this->mod = $this->CheckMod($data['mod']);
        if(empty($this->mod)){
            return ['code' => '0','msg' => '模型不存在或已禁用','data' => ''];
        }
        //  查询模型字段
        $this->filelist = $this->CheckFile();
        if(empty($this->filelist)){
            return ['code' => '0','msg' => '暂无字段，请先创建字段','data' => ''];
        }
        return ['code' => '1','msg' => '查询成功'];
    }
    //  查询模块信息
    protected function CheckModular($modularname){
        $res = Cache::get("MODULAR") ?? [];
        if(empty($res[$modularname])){
            $_m = new Modular();
            $_res = $_m->GetList(['name' => $modularname,'status' => '1','GetFile' => 'id,title,name,status'],false);
            if(!empty($_res)){
                $_res = $_m->UntList($_res);
            }
            $_res = $_res['0'] ?? [];
            if(!empty($_res)){
                $res[$modularname] = $_res;
                Cache::set("MODULAR",$res);
            }
        }
        return $res[$modularname] ?? [];
    }
    //  查询模块信息
    protected function CheckMod($modname){
        $res = Cache::get("MOD_{$this->modular['name']}") ?? [];
        if(empty($res[$modname])){
            $_m = new ModularMod();
            $_res = $_m->GetList(['fid' => $this->modular['id'],'name' => $modname,'status' => '1','GetFile' => 'id,fid,title,name,status,open,name_key,pages,list_order,see_sort,see_addtime,see_addip'],false);
            if(!empty($_res)){
                $_res = $_m->UntList($_res);
            }
            $_res = $_res['0'] ?? [];

            if(!empty($_res)){
                $res[$modname] = $_res;
                Cache::set("MOD_{$this->modular['name']}",$res);
            }
        }
        return $res[$modname] ?? [];
    }
    //  查询模型字段
    protected function CheckFile(){
        $res = Cache::get("MOD_{$this->modular['name']}_{$this->mod['name']}_field") ?? [];
        if(empty($res['zone'])){
            $_m = new ModularField();
            $res['zone'] = $_m->GetList(['fid' => $this->mod['id'],'status' => '1','GetFile' => 'id,fid,title,field,type,required,required_list,default,list,unit,tip,sort,geturl,fielddata,gettype,list_show,search_show,group'],false);
            if(!empty($res['zone'])){
                $res['zone'] = $_m->UntList($res['zone']);
                Cache::set("MOD_{$this->modular['name']}_{$this->mod['name']}_field",$res);
            }
        }
        return $res['zone'];
    }
    //  标准化字段
    protected function FormatFiled($data,$type = 'form'){
        foreach ($data as &$v) {
            if(in_array($v['type'],['select','radio']) ){
                if($v['type'] == 'select'){
                    $v['text'] = true;
                }
                if(!empty($v['list'])) {
                    $v['list'] = DataTrim(explode("\r\n",str_replace(["\r\n", "\r", "\n"], "\r\n", $v['list'])));
                    foreach ($v['list'] as $k1 => $v1) {
                        $_v = DataTrim(explode('|', $v1));
                        if (count($_v) > '1') {
                            $v1 = [
                                'value' => $_v['0'],
                                'title' => $_v['1'],
                            ];
                        } else {
                            $v1 = [
                                'value' => $v1,
                                'title' => $v1,
                            ];
                        }
                        $v['list'][$k1] = $v1;
                    }
                }
            }
            unset($v['id'], $v['fid'],$v['sort']);
            switch ($type){
                case 'adminform':
                    unset($v['list_show'],$v['search_show']);
                    break;
                case 'adminlist':
                case 'adminsearch':
                case 'memberlist':
                    unset($v['required'], $v['required_list'],$v['tip'],$v['gettype'],$v['group'],$v['list_show'],$v['search_show']);
                    if($type == 'adminsearch' && in_array($v['type'],['radio'])){
                        $v['type'] = 'select';
                    }
                    break;
                case 'homeread':
                case 'homelist':
                    unset($v['type'],$v['required'], $v['required_list'],$v['tip'],$v['list'],$v['geturl'],$v['fielddata'],$v['gettype'],$v['group'],$v['list_show'],$v['search_show']);
                    break;
            }
        }
        return $data;
    }
    //  查询数据表主键
    protected function GetModPk(){
        //  查询主键
        $_m = 'app\\' . $this->mod['fid_name'] ."\\model\\" . $this->mod['name_key'];
        $_m = new $_m;
        return $_m->getPk();
    }
}