<?php
declare(strict_types = 1);
namespace app\common\subscribe;

use app\common\model\LogUser;
use think\Event;

class User
{
    public function onAll($data){
        $type = $data['type'];
        if(!method_exists($this,$type)){
            return true;
        }
        $res = $this->$type($data['data']);
        return $res;
    }
    public function subscribe(Event $event)
    {
        $event->listen('User', [$this,'onAll']);
    }
    //  登录成功
    protected function Success($data)
    {
        $this->SetUserData($data);
        $this->SetUserLog($data);
        return true;
    }
    //  登录失败
    protected function Error($data)
    {
        $this->SetUserLog($data,true);
        return true;
    }
    //  保存用户缓存
    protected function SetUserData($data){
        session('userdb', $data);
        if(request()->viewconf['app'] == 'admin'){
            session('_eru_', 'admin');
        }
    }
    //  记录登录日志
    protected function SetUserLog($data,$error = false){
        $_name = empty($data['u_name']) ? $data['u_phone'] : $data['u_name'];
        $_pwd = $data['u_password'] ?? '';
        $_pwd = empty($data['u_code']) ? $_pwd : $data['u_code'];
        $_add = [
            'uid' => $error ? '' : $data['uid'],
            'type' => app('http')->getname(),
            'title' =>  $error ? '用户登录失败' : '用户登录成功',
            'cont' => $error ? "用户名: {$_name}, 密码： {$_pwd}" : '密码已加密',
        ];
        $_m = new LogUser();
        $_add = $_m->EditAdd($_add);
        $_m->SetOne($_add);
        return true;
    }
    //  退出登录
    protected function OutUser(){
        session('userdb',null);
        if(request()->viewconf['app'] == 'admin'){
            session('_eru_',null);
        }
        return true;
    }
}