<?php
declare(strict_types = 1);
namespace app\hook\controller;

use support\Request;
use Webman\Captcha\CaptchaBuilder;

class Captcha extends Base
{
    public function index(Request $request){
        // 初始化验证码类CaptchaBuilder
        $builder = new CaptchaBuilder();
        //  取第一个随机数
        $one = mt_rand(1, 30);
        $two = $one < 10 ? mt_rand(11, 30) : mt_rand(1, 10);
        // 生成验证码
        $builder->setPhrase("{$one} + {$two} =");
        $builder->setMaxFrontLines(0);
        $builder->setMaxAngle(1);
        $builder->setMaxOffset(1);
        $builder->setBackgroundColor(243, 251, 254);
        $builder->build();
        // 将验证码的值存储到session中
        $request->session()->set('captcha', $one + $two);
        // 获得验证码图片二进制数据
        $img_content = $builder->get();
        // 输出验证码二进制数据
        return response($img_content, 200, ['Content-Type' => 'image/jpeg']);
    }
}