DROP TABLE IF EXISTS im_advert_ad;
CREATE TABLE `im_advert_ad` (
                                `id` bigint(20) NOT NULL AUTO_INCREMENT,
                                `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                                `uid` bigint(20) DEFAULT '0' COMMENT '用户UID',
                                `status` tinyint(4) DEFAULT '0' COMMENT '状态，0=>草稿，1=>启用，2=>禁用',
                                `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                                `edittime` datetime DEFAULT NULL COMMENT '编辑时间',
                                `del_time` datetime DEFAULT NULL COMMENT '删除时间',
                                `addip` varchar(255) DEFAULT NULL COMMENT '添加IP',
                                `ropt` int(11) DEFAULT NULL COMMENT '端口',
                                `title` varchar(255) DEFAULT NULL COMMENT '广告名称',
                                `class` tinyint(2) NOT NULL DEFAULT '0' COMMENT '广告类型',
                                `cont` text COMMENT '广告内容',
                                `sort` int(11) DEFAULT '0',
                                PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='广告管理表';

DROP TABLE IF EXISTS im_auth_rule;
CREATE TABLE `im_auth_rule` (
                                `id` int(11) NOT NULL AUTO_INCREMENT,
                                `title` varchar(80) NOT NULL COMMENT '权限名称',
                                `name` varchar(150) DEFAULT NULL COMMENT '权限地址',
                                `model` varchar(60) DEFAULT '0' COMMENT '所属模块',
                                `status` int(11) DEFAULT '0' COMMENT '是否启用，0为禁用，1为启用',
                                `sort` int(11) DEFAULT '0' COMMENT '排序值从大到小',
                                `edittime` datetime DEFAULT NULL,
                                PRIMARY KEY (`id`),
                                KEY `status` (`status`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='权限表';

DROP TABLE IF EXISTS im_auth_rule_access;
CREATE TABLE `im_auth_rule_access` (
                                       `id` bigint(20) NOT NULL AUTO_INCREMENT,
                                       `fid` int(11) DEFAULT NULL COMMENT '角色ID',
                                       `mid` int(11) DEFAULT NULL COMMENT '权限ID',
                                       `artion` text COMMENT '子权限',
                                       `model` varchar(30) DEFAULT NULL COMMENT '所属模块',
                                       PRIMARY KEY (`id`),
                                       KEY `mid` (`mid`),
                                       KEY `fid` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户组权限中间表';

DROP TABLE IF EXISTS im_cms_article;
CREATE TABLE `im_cms_article` (
                                  `id` bigint(20) NOT NULL AUTO_INCREMENT,
                                  `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                                  `uid` bigint(20) DEFAULT '0' COMMENT '用户UID',
                                  `sort` int(11) DEFAULT '0' COMMENT '排序',
                                  `status` tinyint(4) DEFAULT '0' COMMENT '状态，0=>草稿，1=>启用，2=>禁用',
                                  `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                                  `edittime` datetime DEFAULT NULL COMMENT '编辑时间',
                                  `del_time` datetime DEFAULT NULL COMMENT '删除时间',
                                  `addip` varchar(255) DEFAULT NULL COMMENT '添加IP',
                                  `ropt` int(11) DEFAULT NULL COMMENT '端口',
                                  `title` varchar(255) DEFAULT NULL COMMENT '文章标题',
                                  `cont` mediumtext COMMENT '内容',
                                  `description` text COMMENT 'SEO简介',
                                  `picurl` varchar(255) DEFAULT NULL COMMENT '封面图',
                                  `keywords` varchar(255) DEFAULT NULL COMMENT 'SEO关键词',
                                  `fid` int(11) NOT NULL DEFAULT '0' COMMENT '所属分类',
                                  `hist` int(11) NOT NULL DEFAULT '0' COMMENT '浏览量',
                                  `top` tinyint(2) NOT NULL DEFAULT '0' COMMENT '推荐',
                                  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='文章管理表';

DROP TABLE IF EXISTS im_cms_goodpart;
CREATE TABLE `im_cms_goodpart` (
                                   `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
                                   `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                                   `uid` bigint(20) DEFAULT '0' COMMENT '用户UID',
                                   `sort` int(11) DEFAULT '0' COMMENT '排序',
                                   `status` tinyint(4) DEFAULT '0' COMMENT '状态，0=>草稿，1=>启用，2=>禁用',
                                   `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                                   `edittime` datetime DEFAULT NULL COMMENT '编辑时间',
                                   `del_time` datetime DEFAULT NULL COMMENT '删除时间',
                                   `addip` varchar(255) DEFAULT NULL COMMENT '添加IP',
                                   `ropt` int(11) DEFAULT NULL COMMENT '端口',
                                   `title` varchar(255) DEFAULT NULL COMMENT '栏目名称',
                                   `pid` int(11) NOT NULL DEFAULT '0' COMMENT '上级栏目',
                                   `pidsee` tinyint(2) NOT NULL DEFAULT '0' COMMENT '上级栏目显示',
                                   `list_num` int(11) NOT NULL DEFAULT '0' COMMENT '列表显示',
                                   `title_num` int(11) NOT NULL DEFAULT '0' COMMENT '内容标题显示',
                                   `cont_num` int(11) NOT NULL DEFAULT '0' COMMENT '内容简介显示',
                                   `jumpurl` varchar(255) DEFAULT NULL COMMENT '跳转地址',
                                   `keywords` varchar(255) DEFAULT NULL COMMENT 'SEO关键词',
                                   `description` text COMMENT 'SEO简介',
                                   `banner` varchar(255) DEFAULT NULL COMMENT 'BANNER',
                                   `logo` varchar(255) DEFAULT NULL COMMENT 'LOGO',
                                   `password` varchar(255) DEFAULT NULL COMMENT '栏目密码',
                                   `temp_late` varchar(255) DEFAULT NULL COMMENT '列表样式',
                                   `temp_list` varchar(255) DEFAULT NULL COMMENT '自订义列表页',
                                   `temp_cont` varchar(255) DEFAULT NULL COMMENT '自订义内容页',
                                   PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='产品分类表';

DROP TABLE IF EXISTS im_cms_goods;
CREATE TABLE `im_cms_goods` (
                                `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
                                `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                                `uid` bigint(20) DEFAULT '0' COMMENT '用户UID',
                                `sort` int(11) DEFAULT '0' COMMENT '排序',
                                `status` tinyint(4) DEFAULT '0' COMMENT '状态，0=>草稿，1=>启用，2=>禁用',
                                `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                                `edittime` datetime DEFAULT NULL COMMENT '编辑时间',
                                `del_time` datetime DEFAULT NULL COMMENT '删除时间',
                                `addip` varchar(255) DEFAULT NULL COMMENT '添加IP',
                                `ropt` int(11) DEFAULT NULL COMMENT '端口',
                                `title` varchar(255) DEFAULT NULL COMMENT '产品名称',
                                `cont` mediumtext COMMENT '产品介绍',
                                `fid` int(11) NOT NULL DEFAULT '0' COMMENT '产品分类',
                                `keywords` varchar(255) DEFAULT NULL COMMENT 'SEO关键词',
                                `description` text COMMENT 'SEO简介',
                                `hist` int(11) NOT NULL DEFAULT '0' COMMENT '浏览量',
                                `top` tinyint(2) NOT NULL DEFAULT '0' COMMENT '推荐',
                                `imgdata` text COMMENT '产品图集',
                                `money` decimal(32,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '价格',
                                PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='产品管理表';

DROP TABLE IF EXISTS im_cms_part;
CREATE TABLE `im_cms_part` (
                               `id` bigint(20) NOT NULL AUTO_INCREMENT,
                               `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                               `uid` bigint(20) DEFAULT '0' COMMENT '用户UID',
                               `sort` int(11) DEFAULT '0' COMMENT '排序',
                               `status` tinyint(4) DEFAULT '0' COMMENT '状态，0=>草稿，1=>启用，2=>禁用',
                               `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                               `edittime` datetime DEFAULT NULL COMMENT '编辑时间',
                               `del_time` datetime DEFAULT NULL COMMENT '删除时间',
                               `addip` varchar(255) DEFAULT NULL COMMENT '添加IP',
                               `ropt` int(11) DEFAULT NULL COMMENT '端口',
                               `title` varchar(255) DEFAULT NULL COMMENT '栏目名称',
                               `pid` int(11) NOT NULL DEFAULT '0' COMMENT '上级栏目',
                               `pid_see` tinyint(2) NOT NULL DEFAULT '0' COMMENT '上级栏目显示',
                               `list_num` int(11) NOT NULL DEFAULT '0' COMMENT '列表显示',
                               `title_num` int(11) NOT NULL DEFAULT '0' COMMENT '内容标题显示',
                               `cont_num` int(11) NOT NULL DEFAULT '0' COMMENT '内容简介显示',
                               `jumpurl` varchar(255) DEFAULT NULL COMMENT '跳转地址',
                               `keywords` varchar(255) DEFAULT NULL COMMENT 'SEO关键词',
                               `description` text COMMENT 'SEO简介',
                               `banner` varchar(255) DEFAULT NULL COMMENT 'BANNER',
                               `logo` varchar(255) DEFAULT NULL COMMENT 'LOGO',
                               `password` varchar(255) DEFAULT NULL COMMENT '栏目密码',
                               `temp_late` varchar(255) DEFAULT NULL COMMENT '列表样式',
                               `temp_list` varchar(255) DEFAULT NULL COMMENT '自订义列表页',
                               `temp_cont` varchar(255) DEFAULT NULL COMMENT '自订义内容页',
                               `articleorder` varchar(255) DEFAULT NULL COMMENT '排序规则',
                               PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='栏目管理表';

DROP TABLE IF EXISTS im_cms_show;
CREATE TABLE `im_cms_show` (
                               `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID',
                               `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                               `uid` bigint(20) DEFAULT '0' COMMENT '用户UID',
                               `sort` int(11) DEFAULT '0' COMMENT '排序',
                               `status` tinyint(4) DEFAULT '0' COMMENT '状态，0=>草稿，1=>启用，2=>禁用',
                               `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                               `edittime` datetime DEFAULT NULL COMMENT '编辑时间',
                               `del_time` datetime DEFAULT NULL COMMENT '删除时间',
                               `addip` varchar(255) DEFAULT NULL COMMENT '添加IP',
                               `ropt` int(11) DEFAULT NULL COMMENT '端口',
                               `title` varchar(255) DEFAULT NULL COMMENT '标题',
                               `cont` mediumtext COMMENT '内容',
                               `keywords` varchar(255) DEFAULT NULL COMMENT 'SEO关键词',
                               `description` text COMMENT 'SEO简介',
                               `template` varchar(255) DEFAULT NULL COMMENT '页面模板',
                               PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='单篇内容表';

DROP TABLE IF EXISTS im_config;
CREATE TABLE `im_config` (
                             `id` int(11) NOT NULL AUTO_INCREMENT,
                             `fid` int(11) DEFAULT NULL COMMENT '配置分类',
                             `title` varchar(80) DEFAULT NULL COMMENT '配置名称',
                             `field` varchar(50) DEFAULT NULL COMMENT '配置字段名',
                             `conf_value` text COMMENT '配置值',
                             `type` varchar(30) DEFAULT NULL COMMENT '表单类型',
                             `required` tinyint(4) DEFAULT NULL COMMENT '是否必填',
                             `required_list` varchar(100) DEFAULT NULL COMMENT '验证规则',
                             `default` varchar(255) DEFAULT NULL COMMENT '默认值',
                             `list` text COMMENT '可选值',
                             `unit` varchar(80) DEFAULT NULL COMMENT '单位',
                             `tip` varchar(255) DEFAULT NULL COMMENT '提示信息',
                             `sort` int(11) DEFAULT '0' COMMENT '排序',
                             `status` tinyint(4) DEFAULT NULL COMMENT '启用状态',
                             `geturl` varchar(255) DEFAULT NULL COMMENT '数据请求地址',
                             `fielddata` varchar(255) DEFAULT NULL COMMENT '自订义变量',
                             `gettype` tinyint(4) DEFAULT '0' COMMENT '调用类型',
                             `private` tinyint(4) DEFAULT '0' COMMENT '参数类型，私有参数不分配至前台0为公用1为私有',
                             PRIMARY KEY (`id`),
                             KEY `fid` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='配置表';

DROP TABLE IF EXISTS im_config_part;
CREATE TABLE `im_config_part` (
                                  `id` int(11) NOT NULL AUTO_INCREMENT,
                                  `icon` varchar(80) DEFAULT NULL COMMENT '分类图标',
                                  `title` varchar(50) DEFAULT NULL COMMENT '分类名称',
                                  `sort` int(11) DEFAULT NULL COMMENT '排序值',
                                  `status` tinyint(4) DEFAULT '0' COMMENT '状态',
                                  `addtime` datetime DEFAULT NULL,
                                  `edittime` datetime DEFAULT NULL,
                                  `del_time` datetime DEFAULT NULL,
                                  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='配置分类表';

DROP TABLE IF EXISTS im_config_up;
CREATE TABLE `im_config_up` (
                                `id` int(11) NOT NULL AUTO_INCREMENT,
                                `edition_no` varchar(50) DEFAULT NULL COMMENT '版本号',
                                `edition_uri` varchar(255) DEFAULT NULL COMMENT '压缩包地址',
                                `cont` mediumtext,
                                `files` mediumtext,
                                `status` tinyint(4) DEFAULT '0',
                                `addtime` datetime DEFAULT NULL,
                                `edittime` datetime DEFAULT NULL,
                                PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='系统升级表';

DROP TABLE IF EXISTS im_eru_tag;
CREATE TABLE `im_eru_tag` (
                              `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
                              `cid` int(11) DEFAULT '0' COMMENT '企业ID',
                              `uid` int(11) DEFAULT '0' COMMENT '用户ID',
                              `title` varchar(80) DEFAULT NULL COMMENT '标题',
                              `TagName` varchar(255) DEFAULT NULL COMMENT '标签名',
                              `TagModular` varchar(80) DEFAULT NULL COMMENT '模块',
                              `TagMod` varchar(255) DEFAULT 'base' COMMENT '模型',
                              `TagField` varchar(255) DEFAULT NULL COMMENT '字段',
                              `TagLimit` int(11) DEFAULT '0' COMMENT '条数',
                              `TagOrder` varchar(255) DEFAULT NULL COMMENT '排序',
                              `TagType` tinyint(4) DEFAULT '0' COMMENT '调用类型0为单条记录，1为多条记录',
                              `TagPub` tinyint(4) DEFAULT '0' COMMENT '是否为公用模板，0为私有，1为公用',
                              `tempname` varchar(255) DEFAULT NULL COMMENT '所在模板名称',
                              `contr` varchar(255) DEFAULT NULL COMMENT '所在模板控制器',
                              `action` varchar(255) DEFAULT NULL COMMENT '所在模板方法',
                              `status` tinyint(4) NOT NULL DEFAULT '1' COMMENT '是否启用',
                              `latename` varchar(255) DEFAULT NULL COMMENT '调用模板名称',
                              `template` mediumtext COMMENT '模板代码',
                              `conf` mediumtext COMMENT '附加配置',
                              `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                              `edittime` datetime DEFAULT NULL COMMENT '修改时间',
                              `del_time` datetime DEFAULT NULL,
                              PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='新模板标签管理';

DROP TABLE IF EXISTS im_link;
CREATE TABLE `im_link` (
                           `id` int(11) NOT NULL AUTO_INCREMENT,
                           `pid` int(11) DEFAULT '0' COMMENT '上级ID',
                           `fid` int(11) DEFAULT '0' COMMENT '分类ID',
                           `title` varchar(100) DEFAULT NULL COMMENT '链接名称',
                           `url` varchar(255) DEFAULT NULL COMMENT '链接地址',
                           `target` tinyint(4) DEFAULT '0' COMMENT '是否在新窗口打开',
                           `icon_type` tinyint(4) DEFAULT '0' COMMENT '图标类型',
                           `icon` varchar(255) DEFAULT NULL COMMENT '图标或者图片',
                           `sort` int(11) DEFAULT '0' COMMENT '排序',
                           `status` tinyint(4) DEFAULT '0' COMMENT '是否启用',
                           `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                           `edittime` datetime DEFAULT NULL COMMENT '修改时间',
                           PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='链接管理表';

DROP TABLE IF EXISTS im_link_part;
CREATE TABLE `im_link_part` (
                                `id` int(11) NOT NULL AUTO_INCREMENT,
                                `title` varchar(100) DEFAULT NULL COMMENT '分类标题',
                                `sort` int(11) DEFAULT '0' COMMENT '排序',
                                `status` tinyint(4) DEFAULT '0' COMMENT '状态',
                                `type` tinyint(4) DEFAULT '0' COMMENT '是否启用子链接',
                                `class` int(11) DEFAULT '0' COMMENT '分类',
                                `addtime` datetime DEFAULT NULL,
                                `edittime` datetime DEFAULT NULL,
                                PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='链接分类';

DROP TABLE IF EXISTS im_log_operate;
CREATE TABLE `im_log_operate` (
                                  `id` bigint(20) NOT NULL AUTO_INCREMENT,
                                  `title` varchar(50) DEFAULT NULL COMMENT '操作类型',
                                  `name` varchar(50) DEFAULT NULL COMMENT '操作模块',
                                  `cont` varchar(100) DEFAULT NULL COMMENT '操作模型',
                                  `uid` bigint(20) DEFAULT '0' COMMENT '操作人',
                                  `aid` varchar(255) DEFAULT NULL COMMENT 'ID',
                                  `addtime` datetime DEFAULT NULL,
                                  `addip` varchar(50) DEFAULT NULL,
                                  `ropt` int(11) DEFAULT '0' COMMENT '端口号',
                                  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='操作记录';

DROP TABLE IF EXISTS im_log_user;
CREATE TABLE `im_log_user` (
                               `id` bigint(20) NOT NULL AUTO_INCREMENT,
                               `uid` bigint(20) NOT NULL DEFAULT '0',
                               `title` varchar(150) DEFAULT NULL,
                               `cont` text,
                               `type` varchar(30) NOT NULL DEFAULT '0',
                               `addip` varchar(50) NOT NULL DEFAULT '0' COMMENT '登录IP',
                               `addtime` datetime NOT NULL COMMENT '登录时间',
                               `del_time` datetime DEFAULT NULL,
                               `ropt` int(11) DEFAULT NULL,
                               PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='登录日志';

DROP TABLE IF EXISTS im_menu;
CREATE TABLE `im_menu` (
                           `id` int(11) NOT NULL AUTO_INCREMENT,
                           `type` tinyint(4) DEFAULT '0' COMMENT '菜单类型0为分组1为菜单',
                           `pid` int(11) DEFAULT '0' COMMENT '上级ID',
                           `aid` int(11) DEFAULT '0' COMMENT '权限ID',
                           `action` varchar(255) DEFAULT NULL COMMENT '操作权限',
                           `fid` int(11) DEFAULT '0' COMMENT '所属分类',
                           `icon_type` tinyint(4) DEFAULT '0' COMMENT '图标类型',
                           `icon` varchar(80) DEFAULT NULL COMMENT '图标',
                           `url` varchar(255) DEFAULT NULL COMMENT '跳转地址',
                           `title` varchar(150) DEFAULT NULL COMMENT '菜单名称',
                           `condtion` varchar(255) DEFAULT NULL COMMENT '附加规则',
                           `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                           `edittime` datetime DEFAULT NULL COMMENT '修改时间',
                           `addip` varchar(50) DEFAULT NULL COMMENT '操作IP',
                           `sort` int(11) DEFAULT '0' COMMENT '排序 ',
                           `status` int(11) DEFAULT '0' COMMENT '是否启用',
                           `mapsee` tinyint(4) DEFAULT '0' COMMENT '是否显示在桌面',
                           PRIMARY KEY (`id`),
                           KEY `im_menu_fid_index` (`fid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='菜单管理表';

DROP TABLE IF EXISTS im_menu_part;
CREATE TABLE `im_menu_part` (
                                `id` int(11) NOT NULL AUTO_INCREMENT,
                                `title` varchar(80) DEFAULT NULL COMMENT '分类名称',
                                `fid` varchar(255) DEFAULT NULL COMMENT '所属用户组分类',
                                `sort` int(11) NOT NULL DEFAULT '0' COMMENT '排序',
                                `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '是否启用',
                                `model` varchar(255) DEFAULT NULL COMMENT '对应模块',
                                `addtime` datetime DEFAULT NULL,
                                `edittime` datetime DEFAULT NULL,
                                `del_time` datetime DEFAULT NULL,
                                PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='系统菜单分类表';

DROP TABLE IF EXISTS im_modular;
CREATE TABLE `im_modular` (
                              `id` int(11) NOT NULL AUTO_INCREMENT,
                              `title` varchar(100) DEFAULT NULL COMMENT '模块名称',
                              `name` varchar(100) DEFAULT NULL COMMENT '模块名称，仅接受英文',
                              `addtime` datetime DEFAULT NULL,
                              `edittime` datetime DEFAULT NULL,
                              `del_time` datetime DEFAULT NULL,
                              `sort` int(11) DEFAULT '0',
                              `status` tinyint(4) DEFAULT '0',
                              PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='系统模块';

DROP TABLE IF EXISTS im_modular_field;
CREATE TABLE `im_modular_field` (
                                    `id` bigint(20) NOT NULL AUTO_INCREMENT,
                                    `fid` int(11) DEFAULT '0' COMMENT '模型ID',
                                    `title` varchar(200) DEFAULT NULL COMMENT '字段名',
                                    `field` varchar(100) DEFAULT NULL COMMENT '字段键',
                                    `sqlvalue` varchar(255) DEFAULT NULL COMMENT 'SQL语句',
                                    `type` varchar(50) DEFAULT NULL COMMENT '表单类型',
                                    `required` tinyint(4) DEFAULT '0' COMMENT '是否为必填项',
                                    `required_list` varchar(100) DEFAULT NULL COMMENT '验证规则',
                                    `default` varchar(255) DEFAULT NULL COMMENT '默认值',
                                    `list` text COMMENT '可选项列表',
                                    `unit` varchar(30) DEFAULT NULL COMMENT '字段单位',
                                    `tip` varchar(255) DEFAULT NULL COMMENT '提示信息',
                                    `sort` int(11) DEFAULT '0' COMMENT '排序值',
                                    `status` tinyint(4) DEFAULT '0' COMMENT '状态',
                                    `geturl` varchar(255) DEFAULT NULL COMMENT '数据请求地址',
                                    `fielddata` varchar(255) DEFAULT NULL COMMENT '自订义变量',
                                    `gettype` tinyint(4) DEFAULT '0' COMMENT '调用类型',
                                    `addtime` datetime DEFAULT NULL,
                                    `edittime` datetime DEFAULT NULL,
                                    `del_time` datetime DEFAULT NULL,
                                    `list_show` tinyint(4) DEFAULT '0' COMMENT '是否在列表显示',
                                    `search_show` tinyint(4) DEFAULT '0' COMMENT '是否启用搜索',
                                    `group` varchar(100) DEFAULT NULL COMMENT '字段分组',
                                    PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='模型字段表';

DROP TABLE IF EXISTS im_modular_mod;
CREATE TABLE `im_modular_mod` (
                                  `id` int(11) NOT NULL AUTO_INCREMENT,
                                  `fid` int(11) DEFAULT NULL COMMENT '模块ID',
                                  `title` varchar(100) DEFAULT NULL COMMENT '模型名称',
                                  `open` varchar(255) DEFAULT NULL COMMENT '开放接口',
                                  `name` varchar(50) DEFAULT NULL COMMENT '模型URL',
                                  `name_key` varchar(50) DEFAULT NULL COMMENT '控制器名',
                                  `pages` tinyint(4) DEFAULT '0' COMMENT '列表分页显示方式',
                                  `list_order` varchar(100) DEFAULT NULL COMMENT '列表排序方式',
                                  `see_sort` tinyint(4) DEFAULT '0' COMMENT '列表排序显示状态，0为不显示，1为显示',
                                  `see_addtime` tinyint(4) DEFAULT '0' COMMENT '列表添加时间显示状态，0为不显示，1为显示',
                                  `see_addip` tinyint(4) DEFAULT '0' COMMENT '列表添加IP显示状态，0为不显示，1为显示',
                                  `sort` int(11) DEFAULT '0',
                                  `status` tinyint(4) DEFAULT '0',
                                  `addtime` datetime DEFAULT NULL,
                                  `edittime` datetime DEFAULT NULL,
                                  `del_time` datetime DEFAULT NULL,
                                  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='控制路由表';

DROP TABLE IF EXISTS im_money;
CREATE TABLE `im_money` (
                            `id` bigint(20) NOT NULL AUTO_INCREMENT,
                            `cid` bigint(20) DEFAULT '0' COMMENT '企业ID',
                            `pid` bigint(20) DEFAULT '0' COMMENT '提现ID',
                            `oid` varchar(50) DEFAULT NULL COMMENT '订单号',
                            `uid` int(11) DEFAULT NULL COMMENT '用户UID',
                            `puid` int(11) DEFAULT '0' COMMENT '产生积分对应用户UID',
                            `add_type` int(11) DEFAULT NULL COMMENT '11001 注册赠送,11001001 签到赠送,11002001 一级推广,11002002 二级推广,11002003 三级推广,11003001 一级返佣,11003002 二级返佣,11003003 三级返佣,11004 活动赠送-具体活动增加对应活动码,12001 发表内容赠送-具体增加对应内容模块码,12002 发表评论赠送-具体增加对应内容模块码,12003 加精赠送-具体增加对应内容模块码,13001 用户充值,13001001 管理员充值,13001002 积分互换,13002 交易收入,21001 用户申请提现,21001001 用户申请提现成功,21001002 拒绝提现,22001 交易支出,22002 管理员扣除',
                            `money_type` int(11) DEFAULT '0' COMMENT '0为人民币，1为基础积分，其余为扩展积分',
                            `user_money` decimal(10,2) unsigned DEFAULT '0.00' COMMENT '用户余额',
                            `all_money` decimal(10,2) unsigned DEFAULT '0.00' COMMENT '当前类型消费汇总',
                            `money` decimal(10,2) unsigned DEFAULT '0.00' COMMENT '当前交易金额',
                            `cont` text COMMENT '积分说明',
                            `addtime` datetime DEFAULT NULL,
                            `addip` varchar(20) DEFAULT NULL,
                            `status` tinyint(4) DEFAULT '0' COMMENT '状态：0->未提现1->已提现2->冻结',
                            `ropt` int(11) DEFAULT '0' COMMENT '端口号',
                            PRIMARY KEY (`id`),
                            KEY `uid` (`uid`),
                            KEY `pid` (`pid`),
                            KEY `add_type` (`add_type`),
                            KEY `money_type` (`money_type`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户积分表';

DROP TABLE IF EXISTS im_money_part;
CREATE TABLE `im_money_part` (
                                 `id` int(11) NOT NULL AUTO_INCREMENT,
                                 `title` varchar(50) DEFAULT NULL COMMENT '积分名称',
                                 `to_rmb` int(11) DEFAULT '0' COMMENT '人民币兑换比例',
                                 `rmb_to` int(11) DEFAULT '0' COMMENT '总换人民币比例',
                                 `sort` int(11) DEFAULT '0' COMMENT '排序',
                                 `status` tinyint(4) DEFAULT '0' COMMENT '是否启用0为禁用，1为启用',
                                 `del_time` datetime DEFAULT NULL,
                                 `addtime` datetime DEFAULT NULL,
                                 `edittime` datetime DEFAULT NULL,
                                 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户积分类型表';

DROP TABLE IF EXISTS im_user;
CREATE TABLE `im_user` (
                           `uid` bigint(20) NOT NULL AUTO_INCREMENT,
                           `cid` bigint(20) DEFAULT '0' COMMENT '企业认证ID',
                           `cmid` bigint(20) NOT NULL DEFAULT '0' COMMENT '实名信息',
                           `u_groupid` varchar(200) DEFAULT NULL COMMENT '用户组ID',
                           `u_name` varchar(80) DEFAULT NULL COMMENT '用户名',
                           `u_sex` tinyint(4) DEFAULT '0' COMMENT '性别0为未知，1为男，2为女',
                           `u_niname` varchar(100) DEFAULT NULL COMMENT '用户昵称',
                           `u_phone` varchar(20) DEFAULT NULL COMMENT '用户手机号',
                           `u_mail` varchar(80) DEFAULT NULL COMMENT '邮箱',
                           `u_icon` varchar(255) DEFAULT NULL COMMENT '头像',
                           `u_password` varchar(255) DEFAULT NULL COMMENT '密码',
                           `u_paypassword` varchar(255) DEFAULT NULL COMMENT '支付密码',
                           `addtime` datetime DEFAULT NULL COMMENT '注册时间',
                           `addip` varchar(50) DEFAULT '0' COMMENT '注册ip',
                           `status` tinyint(4) DEFAULT '0' COMMENT '用户状态，0为审核中，1为通过审核，2为禁用',
                           `del_time` datetime DEFAULT NULL COMMENT '软删除，删除时间',
                           `edittime` datetime DEFAULT NULL,
                           `u_token` varchar(255) DEFAULT NULL COMMENT 'TOKEN',
                           PRIMARY KEY (`uid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户基础表';

DROP TABLE IF EXISTS im_user_card;
CREATE TABLE `im_user_card` (
                                `id` int(11) NOT NULL AUTO_INCREMENT,
                                `name` varchar(30) DEFAULT NULL COMMENT '用户姓名',
                                `sex` tinyint(4) DEFAULT '0' COMMENT '性别0为未知，1为男，2为女',
                                `birthday_y` int(11) DEFAULT NULL COMMENT '生日-年',
                                `birthday_m` int(11) DEFAULT NULL COMMENT '生日-月',
                                `birthday_d` int(11) DEFAULT NULL COMMENT '生日-日',
                                `zodiac` varchar(3) DEFAULT NULL COMMENT '生肖',
                                `constellation` varchar(20) DEFAULT NULL COMMENT '星座',
                                `card_no` varchar(30) DEFAULT NULL COMMENT '身份证号',
                                `card_img_front` varchar(255) DEFAULT NULL COMMENT '身份证正面',
                                `card_img_side` varchar(255) DEFAULT NULL COMMENT '身份证背面',
                                `birthday` varchar(20) DEFAULT NULL COMMENT '民族',
                                `card_add` varchar(80) DEFAULT NULL COMMENT '身份证地址',
                                `province` int(11) DEFAULT NULL COMMENT '省',
                                `city` int(11) DEFAULT NULL COMMENT '市',
                                `county` int(11) DEFAULT NULL COMMENT '县',
                                `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                                `edittime` datetime DEFAULT NULL,
                                `del_time` datetime DEFAULT NULL,
                                PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='实名用户表';

DROP TABLE IF EXISTS im_user_group;
CREATE TABLE `im_user_group` (
                                 `id` int(11) NOT NULL AUTO_INCREMENT,
                                 `fid` int(11) DEFAULT '0' COMMENT '用户组类型',
                                 `title` varchar(80) NOT NULL COMMENT '用户组名称',
                                 `icon` varchar(255) DEFAULT NULL COMMENT '用户组图标，可以是图片或者icon',
                                 `icon_type` tinyint(4) DEFAULT '0' COMMENT '角色图标0为icon,1为图片',
                                 `up_money` int(11) DEFAULT '0' COMMENT '用户组升级所需积分或人民币',
                                 `up_type` tinyint(4) DEFAULT '0' COMMENT '用户组升级积分类型，0为积分，1为人民币，扩展类型参考积分类型表',
                                 `up_auto` int(11) DEFAULT '0' COMMENT '是否为自动升级0为手动，1为自动',
                                 `group_admin` tinyint(4) DEFAULT '0' COMMENT '是否拥有后台权限，0为禁止，1为允许',
                                 `group_space` int(11) DEFAULT '0' COMMENT '用户可上传文件容量0为不限制',
                                 `sort` int(11) DEFAULT '0' COMMENT '排序',
                                 `status` tinyint(4) DEFAULT '0' COMMENT '是否启用0为禁用1为启用',
                                 `addtime` datetime DEFAULT NULL COMMENT '添加时间',
                                 `edittime` datetime DEFAULT NULL COMMENT '修改时间',
                                 `del_time` datetime DEFAULT NULL,
                                 PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户组表';

DROP TABLE IF EXISTS im_user_group_part;
CREATE TABLE `im_user_group_part` (
                                      `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '对应用户组表fid',
                                      `title` varchar(80) DEFAULT NULL,
                                      `auth_list` text COMMENT '拥有权限的模块，包括admin,api,home,member',
                                      `sort` int(11) DEFAULT '0' COMMENT '排序',
                                      `status` tinyint(4) DEFAULT '0' COMMENT '状态，0为禁用，1为启用',
                                      `addtime` datetime DEFAULT NULL,
                                      `edittime` datetime DEFAULT NULL,
                                      `del_time` datetime DEFAULT NULL,
                                      PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='用户组类型表';

INSERT INTO `im_advert_ad` VALUES ('1','0','1','1','2023-09-26 23:11:16','2024-04-18 14:40:32','','139.227.220.43','30587','首页广告','1','[{\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/0b05405044.jpg\",\"title\":\"EruCms3.0版本正式上线\",\"url\":\"\",\"sort\":\"\",\"cont\":\"更便捷 更智能 更高效的建站系统\"},{\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/f8af4ba284.jpg\",\"title\":\"EruCms WebMan版正式上线\",\"url\":\"\",\"sort\":\"\",\"cont\":\"一样的写法 十倍的性能\"}]','0');
INSERT INTO `im_advert_ad` VALUES ('2','0','1','1','2023-10-09 16:10:27','2024-04-18 14:55:05','','139.227.220.43','30746','服务介绍','1','[{\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/28552a885a.png\",\"title\":\"模块化设计\",\"url\":\"\",\"sort\":\"\",\"cont\":\"千万级负载，企业级安全保障，灵活扩展、支持多终端\"},{\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/8efd5f5eae.png\",\"title\":\"便携标签管理\",\"url\":\"\",\"sort\":\"\",\"cont\":\"活码生成，自由组合内容展示、表单、批量、数据统计、美化和标签排版等功能\"},{\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/f3ffef4ef3.png\",\"title\":\"API智能扩展\",\"url\":\"\",\"sort\":\"\",\"cont\":\"专线接入、稳定安全、运营推广全程无忧，成熟的短链接解决方案，万物可链\"},{\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/8443482788.png\",\"title\":\"在线免费升级\",\"url\":\"\",\"sort\":\"\",\"cont\":\"满足各类调研场景:市场调查、产品调查、学生调查,自动生成专业的分析报表\"}]','0');
INSERT INTO `im_advert_ad` VALUES ('3','0','1','1','2023-10-09 16:11:00','2024-04-18 14:42:58','','139.227.220.43','30919','首页-关于我们','0','{\"title\":\"开发简单、易用、高效的内容管理系统\",\"url\":\"\",\"cont\":\"\",\"picurl\":\"http:\\/\\/www_zhaoyan_net\\/Ls_dir\\/2024-04\\/ee7e60a000.jpg\"}','0');
INSERT INTO `im_auth_rule` VALUES ('1','角色分类','UserGroupPart','0','1','0','2023-08-21 08:55:55');
INSERT INTO `im_auth_rule` VALUES ('2','用户角色','UserGroup','0','1','0','2023-10-19 15:14:33');
INSERT INTO `im_auth_rule` VALUES ('3','用户管理','User','0','1','0','2023-06-13 23:56:34');
INSERT INTO `im_auth_rule` VALUES ('4','权限管理','AuthRule','0','1','0','2023-06-16 22:56:03');
INSERT INTO `im_auth_rule` VALUES ('5','菜单分类','MenuPart','0','1','0','2023-09-23 22:37:31');
INSERT INTO `im_auth_rule` VALUES ('6','系统菜单','Menu','0','1','0','2023-08-23 00:49:23');
INSERT INTO `im_auth_rule` VALUES ('7','登录日志','LogUser','0','1','0','2023-08-21 00:38:07');
INSERT INTO `im_auth_rule` VALUES ('8','系统配置分类','ConfigPart','0','1','0','2023-08-23 21:22:45');
INSERT INTO `im_auth_rule` VALUES ('9','系统配置','Config','0','1','0','2023-08-23 21:22:59');
INSERT INTO `im_auth_rule` VALUES ('10','积分分类','MoneyPart','0','1','0','2023-08-30 15:57:14');
INSERT INTO `im_auth_rule` VALUES ('11','积分明细','Money','0','1','0','2023-08-30 15:57:41');
INSERT INTO `im_auth_rule` VALUES ('12','数据库管理','SqlManage','0','1','0','2023-09-04 00:09:44');
INSERT INTO `im_auth_rule` VALUES ('13','模块管理','Modular','0','1','0','2023-09-11 23:40:48');
INSERT INTO `im_auth_rule` VALUES ('14','模型管理','ModularMod','0','1','0','2023-09-13 00:28:56');
INSERT INTO `im_auth_rule` VALUES ('15','模型字段管理','ModularFiled','0','1','0','2023-09-14 14:20:22');
INSERT INTO `im_auth_rule` VALUES ('16','栏目管理','Part','cms','1','0','2023-09-14 20:08:28');
INSERT INTO `im_auth_rule` VALUES ('17','文章管理','Article','cms','1','0','2023-09-23 23:40:13');
INSERT INTO `im_auth_rule` VALUES ('18','链接分类','LinkPart','0','1','0','2023-09-25 08:06:51');
INSERT INTO `im_auth_rule` VALUES ('19','链接管理','Link','0','1','0','2023-09-25 08:07:09');
INSERT INTO `im_auth_rule` VALUES ('20','广告管理','Ad','advert','1','0','2023-09-26 22:20:49');
INSERT INTO `im_auth_rule` VALUES ('21','标签管理','Tag','0','1','0','2023-10-10 23:01:58');
INSERT INTO `im_auth_rule` VALUES ('28','产品分类','Goodpart','cms','1','0','2023-10-24 23:32:20');
INSERT INTO `im_auth_rule` VALUES ('29','产品管理','Goods','cms','1','0','2023-10-24 23:46:33');
INSERT INTO `im_auth_rule` VALUES ('30','单篇内容','Show','cms','1','0','2023-10-25 12:01:28');
INSERT INTO `im_auth_rule_access` VALUES ('1','1','7','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('2','1','8','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('3','1','9','read,create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('4','1','5','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('5','1','6','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('6','1','1','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('7','1','2','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('8','1','3','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('10','1','10','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('11','1','11','del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('12','2','12','','member');
INSERT INTO `im_auth_rule_access` VALUES ('13','1','4','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('14','1','13','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('15','1','14','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('16','1','15','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('17','1','12','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('18','1','16','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('19','1','17','read,create','admin');
INSERT INTO `im_auth_rule_access` VALUES ('20','1','18','read,create','admin');
INSERT INTO `im_auth_rule_access` VALUES ('21','1','19','read,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('22','1','20','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('23','1','21','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('24','1','22','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('25','1','23','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('26','1','24','read,create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('27','1','25','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('28','1','26','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('29','1','27','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('30','1','28','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('31','1','29','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('32','1','30','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('33','1','31','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('34','1','32','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('35','1','33','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('36','1','34','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('37','1','35','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('38','1','36','edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('39','1','37','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('40','1','38','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('41','1','39','create,edit,del','admin');
INSERT INTO `im_auth_rule_access` VALUES ('42','1','40','','admin');
INSERT INTO `im_auth_rule_access` VALUES ('43','1','41','create,edit,del','admin');
INSERT INTO `im_cms_article` VALUES ('1','0','1','0','1','2023-09-30 10:58:54','2024-04-19 13:41:44','','139.227.220.43','31472','Content Management System','<p>CMS是英语Content Management System的缩写，按英语的字面翻译就是内容管理系统，顾名思义，它主要是为了方便发布网络内容而存在的一体化Web管理系统。</p><p>很久很久以前，人们做网站很多用静态HTML+CSS+Javascript直接写，也就是静态页面。但是如果有一组页面要维护，对于静态页面来说是一件很麻烦的事，比如我有一个人的Email地址变更了，这一组页面上所有出现的地方都要改，于是就有了适合Web的动态语言，如ASP，PHP，JAVA，.NET等等，它们把数据保存在数据库中，可以动态的引用，这样就能生产出较大规模的网站了，当时诞生了一批大型网站，叫做门户网站，比如新浪，网易，搜狐，他们的内容很丰富，很多，他们有一大批编辑来搜集整理网站的文章，但是总不可能让程序员帮他们把内容上传吧，于是CMS诞生了，通常CMS有一个后台，编辑通过登录后台进入一个可视化的操作界面，把文章录入进去，然后通过上一级的总编审核后发布到网站中。</p><p>上面说的文章发布只是CMS的一个功能模块，通常还会有一个会员管理系统，这是最基本的2个功能模块。文章发布会带有一个富文本编辑器，可以直接插入和上传媒体文件，如图片和视频；还有分类以及排序，发布以及更新的时间戳，Tag标签等等，更有强大的CMS会添加自定义的字段，比如加入文章出处，原创作者等。会员系统会分级人员的权限，比如超级管理员能做所有后台能做的事情，而编辑只能添加和编辑删除某个分类下的文章，甚至只能看到这个分类，其他分类对于他是隐藏的。</p><p>但是一个功能较强大的CMS远不止如此，他们会有各种各样奇奇怪怪的功能模块，比如留言板，评论系统，预约系统，多语言模块等等。博客系统也是一种CMS，只是它们更侧重于发布博客。</p><p></p>','CMS是英语ContentManagementSystem的缩写，按英语的字面翻译就是内容管理系统，顾名思义，它主要是为了方便发布网络内容而存在的一体化Web管理系统。很久很久以前，人们做网站很多用静态HTML+CSS+Javascript直接写，也就是静态页面。但是如果有一组页面要维护，对于静态页面来说是一件很麻烦的事，比如我有一个人的Email地','','','2','43','0');
INSERT INTO `im_cms_article` VALUES ('2','0','1','0','1','2024-04-19 13:44:25','2024-04-19 13:44:53','','112.64.2.38','29733','什么时内容管理系统','<p>CMS是英语Content Management System的缩写，按英语的字面翻译就是内容管理系统，顾名思义，它主要是为了方便发布网络内容而存在的一体化Web管理系统。</p><p>很久很久以前，人们做网站很多用静态HTML+CSS+Javascript直接写，也就是静态页面。但是如果有一组页面要维护，对于静态页面来说是一件很麻烦的事，比如我有一个人的Email地址变更了，这一组页面上所有出现的地方都要改，于是就有了适合Web的动态语言，如ASP，PHP，JAVA，.NET等等，它们把数据保存在数据库中，可以动态的引用，这样就能生产出较大规模的网站了，当时诞生了一批大型网站，叫做门户网站，比如新浪，网易，搜狐，他们的内容很丰富，很多，他们有一大批编辑来搜集整理网站的文章，但是总不可能让程序员帮他们把内容上传吧，于是CMS诞生了，通常CMS有一个后台，编辑通过登录后台进入一个可视化的操作界面，把文章录入进去，然后通过上一级的总编审核后发布到网站中。</p><p>上面说的文章发布只是CMS的一个功能模块，通常还会有一个会员管理系统，这是最基本的2个功能模块。文章发布会带有一个富文本编辑器，可以直接插入和上传媒体文件，如图片和视频；还有分类以及排序，发布以及更新的时间戳，Tag标签等等，更有强大的CMS会添加自定义的字段，比如加入文章出处，原创作者等。会员系统会分级人员的权限，比如超级管理员能做所有后台能做的事情，而编辑只能添加和编辑删除某个分类下的文章，甚至只能看到这个分类，其他分类对于他是隐藏的。</p><p>但是一个功能较强大的CMS远不止如此，他们会有各种各样奇奇怪怪的功能模块，比如留言板，评论系统，预约系统，多语言模块等等。博客系统也是一种CMS，只是它们更侧重于发布博客。</p><p><img src=\"http://www_zhaoyan_net/Ls_dir/2024-04/7347ba3139.jpg\" style=\"max-width:100%;\" contenteditable=\"false\"/></p>','CMS是英语ContentManagementSystem的缩写，按英语的字面翻译就是内容管理系统，顾名思义，它主要是为了方便发布网络内容而存在的一体化Web管理系统。很久很久以前，人们做网站很多用静态HTML+CSS+Javascript直接写，也就是静态页面。但是如果有一组页面要维护，对于静态页面来说是一件很麻烦的事，比如我有一个人的Email地','http://www_zhaoyan_net/Ls_dir/2024-04/7fb2b8777b.jpg','','2','3','0');
INSERT INTO `im_cms_article` VALUES ('3','0','1','0','1','2024-04-19 14:30:56','2024-04-19 14:30:56','','112.64.2.38','29852','手机网站建设公司哪家好?主要看这四大方面','<p>
&nbsp;&nbsp;&nbsp;&nbsp;</p><p>如今，随着移动互联网的高速发展，手机上网用户已经远远超过了电脑用户，那随着用户上网行为和需求的不断改变，手机无时无刻的都和我们的生活紧紧相连，未来的世界就是移动互联网的时代。那作为企业该如何抓住这次机遇？小编认为把握企业移动端的潜在客户，做一个专属自己企业的手机网站，通过各种移动端推广方式，把流量引入到手机网站，在转化成询盘，但前提一定要有一个优质的营销手机网站。那么最后重要的问题来了，手机网站建设公司哪家好呢?下面就来细细的分析一下。<br/><br/></p><p>　　<strong>一、了解手机网站建设公司的“前世今生”，选择有实力的</strong><br/><br/></p><figure style=\"text-align:center;\"><img src=\"http://www_zhaoyan_net/Ls_dir/2024-04/66ff69b969.jpeg\" alt=\"手机网站建设公司哪家好?主要看这四大方面\"/></figure><p><br/></p><p>　　<strong>手机网站建设公司哪家好</strong>？选择一家手机网站建设公司，应该先上网了解一下该公司的历史，看是什么时候成立的，如果是刚成立的公司，就要看看它在网站建设方面的实力。<br/></p><p>　　<strong>二、看手机网站建设公司专攻的方向，方能“对症下药”</strong><br/><br/></p><figure style=\"text-align:center;\"><img src=\"http://www_zhaoyan_net/Ls_dir/2024-04/86f309f600.jpeg\" alt=\"手机网站建设公司哪家好?主要看这四大方面\"/></figure><p><br/></p><p>　　找营销型手机网站建设公司，一定要看看它专供哪一方面，千万不要找那种只有“半桶水”的公司，这样不仅效果得不到保证，可能还会白白花钱，造成不必要的浪费。目前国内从事网站建设业务的公司已经多到数不胜数，几乎每个网络公司都在开展网站建设业务，只是侧重点不同罢了。<br/></p><p>　<strong>　三、找手机网站建设公司的成功案例，做到心中有数</strong><br/><br/></p><figure style=\"text-align:center;\"><img src=\"http://www_zhaoyan_net/Ls_dir/2024-04/ff90f9fd88.jpeg\" alt=\"手机网站建设公司哪家好?主要看这四大方面\"/></figure><p><br/></p><p>　　<strong>手机网站建设公司哪家好</strong>？若想要心中有数，找手机网站建设公司的时候，最好看看这家公司在过去曾经设计开发过什么样的成功案例，从中可以看出该公司的网站建设水平。有些手机网站建设公司的案例存在抄袭或者复制的情况，若想更为清晰地了解一个网站是否真正由这家公司设计开发的，可以从下面两点看出来。首先，若是抄袭或者复制别家公司案例的网站建设公司，基本上不能够提供网站设计稿源文件或程序源代码，所以你可以要求手机网站建设公司提供这些资料给你看。其次，可以亲自通过电话/email等联系方式与网站用户进行询问验证，要求网站建设公司提供即可。<br/></p><p>　<strong>　四、看手机网站建设公司的团队结构</strong><br/><br/></p><figure style=\"text-align:center;\"><img src=\"http://www_zhaoyan_net/Ls_dir/2024-04/da5553838d.jpeg\" alt=\"手机网站建设公司哪家好?主要看这四大方面\"/></figure><p><br/></p><p>　　了解其公司规模一家专业、优秀的手机网站建设公司，它都会有一支分工明确的团队，并不是一个人什么事都做，一个手机网站建设也不能完全靠一个人就能全部搞定。以一些小公司为例，随随便便找一两个人做网站，做出来的模板相对粗糙，这样肯定是没有团队协作完成的效果那么专业的。则有一个专业的开发团队，只要客户把网站交给做，这个网站的诞生必定是经过的专业团队一起打造的。</p>&nbsp;&nbsp;  <p></p>','如今，随着移动互联网的高速发展，手机上网用户已经远远超过了电脑用户，那随着用户上网行为和需求的不断改变，手机无时无刻的都和我们的生活紧紧相连，未来的世界就是移动互联网的时代。那作为企业该如何抓住这次机遇？小编认为把握企业移动端的潜在客户，做一个专属自己企业的手机网站，通过各种移动端推广方式，把流量引','http://www_zhaoyan_net/Ls_dir/2024-04/88b7868686.jpeg','','4','5','0');
INSERT INTO `im_cms_goodpart` VALUES ('1','0','1','0','1','2023-10-25 13:32:50','2024-04-19 14:10:38','','139.227.220.43','31450','系统','0','1','0','0','0','','','','','','','','','');
INSERT INTO `im_cms_part` VALUES ('1','0','1','0','1','2023-09-22 14:48:56','2024-04-19 14:28:18','','139.227.220.43','29824','新闻资讯','0','1','0','0','0','','','','http://www_zhaoyan_net/Ls_dir/2024-04/63133e3c36.jpg','','','','','','0');
INSERT INTO `im_cms_part` VALUES ('2','0','1','0','1','2023-09-23 22:34:39','2024-04-19 09:36:00','','139.227.220.43','31482','技术知识','1','1','0','0','0','','','','','','111111','','','','0');
INSERT INTO `im_cms_part` VALUES ('3','0','1','0','1','2024-04-19 09:02:58','2024-04-19 14:29:05','','112.64.2.38','29852','栏目跳转','1','0','0','0','0','http://www.wormcms.com','','','','','','','','','0');
INSERT INTO `im_cms_part` VALUES ('4','0','1','0','1','2024-04-19 14:29:34','2024-04-19 14:29:41','','112.64.2.38','29852','文章列表','1','1','0','0','0','','','','','','','','','','0');
INSERT INTO `im_cms_part` VALUES ('5','0','1','0','1','2024-04-22 14:08:01','2024-04-22 14:23:40','','112.64.2.38','29715','产品案例','0','1','0','0','0','','','','','','','img_list','','','0');
INSERT INTO `im_config` VALUES ('1','1','系统名称','web_title','演示网站','text','1','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('2','1','系统简称','web_title_min','演示网站','text','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('3','1','系统标签','web_keywords','演示网站','text','0','','','','','多个标签请用英文逗号分割','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('4','1','系统简介','web_description','演示网站','textarea','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('5','1','系统网址','web_url','http://tp.eruyun.com','text','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('6','1','LOGO','web_logo','http://www_zhaoyan_net/Ls_dir/webdb/0811889cd8.png','image','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('7','1','系统状态','web_open','1','radio','0','','1','1|开启
0|关闭','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('8','1','关闭原因','web_openwhy','关闭原因','textarea','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('9','1','前台模板','web_template','default','getmodel','0','','','','','','0','1','/hook/piece?model=home&n=template','','2','0');
INSERT INTO `im_config` VALUES ('10','1','后台模板','web_template_admin','default','getmodel','0','','','','','','0','1','/hook/piece?model=admin&n=template','title=title,value=value','2','0');
INSERT INTO `im_config` VALUES ('11','1','会员中心模板','web_template_member','','getmodel','0','','','','','','0','1','/hook/piece?model=member&n=template','','2','0');
INSERT INTO `im_config` VALUES ('12','1','ICP备案号','web_icp','沪ICP备2021033998号','text','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('13','1','公安备案','web_policeicp','','text','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('14','1','底部版权','web_footbq','','textarea','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('15','1','后台登录验证','web_adminyz','1','radio','0','','1','1|启用
0|禁用','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('16','1','前台登录验证','web_homeyz','1','radio','0','','1','1|启用
0|禁用','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('17','2','公司名称','company_title','上海焱凤信息技术有限公司','text','0','','','','','','100','1','','','0','0');
INSERT INTO `im_config` VALUES ('18','2','联系电话','company_tel','400-021-5606','text','0','','','','','','80','1','','','0','0');
INSERT INTO `im_config` VALUES ('19','2','联系地址','company_address','上海市浦东新区惠南镇绿地峰汇商务广场','text','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('20','2','公众号二维码','company_mp_qrcode','http://www_zhaoyan_net/Ls_dir/webdb/a333c3c5ac.jpg','image','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('21','2','联系人','company_contacts','赵焱','text','0','','','','','','90','1','','','0','0');
INSERT INTO `im_config` VALUES ('22','2','联系手机','company_phone','18616399020','text','0','','','','','','80','1','','','0','0');
INSERT INTO `im_config` VALUES ('23','2','传真号码','company_fax','','text','0','','','','','','78','1','','','0','0');
INSERT INTO `im_config` VALUES ('24','2','联系QQ','company_qq','840712498','text','0','','','','','','70','1','','','0','0');
INSERT INTO `im_config` VALUES ('25','1','授权码','web_warrant','B84DE','text','0','','','','','请在 http://wormcms.com/server/empower.html 获取授权码','0','1','','','0','0');
INSERT INTO `im_config` VALUES ('26','2','企业邮箱','company_email','','text','0','','','','','','0','1','','','0','0');
INSERT INTO `im_config_part` VALUES ('1','im-icon im-sitting','系统基础配置','0','1','2023-08-23 22:40:39','2023-10-20 16:01:48','');
INSERT INTO `im_config_part` VALUES ('2','im-icon im-8','企业信息','0','1','2023-08-23 23:23:02','2023-08-30 12:34:22','');
INSERT INTO `im_eru_tag` VALUES ('1','0','1','in_ceshi','in_ceshi','base','@text@','','0','','1','0','default','Index','index','1','','','','2024-04-15 20:32:31','2024-04-15 20:36:24','');
INSERT INTO `im_eru_tag` VALUES ('2','0','1','','indexhdp','advert','ad','title,cont','0','','0','0','default','Index','index','1','','','{\"id\":\"1\"}','2024-04-15 20:42:06','2024-04-15 20:42:06','');
INSERT INTO `im_eru_tag` VALUES ('3','0','1','','topnav','base','link','','0','','1','0','default','Index','index','1','','','{\"fid\":\"1\",\"class\":\"0\"}','2024-04-15 20:42:57','2024-04-15 20:42:57','');
INSERT INTO `im_link` VALUES ('1','0','1','首页','/','1','0','im-icon im-add','10','1','2023-09-25 16:23:44','2024-04-19 14:53:08');
INSERT INTO `im_link` VALUES ('2','0','1','关于我们','/cms/show-1.html','1','1','','10','1','2023-09-25 16:26:02','2024-04-19 14:53:08');
INSERT INTO `im_link` VALUES ('3','0','2','易如云','https://www.eruyun.com','1','0','im-icon im-add','0','1','2023-09-25 16:49:01','2023-09-25 16:49:01');
INSERT INTO `im_link` VALUES ('4','0','1','新闻资讯','/cms/part-1.html','0','0','im-icon im-add','10','1','2023-09-25 16:51:17','2024-04-19 14:53:09');
INSERT INTO `im_link` VALUES ('5','0','1','产品中心','/cms/goodpart-1.html','1','0','im-icon im-add','10','1','2024-04-09 15:02:23','2024-04-19 14:53:10');
INSERT INTO `im_link` VALUES ('6','0','1','联系我们','/cms/show-2.html','1','0','im-icon im-add','0','1','2024-04-09 15:02:32','2024-04-19 14:53:15');
INSERT INTO `im_link` VALUES ('7','0','3','阿里云','https://aliyun.com','1','1','http://www_zhaoyan_net/Ls_dir/2024-04/554a666bdd.jpg','0','1','2024-04-17 11:40:01','2024-04-17 11:40:01');
INSERT INTO `im_link` VALUES ('8','0','3','百度云','https://cloud.baidu.com','1','1','http://www_zhaoyan_net/Ls_dir/2024-04/a5a75ddd1a.jpg','0','1','2024-04-17 11:48:25','2024-04-17 11:48:25');
INSERT INTO `im_link` VALUES ('9','0','3','腾讯云','https://cloud.tencent.com','1','1','http://www_zhaoyan_net/Ls_dir/2024-04/d0aa50dd49.jpg','0','1','2024-04-17 11:49:35','2024-04-17 11:49:35');
INSERT INTO `im_link` VALUES ('10','0','3','天翼云','https://www.ctyun.cn','1','1','http://www_zhaoyan_net/Ls_dir/2024-04/a336393613.jpg','0','1','2024-04-17 11:51:05','2024-04-17 11:51:05');
INSERT INTO `im_link` VALUES ('11','0','3','中国联通','https://cucc.wocloud.cn/','1','1','http://www_zhaoyan_net/Ls_dir/2024-04/e401444114.jpg','0','1','2024-04-17 11:54:20','2024-04-17 11:54:20');
INSERT INTO `im_link` VALUES ('12','0','3','中国移动','https://ecloud.10086.cn','1','1','http://www_zhaoyan_net/Ls_dir/2024-04/5522952225.jpg','0','1','2024-04-17 11:56:02','2024-04-17 11:56:02');
INSERT INTO `im_link` VALUES ('13','0','4','关于我们','/','1','0','im-icon im-add','0','1','2024-04-17 14:44:23','2024-04-17 14:44:23');
INSERT INTO `im_link` VALUES ('14','0','4','联系我们','/','1','0','im-icon im-add','0','1','2024-04-17 14:44:34','2024-04-17 14:44:34');
INSERT INTO `im_link` VALUES ('15','0','4','系统介绍','/','1','0','im-icon im-add','0','1','2024-04-17 14:44:59','2024-04-17 14:45:11');
INSERT INTO `im_link` VALUES ('16','0','4','更新记录','/','1','0','im-icon im-add','0','1','2024-04-17 14:45:31','2024-04-17 14:45:31');
INSERT INTO `im_link` VALUES ('17','0','1','产品案例','/cms/part-5.html','1','0','im-icon im-add','8','1','2024-04-19 14:53:00','2024-04-22 14:08:24');
INSERT INTO `im_link_part` VALUES ('1','网站主导航','0','1','1','0','2023-09-25 08:22:22','2023-10-14 10:30:26');
INSERT INTO `im_link_part` VALUES ('2','友情链接','0','1','0','1','2023-09-25 08:24:54','2023-09-25 08:24:54');
INSERT INTO `im_link_part` VALUES ('3','合作伙伴','0','1','0','1','2023-09-25 08:25:01','2023-10-20 17:09:40');
INSERT INTO `im_link_part` VALUES ('4','底部导航','0','1','1','0','2023-09-25 08:54:46','2023-09-25 08:54:53');

INSERT INTO `im_menu` VALUES ('1','0','0','0','','1','0','im-icon im-hexin','','系统高级配置','','2023-06-25 00:43:15','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('2','1','1','4','create,edit,del','1','0','im-icon im-caozuo','','系统权限管理','','2023-06-25 00:44:26','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('3','1','1','5','create,edit,del','1','0','im-icon im-app','','系统菜单分类','','2023-06-25 01:40:24','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('4','1','1','1','create,edit,del','1','0','im-icon im-yonghuzu','','角色分类','','2023-06-25 01:41:07','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('5','0','0','0','','1','0','im-icon im-sitting','','全局配置','','2023-06-25 01:42:02','2023-09-11 23:42:21','112.64.2.140','10','1','0');
INSERT INTO `im_menu` VALUES ('6','1','1','6','create,edit,del','1','0','im-icon im-menu','','会员菜单管理','','2023-06-25 01:44:07','2023-09-11 22:49:14','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('7','0','0','0','','1','0','im-icon im-person2','','用户管理','','2023-06-25 01:44:44','','112.64.2.140','20','1','0');
INSERT INTO `im_menu` VALUES ('8','1','7','2','create,edit,del','1','0','im-icon im-all','','角色管理','','2023-06-25 01:45:57','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('9','1','7','3','read,create,edit,del','1','0','im-icon im-unie64d','','用户管理','','2023-06-25 01:46:23','2023-08-30 20:57:11','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('10','0','0','0','','1','0','im-icon im-querenfangan','','日志管理','','2023-06-25 01:47:09','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('11','1','10','7','del','1','0','im-icon im-querenfangan','','用户登录日志','','2023-06-25 10:38:44','','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('12','2','5','0','','1','0','im-icon im-8','admin/Config/editconf?fid=2','企业信息','','2023-08-19 20:56:35','2023-08-30 12:35:56','112.64.2.140','0','1','0');
INSERT INTO `im_menu` VALUES ('13','1','1','8','create,edit,del','1','0','im-icon im-sitting','','系统配置分类','','2023-08-23 21:23:43','','112.64.2.32','0','1','0');
INSERT INTO `im_menu` VALUES ('14','1','1','9','create,edit,del','1','0','im-icon im-all','','系统字段管理','','2023-08-23 21:24:20','2023-08-23 21:48:11','112.64.2.32','0','1','0');
INSERT INTO `im_menu` VALUES ('15','2','5','0','','1','0','im-icon im-caozuoxitong','admin/Config/editconf?fid=1','基础设置','','2023-08-23 23:56:52','2023-09-11 22:52:16','112.64.2.32','10','1','0');
INSERT INTO `im_menu` VALUES ('16','1','1','10','create,edit,del','1','0','im-icon im-xinyongqia','','系统积分分类','','2023-08-30 15:58:38','2023-08-30 15:59:15','112.64.2.32','0','1','0');
INSERT INTO `im_menu` VALUES ('17','1','7','11','read,create','1','0','im-icon im-menu','','用户积分明细','money_type=1','2023-08-31 09:24:35','2023-08-31 10:32:07','112.64.2.32','0','1','0');
INSERT INTO `im_menu` VALUES ('18','1','7','11','read,create','1','0','im-icon im-yingxiao','','用户财务流水','money_type=0','2023-08-31 09:25:15','2023-08-31 10:32:25','112.64.2.32','0','1','0');
INSERT INTO `im_menu` VALUES ('19','1','1','12','read,edit,del','1','0','im-icon im-caozuoxitong','','数据库管理','','2023-09-04 00:11:11','2023-09-09 12:04:37','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('20','1','1','13','create,edit,del','1','0','im-icon im-sitting','','系统模块管理','','2023-09-11 23:43:34','2023-09-11 23:43:34','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('21','1','5','14','create,edit,del','1','0','im-icon im-app','','模型管理','fid=1','2023-09-13 00:39:43','2023-09-13 00:40:04','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('22','0','0','16','create,edit,del','1','0','im-icon im-querenfangan','','内容管理','','2023-09-14 22:24:00','2023-09-14 22:24:00','139.227.220.43','100','1','0');
INSERT INTO `im_menu` VALUES ('23','1','22','16','create,edit,del','1','0','im-icon im-all','','文章分类','','2023-09-14 22:24:43','2023-10-24 23:30:53','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('24','1','22','17','read,create,edit,del','1','0','im-icon im-menu','','文章管理','','2023-09-24 00:32:34','2023-09-24 00:32:34','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('25','0','0','0','','1','0','im-icon im-all','','导航管理','','2023-09-25 08:08:47','2023-09-25 08:11:36','139.227.220.43','28','1','0');
INSERT INTO `im_menu` VALUES ('26','1','25','18','create,edit,del','1','0','im-icon im-menu','','导航分类','class=0','2023-09-25 08:09:41','2023-09-25 08:09:41','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('27','0','0','0','','1','0','im-icon im-all','','友情链接管理','','2023-09-25 08:23:24','2023-09-25 08:23:32','139.227.220.43','26','1','0');
INSERT INTO `im_menu` VALUES ('28','1','27','18','create,edit,del','1','0','im-icon im-menu','','友情链接分类','class=1','2023-09-25 08:24:05','2023-09-25 08:24:05','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('29','1','25','19','create,edit,del','1','0','im-icon im-menu','','主导航管理','fid=1','2023-09-25 08:28:09','2023-09-25 08:28:09','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('30','1','27','19','create,edit,del','1','0','im-icon im-menu','','友情链接','fid=2','2023-09-25 08:28:46','2023-09-25 08:28:46','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('31','1','27','19','create,edit,del','1','0','im-icon im-menu','','合作伙伴','fid=3','2023-09-25 08:29:16','2023-09-25 08:29:16','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('32','1','25','19','create,edit,del','1','0','im-icon im-menu','','底部导航管理','fid=4','2023-09-25 08:55:48','2023-09-25 08:55:48','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('33','0','0','0','','1','0','im-icon im-kanxiaoguo','','广告管理','','2023-09-26 22:23:37','2023-09-26 22:23:47','139.227.220.43','24','1','0');
INSERT INTO `im_menu` VALUES ('34','1','33','20','create,edit,del','1','0','im-icon im-kanxiaoguo','','站内广告','','2023-09-26 22:24:13','2023-10-21 22:28:20','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('35','0','0','0','','1','0','im-icon im-8','','页面美化','','2023-10-10 23:05:29','2023-10-10 23:05:47','139.227.220.43','22','1','0');
INSERT INTO `im_menu` VALUES ('36','1','35','21','edit,del','1','0','im-icon im-extend','','标签管理','','2023-10-10 23:06:37','2023-10-10 23:06:37','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('37','0','0','0','','1','0','im-icon im-cangku','','产品管理','','2023-10-24 23:42:58','2023-10-24 23:43:08','139.227.220.43','90','1','0');
INSERT INTO `im_menu` VALUES ('38','1','37','28','create,edit,del','1','0','im-icon im-app','','产品分类','','2023-10-24 23:44:06','2023-10-24 23:44:06','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('39','1','37','29','create,edit,del','1','0','im-icon im-8','','产品列表','','2023-10-24 23:47:54','2023-10-24 23:47:54','139.227.220.43','0','1','0');
INSERT INTO `im_menu` VALUES ('40','0','0','0','','1','0','im-icon im-qiyeyewu','','单篇内容','','2023-10-25 12:06:00','2023-10-25 12:06:07','139.227.220.43','80','1','0');
INSERT INTO `im_menu` VALUES ('41','1','40','30','create,edit,del','1','0','im-icon im-qiyeyewu','','内容列表','','2023-10-25 12:06:46','2023-10-25 12:06:46','139.227.220.43','0','1','0');
INSERT INTO `im_menu_part` VALUES ('1','后台菜单','1','0','1','admin','2023-06-24 16:38:23','2023-10-20 17:06:22','');
INSERT INTO `im_menu_part` VALUES ('2','会员中心菜单','1,2','0','1','member','2023-06-24 16:57:04','2023-06-24 16:57:04','');
INSERT INTO `im_menu_part` VALUES ('3','API接口','2','0','1','api','2023-06-24 17:16:18','2023-08-23 00:55:03','');
INSERT INTO `im_modular` VALUES ('1','基础内容模块','cms','2023-09-12 23:42:18','2023-10-21 22:09:04','','0','1');
INSERT INTO `im_modular` VALUES ('2','广告模块','advert','2023-09-26 22:19:16','2023-10-21 22:09:09','','0','1');
INSERT INTO `im_modular_field` VALUES ('1','1','栏目名称','title','varchar','text','1','','','','','','100','1','','','0','2023-09-14 15:18:52','2023-10-16 09:58:31','','1','0','');
INSERT INTO `im_modular_field` VALUES ('2','1','上级栏目','pid','int','rank','0','','','','','','90','1','','','0','2023-09-14 16:27:23','2023-10-16 09:58:36','','0','0','');
INSERT INTO `im_modular_field` VALUES ('3','1','上级栏目显示','pid_see','tinyint','radio','0','','1','1|上级显示
0|上级隐藏','','','80','1','','','0','2023-09-14 16:28:36','2023-10-16 09:58:39','','1','0','');
INSERT INTO `im_modular_field` VALUES ('4','1','列表显示','list_num','int','text','1','number','0','','条','默认20条','70','1','','','0','2023-09-21 23:39:57','2023-10-16 09:58:43','','1','0','');
INSERT INTO `im_modular_field` VALUES ('5','1','内容标题显示','title_num','int','text','1','number','0','','字','0为不限制','0','1','','','0','2023-09-21 23:40:38','2023-09-21 23:40:38','','0','0','');
INSERT INTO `im_modular_field` VALUES ('6','1','内容简介显示','cont_num','int','text','1','number','0','','字','默认为300字','0','1','','','0','2023-09-21 23:41:22','2023-09-21 23:41:22','','0','0','');
INSERT INTO `im_modular_field` VALUES ('7','1','跳转地址','jumpurl','varchar','text','0','','','','','','0','1','','','0','2023-09-21 23:41:56','2023-09-21 23:42:14','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('8','1','SEO关键词','keywords','varchar','text','0','','','','','多个关键词请用英文’,‘进行分割，推荐80字以内','0','1','','','0','2023-09-21 23:42:50','2023-09-21 23:42:50','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('9','1','SEO简介','description','text','textarea','0','','','','','推荐200字以内','0','1','','','0','2023-09-21 23:43:42','2023-09-21 23:43:50','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('10','1','BANNER','banner','varchar','image','0','','','','','','0','1','','','0','2023-09-21 23:44:19','2023-09-21 23:44:24','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('11','1','LOGO','logo','varchar','image','0','','','','','','0','1','','','0','2023-09-21 23:45:22','2023-09-21 23:45:22','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('12','1','栏目密码','password','varchar','text','0','','','','','','0','1','','','0','2023-09-21 23:45:59','2023-09-21 23:45:59','','1','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('13','1','列表样式','temp_late','varchar','getmodel','0','','','','','','0','1','/hook/Piece?n=template&model=home&fun=default/template/cms/article_list&son=htm','','2','2023-09-21 23:46:39','2024-04-22 14:22:00','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('14','1','自订义列表页','temp_list','varchar','text','0','','','','','内容页模板地址，如：new_cont.htm','0','1','','','0','2023-09-21 23:47:25','2024-04-22 17:06:50','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('15','1','自订义内容页','temp_cont','varchar','text','0','','','','','内容页模板地址，如：new_cont.htm','0','1','','','0','2023-09-21 23:48:07','2024-04-22 17:06:43','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('16','2','文章标题','title','varchar','text','1','','','','','','100','1','','','0','2023-09-24 00:31:06','2023-09-30 11:58:23','','1','1','');
INSERT INTO `im_modular_field` VALUES ('17','2','内容','cont','mediumtext','editor','0','','','','','','90','1','','','0','2023-09-24 00:31:42','2023-09-30 11:58:28','','0','0','');
INSERT INTO `im_modular_field` VALUES ('18','3','广告名称','title','varchar','text','0','','','','','','0','1','','','0','2023-09-26 22:21:06','2023-10-21 15:55:56','','1','0','');
INSERT INTO `im_modular_field` VALUES ('19','3','广告类型','class','tinyint','select','0','','0','0|图文广告
1|图片列表
2|视频广告','','','0','1','','','0','2023-09-26 22:21:54','2023-10-25 08:43:34','','1','1','');
INSERT INTO `im_modular_field` VALUES ('20','3','广告内容','cont','text','textarea','0','','','','','','0','1','','','0','2023-09-26 22:22:36','2023-09-26 22:22:36','','0','0','');
INSERT INTO `im_modular_field` VALUES ('21','2','SEO关键词','keywords','varchar','text','0','','','','','多个关键词请用英文’,‘进行分割，推荐80字以内','0','1','','','0','2023-09-28 08:07:43','2023-10-25 08:50:33','','1','0','');
INSERT INTO `im_modular_field` VALUES ('22','2','SEO简介','description','text','textarea','0','','','','','','0','1','','','0','2023-09-28 08:12:08','2023-09-28 08:12:08','','0','0','');
INSERT INTO `im_modular_field` VALUES ('23','2','封面图','picurl','varchar','image','0','','','','','','0','1','','','0','2023-09-28 08:12:55','2023-09-28 08:12:55','','0','0','');
INSERT INTO `im_modular_field` VALUES ('25','2','所属分类','fid','int','getmodel','0','','','','','','80','1','cms/Part/getlist','title=title_display,value=id','2','2023-09-30 11:55:29','2023-10-22 15:32:48','','1','1','');
INSERT INTO `im_modular_field` VALUES ('26','2','浏览量','hist','int','hidden','0','','0','','','','0','1','','','0','2023-10-16 09:45:08','2023-10-16 09:45:08','','1','0','');
INSERT INTO `im_modular_field` VALUES ('27','2','推荐','top','tinyint','radio','0','','0','0|不推荐
1|推荐','','','0','1','','','0','2023-10-16 09:46:25','2023-10-16 09:46:25','','1','0','');
INSERT INTO `im_modular_field` VALUES ('30','1','排序规则','articleorder','varchar','select','0','','0','0|默认排序
id desc|发表时间降序
id asc|发表时间升序
hist desc,id desc|浏览量降序
hist asc,id desc|浏览量升序','','','60','1','','','0','2023-10-16 09:55:47','2023-10-16 10:00:30','','0','0','');
INSERT INTO `im_modular_field` VALUES ('31','4','栏目名称','title','varchar','text','1','','','','','','100','1','','','0','2023-10-24 23:33:11','2023-10-24 23:40:39','','1','0','');
INSERT INTO `im_modular_field` VALUES ('32','4','上级栏目','pid','int','rank','0','','','','','','90','1','','','0','2023-10-24 23:33:18','2023-10-24 23:40:43','','0','0','');
INSERT INTO `im_modular_field` VALUES ('33','4','上级栏目显示','pidsee','tinyint','radio','0','','1','1|上级显示
0|上级隐藏','','','80','1','','','0','2023-10-24 23:38:59','2023-10-24 23:41:12','','1','0','');
INSERT INTO `im_modular_field` VALUES ('34','4','列表显示','list_num','int','text','1','number','0','','条','默认20条','70','1','','','0','2023-09-21 23:39:57','2023-10-24 23:41:02','','1','0','');
INSERT INTO `im_modular_field` VALUES ('35','4','内容标题显示','title_num','int','text','1','number','0','','字','0为不限制','0','1','','','0','2023-09-21 23:40:38','2023-10-24 23:41:18','','0','0','');
INSERT INTO `im_modular_field` VALUES ('36','4','内容简介显示','cont_num','int','text','1','number','0','','字','默认为300字','0','1','','','0','2023-09-21 23:41:22','2023-10-24 23:41:24','','0','0','');
INSERT INTO `im_modular_field` VALUES ('37','4','跳转地址','jumpurl','varchar','text','0','','','','','','0','1','','','0','2023-09-21 23:41:56','2023-10-24 23:41:29','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('38','4','SEO关键词','keywords','varchar','text','0','','','','','多个关键词请用英文’,‘进行分割，推荐80字以内','0','1','','','0','2023-09-21 23:42:50','2023-10-24 23:41:34','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('39','4','SEO简介','description','text','textarea','0','','','','','推荐200字以内','0','1','','','0','2023-09-21 23:43:42','2023-10-24 23:41:38','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('40','4','BANNER','banner','varchar','image','0','','','','','','0','1','','','0','2023-09-21 23:44:19','2023-10-24 23:41:42','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('41','4','LOGO','logo','varchar','image','0','','','','','','0','1','','','0','2023-09-21 23:45:22','2023-10-24 23:41:47','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('42','4','栏目密码','password','varchar','text','0','','','','','','0','1','','','0','2023-09-21 23:45:59','2023-10-24 23:41:50','','1','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('43','4','列表样式','temp_late','varchar','select','0','','','','','','0','1','','','0','2023-09-21 23:46:39','2023-10-24 23:41:56','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('44','4','自订义列表页','temp_list','varchar','text','0','','','','','内容页模板地址，如：new_cont.htm','0','1','','','0','2023-09-21 23:47:25','2024-04-22 17:06:26','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('45','4','自订义内容页','temp_cont','varchar','text','0','','','','','内容页模板地址，如：new_cont.htm','0','1','','','0','2023-09-21 23:48:07','2024-04-22 17:06:16','','0','0','SEO及风格');
INSERT INTO `im_modular_field` VALUES ('46','5','产品名称','title','varchar','text','1','','','','','','100','1','','','0','2023-10-24 23:47:01','2023-10-25 08:53:09','','1','0','');
INSERT INTO `im_modular_field` VALUES ('47','5','产品介绍','cont','mediumtext','editor','0','','','','','','0','1','','','0','2023-10-25 08:48:03','2023-10-25 08:48:09','','0','0','');
INSERT INTO `im_modular_field` VALUES ('48','5','产品分类','fid','int','getmodel','0','','','','','','0','1','cms/Goodpart/getlist','title=title_display,value=id','2','2023-10-25 08:49:55','2023-10-25 08:49:55','','1','1','');
INSERT INTO `im_modular_field` VALUES ('49','5','SEO关键词','keywords','varchar','text','0','','','','','多个关键词请用英文’,‘进行分割，推荐80字以内','0','1','','','0','2023-10-25 08:50:44','2023-10-25 08:50:44','','0','0','');
INSERT INTO `im_modular_field` VALUES ('50','5','SEO简介','description','text','textarea','0','','','','','','0','1','','','0','2023-10-25 08:51:13','2023-10-25 08:51:13','','0','0','');
INSERT INTO `im_modular_field` VALUES ('51','5','浏览量','hist','int','hidden','0','','0','','','','0','1','','','0','2023-10-25 08:51:47','2023-10-25 08:51:47','','1','0','');
INSERT INTO `im_modular_field` VALUES ('52','5','推荐','top','tinyint','radio','0','','0','0|不推荐
1|推荐','','','0','1','','','0','2023-10-25 08:52:25','2023-10-25 08:52:25','','1','1','');
INSERT INTO `im_modular_field` VALUES ('53','5','产品图集','imgdata','text','images','0','','','','','','90','1','','','0','2023-10-25 08:53:03','2023-10-25 08:53:11','','0','0','');
INSERT INTO `im_modular_field` VALUES ('54','6','标题','title','varchar','text','1','','','','','','0','1','','','0','2023-10-25 12:01:54','2023-10-25 12:01:54','','1','0','');
INSERT INTO `im_modular_field` VALUES ('55','6','内容','cont','mediumtext','editor','0','','','','','','0','1','','','0','2023-10-25 12:02:33','2023-10-25 12:02:33','','0','0','');
INSERT INTO `im_modular_field` VALUES ('56','6','SEO关键词','keywords','varchar','text','0','','','','','多个关键词请用英文’,‘进行分割，推荐80字以内','0','1','','','0','2023-10-25 12:03:19','2023-10-25 12:03:19','','0','0','');
INSERT INTO `im_modular_field` VALUES ('57','6','SEO简介','description','text','textarea','0','','','','','','0','1','','','0','2023-10-25 12:03:47','2023-10-25 12:03:47','','0','0','');
INSERT INTO `im_modular_field` VALUES ('58','6','页面模板','template','varchar','text','0','','','','','页面模板名称，如：new_cont.htm，请在对应模板目录下创建文件','0','1','','','0','2023-10-25 12:04:36','2024-04-22 17:05:56','','0','0','');
INSERT INTO `im_modular_field` VALUES ('59','5','价格','money','decimal','money','0','','0','','元','','88','1','','','0','2024-04-22 08:54:52','2024-04-22 08:55:01','','1','0','');
INSERT INTO `im_modular_mod` VALUES ('1','1','栏目管理','admin,home,api,member','part','Part','2','0','0','0','0','0','1','2023-09-13 21:05:24','2023-09-23 23:08:07','');
INSERT INTO `im_modular_mod` VALUES ('2','1','文章管理','admin,home,api,member','article','Article','0','0','1','1','0','0','1','2023-09-13 23:40:44','2023-09-30 11:40:52','');
INSERT INTO `im_modular_mod` VALUES ('3','2','站内广告','admin,home,api,member','ad','Ad','0','0','1','1','1','0','1','2023-09-26 22:20:27','2023-10-25 08:25:36','');
INSERT INTO `im_modular_mod` VALUES ('4','1','产品分类','admin,home,api,member','goodpart','Goodpart','2','id asc','1','1','1','0','1','2023-10-24 23:32:14','2023-10-24 23:32:14','');
INSERT INTO `im_modular_mod` VALUES ('5','1','产品管理','admin,home,api,member','goods','Goods','0','0','1','1','1','0','1','2023-10-24 23:46:25','2023-10-24 23:46:25','');
INSERT INTO `im_modular_mod` VALUES ('6','1','单篇内容','admin,home,api,member','show','Show','0','0','1','1','1','0','1','2023-10-25 12:01:20','2024-04-17 15:40:56','');
INSERT INTO `im_money_part` VALUES ('1','金币','150','100','0','1','','2023-08-30 19:49:58','2023-10-19 23:46:33');

INSERT INTO `im_user_group` VALUES ('1','1','超级管理员','im-icon im-person2','0','0','0','0','1','0','0','1','2023-06-16 01:30:09','2023-10-19 16:57:14','');
INSERT INTO `im_user_group` VALUES ('2','2','普通会员','im-icon im-add','0','0','0','0','0','0','0','1','2023-06-16 01:32:14','2023-06-16 01:32:14','');
INSERT INTO `im_user_group` VALUES ('3','2','VIP','im-icon im-add','0','100','1','1','0','0','0','1','2023-06-16 01:32:32','2023-08-30 20:43:30','');
INSERT INTO `im_user_group_part` VALUES ('1','系统组','eru,home,member,api','0','1','2023-06-15 23:52:37','2023-10-19 23:43:44','');
INSERT INTO `im_user_group_part` VALUES ('2','用户组','home,member,api','0','1','2023-06-16 00:09:09','2023-10-19 23:43:52','');
