<?php
declare(strict_types = 1);
namespace app\install\controller;

use app\common\controller\Base;
use app\common\imtrait\ImTrait;
use app\common\model\SqlManage;
use app\common\model\User;
use think\exception\ValidateException;
use think\facade\{Cache,Config,Db};

class Index extends Base
{
    use ImTrait;
    protected function initialize()
    {
        parent::initialize();
        $this->space_name = 'home';
        //  设置模板
        $this->request->viewconf = $this->SetView(['app' => $this->space_name,'default_dir' => 'install']);
    }
    public function index(){
        return $this->ResHomeRead();
    }
    public function one(){
        $_os = $this->xitong();
        $_hanshu = $this->hanshu();
        $_check_dirs = $this->check_dirs();
        $check = $_os['check'];
        $check = !$_hanshu['check'] ? false : $check;
        $check = !$_check_dirs['check'] ? false : $check;
        $res = [
            'xitong' => $_os['data'],
            'hanshu' => $_hanshu['data'],
            'check_dirs' => $_check_dirs['data'],
            'check' => $check,
        ];
        return $this->ResHomeRead($res);
    }
    public function two(){
        $data = $this->SaveCheck();
        try {
            validate('app\\install\\validate\\Install')->scene("database")->check($data['db']);
        }catch (ValidateException $e){
            ResClient($e->getError(),'0');
        }
        try {
            validate('app\\install\\validate\\Install')->scene("webdata")->check($data['web']);
        }catch (ValidateException $e){
            ResClient($e->getError(),'0');
        }
        $this->checkdatabase($data['db']);
        session('webdata',$data['web']);
        ResClient('验证通过,开始安装数据库');
    }
    public function three(){
        if(Cache::has('base_sql') && $this->getdata['code'] != '999'){
            $res = Cache::get('base_sql');
        } else {
            $this->GetSql();
            ResClient('读取数据库文件成功，准备导入数据......','2',['url' => url('three')->domain(true)->build()],url('three')->domain(true)->build());
        }
        $_set = array_splice($res,0,1);

        $_m = new SqlManage();
        $_res = $_m->RevertSql($_set['0']);

        if(!$_res){
            ResClient("写入数据库失败，请重试：{$_set['0']}",'0');
        }
        if(count($res) < '1'){
            Cache::delete('base_sql');
            ResClient('导入数据完成，准备写入管理账号......','2',['url' => url('four')->domain(true)->build()],url('four')->domain(true)->build());
        }
        Cache::set('base_sql',$res);
        ResClient("写入：{$_set['0']}",'2',['url' => url('three')->domain(true)->build()],url('three')->domain(true)->build());
    }
    public function four(){
        $webdata = session('webdata');
        Db::name('config')->whereField('web_title')->update(['conf_value' => $webdata['web_title']]);
        Db::name('config')->whereField('web_title_min')->update(['conf_value' => $webdata['web_title']]);
        Db::name('config')->whereField('web_keywords')->update(['conf_value' => $webdata['web_title']]);
        Db::name('config')->whereField('web_description')->update(['conf_value' => $webdata['web_title']]);
        Db::name('config')->whereField('web_url')->update(['conf_value' => $webdata['web_url']]);
        $user = [
            'u_name' => $webdata['u_name'],
            'u_groupid' => '1',
            'u_password' => $webdata['u_password'],
            'status' => '1',
        ];
        $_m = new User();
        $user = $_m->EditAdd($user);
        $_m->SetOne($user);
        session('webdata',null);
        //  写入锁文件
        $add = [
            'add' => date('Y-m-d H:i:s'),
            'version_no' => '3.0.0',
            'server' => 'https://wormcms.com',
        ];
        WriteFile(base_path().'app.lock', json_encode($add,JSON_UNESCAPED_UNICODE));
        ResClient('系统安装完成','1');
    }
    //  检测系统信息
    protected function xitong(){
        $xitong = [
            'os' =>['操作系统','无限制','linux',PHP_OS,'success'],
            'php' => ['PHP版本','8.0','8.0及以上',PHP_VERSION,'success'],
            'gd' => ['GD库','2.0','2.0','检测中...','success'],
            'upload' => ['附件上传','无限制','2MB','检测中...','success'],
            'dirs' => ['磁盘空间','100MB','>100MB','检测中...','success'],
        ];
        $osstatus = true;
        //  检测php版本号
        if ($xitong['php'][3] < $xitong['php'][1]) {
            $xitong['php'][4] = 'error';
            $osstatus = false;
        }
        //  检测附件上传
        if(@ini_get('file_uploads')){
            $xitong['upload'][3] = ini_get('upload_max_filesize');
        }
        //  检测磁盘空间
        if(function_exists('disk_free_space')){
            $_dirs = floor(disk_free_space(root_path())/(1024*2));
            $xitong['dirs'][3] = $_dirs > '100' ? '大于 100 MB' : $_dirs.' MB';
            if($_dirs < 100){
                $osstatus = false;
            }
        }
        //  检测GD库
        $temparr = function_exists('gd_info') ? gd_info() : array();
        if(empty($temparr['GD Version'])){
            $xitong['gd'][3] = '未安装GD库';
            $xitong['gd'][4] = 'error';
            $osstatus = false;
        }else{
            $xitong['gd'][3] = $temparr['GD Version'];
        }
        unset($temparr);
        return ['data' => $xitong,'check' => $osstatus];
    }
    //  检测函数
    protected function hanshu(){
        $hanshu = [
            'pdo' => ['pdo()','支持','支持','success','class'],
            'pdo_mysql' => ['pdo_mysql()','支持','支持','success','mod'],
            'openssl' => ['openssl()','支持','支持','success','mod'],
//            'redis' => ['redis','支持','支持','success','mod'],
            'gd' => ['gd()','支持','支持','success','mod'],
            'mbstring' => ['mbstring()','支持','支持','success','mod'],
            'zip' => ['zip()','支持','支持','success','mod'],
            'fileinfo' => ['fileinfo()','支持','支持','success','mod'],
            'curl' => ['curl()','支持','支持','success','mod'],
            'xml' => ['xml()','支持','支持','success','fons'],
            'mb_strlen' => ['mb_strlen()','支持','支持','success','fons'],
        ];
        $osstatus = true;
        foreach ($hanshu as $k => $v) {
            if(('class'==$v[4] && !class_exists($k)) || ('mod'==$v[4] && !extension_loaded($k)) || ('fons'==$v[4] && !function_exists($k)) ) {
                $v[2] = '不支持';
                $v[3] = 'no';
                $osstatus = false;
            }
            $hanshu[$k] = $v;
        }
        return ['data' => $hanshu,'check' => $osstatus];
    }
    //  检测写入权限
    protected function check_dirs(){
        $check_dirs = [
            'runtime' => ['runtime','可写','可写','success','dir'],
            'upload_file' => ['upload_file','可写','可写','success','dir'],
            'conf' => ['config','可写','可写','success','dir'],
        ];
        $osstatus = true;
        foreach ($check_dirs as $k => $v){
            if($v['4'] == 'dir'){
                if (!file_exists($v['0'])) {
                    @mkdir($v['0'],0755,true);
                }
                if(!is_writable(root_path().$v['0'])){
                    if(is_dir(root_path().$v['0'])){
                        $v['2'] = '不可写';
                        $v['3'] = 'error';
                        $osstatus = false;
                    }else{
                        $v['2'] = '不存在';
                        $v['3'] = 'error';
                        $osstatus = false;
                    }
                }
            }else{
                if(file_exists(root_path().$v['0'])){
                    if(!is_writable(root_path().$v['0'])){
                        $v['2'] = '不存在';
                        $v['3'] = 'error';
                        $osstatus = false;
                    }
                }else{
                    $v['2'] = '不存在';
                    $v['3'] = 'error';
                    $osstatus = false;
                }
            }
            $check_dirs[$k] = $v;
        }
        return ['data' => $check_dirs,'check' => $osstatus];
    }
    //  验证数据库
    protected function checkdatabase($data){
        $config = include config_path().'database.php';
        foreach ($data as $k => $v) {
            if (array_key_exists($k, $config['connections']['mysql']) === false) {
                ResClient('参数'.$k.'不存在！','0');
            }
            $config['connections']['mysql'][$k] = $v;
        }
        Config::set($config, 'database');
        $db_instance = Db::connect('mysql');
        try{
            $db_instance->execute('select version()');
        }catch(\Exception $e){
            ResClient('数据库连接失败，请检查数据库配置！','0');
        }
        $this->mkDatabase($data);
        return true;
    }
    //  生成配置文件
    protected function mkDatabase($data){
        $code = "<?php
return [
    'default'         => env('database.driver', 'mysql'),
    'time_query_rule' => [],
    'auto_timestamp'  => true,
    'datetime_format' => 'Y-m-d H:i:s',
    'connections'     => [
        'mysql' => [
            'type'              => env('database.type', 'mysql'),
            'hostname'          => env('database.hostname', '{$data['hostname']}'),
            'database'          => env('database.database', '{$data['database']}'),
            'username'          => env('database.username', '{$data['username']}'),
            'password'          => env('database.password', '{$data['password']}'),
            'hostport'          => env('database.hostport', '{$data['hostport']}'),
            'params'            => [],
            'charset'           => env('database.charset', 'utf8mb4'),
            'prefix'            => env('database.prefix', '{$data['prefix']}'),
            'deploy'            => 0,
            'rw_separate'       => false,
            'master_num'        => 1,
            'slave_no'          => '',
            'fields_strict'     => true,
            'break_reconnect'   => false,
            'trigger_sql'       => env('app_debug', true),
            'fields_cache'      => false,
            'schema_cache_path' => app()->getRuntimePath() . 'schema' . DIRECTORY_SEPARATOR,
        ],
    ],
];";
        $formsrb = WriteFile(config_path().'database.php', $code);
        // 判断写入是否成功
        if (empty($formsrb['code'])) {
            ResClient('数据库配置写入失败！','0');
        }
        $code = "<?php
return [
    'default' => env('cache.driver', 'file'),
    'stores'  => [
        'file' => [
            'type'       => 'File',
            'path'       => '',
            'prefix'     => '{$data['database']}_',
            'expire'     => 3600,
            'serialize'  => [],
        ],
    ],
];";
        $formsrb = WriteFile(config_path().'cache.php', $code);
        if (empty($formsrb['code'])) {
            ResClient('配置文件写入失败！','0');
        }
        return true;
    }
    //  读取SQL文件
    protected function GetSql(){
        //  查询数据库文件
        $res = GetReadFile(app_path('config') . 'base.sql');
        $res = explode("\n",$res);
        $res = DataTrim($res);
        $res = DelNull($res);

        $database = Config::get('database');
        $database = $database['connections'][$database['default']];
        foreach ($res as $k => $v){
            $_v = substr($v,0,4);
            if(strpos($_v,"#") !== false || strpos($_v,"--") !== false){
                unset($res[$k]);
            }
            if ($v == 'BEGIN;' || $v =='COMMIT;') {
                unset($res[$k]);
                continue;
            }
            // 替换表前缀
            $v = $_v == 'DROP' ? str_replace('im_', $database['prefix'], $v) : str_replace('`im_', '`'.$database['prefix'], $v);
            $res[$k] = $v;
        }
        $res = implode("\n",$res);
        $res = str_replace("\r",'',$res);
        $res = explode(";\n",$res);
        Cache::set('base_sql',$res);
        return $res;
    }
}