layui.define(function(exports) {
    const layer = layui.layer,
        layform = layui.form,
        element = layui.element,
        laydate = layui.laydate;
    let see = {};
    // post提交数据
    see.AppPost = function (url,data = '',fun = '') {
        $.post(url,data,function (res) {
            if(typeof fun == "function"){
                fun(res);
            } else {
                layer.msg(res.msg,{},function () {
                    if(res.code.toString() === '1'){
                        return true;
                    }else if (res.code.toString() === '0'){
                        return false;
                    }
                })
            }
        }).fail(function () {
            layer.closeAll('loading');
            layer.alert('系统错误，请稍后再试！');
        });
    }
    see.AppGet = function (url,data = '',fun = '') {
        $.get(url,data,function (res) {
            layer.closeAll('loading');
            if(typeof fun == "function"){
                fun(res);
            } else {
                layer.msg(res.msg,{},function () {
                    if(res.code.toString() === '1'){
                        return true;
                    }else if (res.code.toString() === '0'){
                        return false;
                    }
                })
            }
        }).fail(function () {
            layer.closeAll('loading');
            layer.alert('系统错误，请稍后再试！');
        });
    }
    //  打开弹层
    see.OpenWind = function (o){
        let d = $(o).data(),
            w = $(window).width() * 0.8;
        d.reload = d.reload ?? '1';
        let index = layer.open({
            type: d.types ? d.types : 2,
            title: d.title,
            area: `${w}px`,
            skin:'addopen',
            offset: '5px',
            maxmin: true,
            anim: `slideDown`,
            content: d.class ? $(`.${d.class}`) : d.url,
            success: function (layero, index,that) {

            },
            end:function (){
                if(d.reload.toString() === '1'){
                    window.location.reload()
                }
            }
        });
        if(d.full === 'y') {
            layer.full(index);
        }
    }
    //  跳转页面
    see.ToWeb = function (o,getview = true){
        let d = getview ? $(o).data() : o,
            _iframe = parent.layer.getFrameIndex(window.name);
        if(typeof _iframe === 'undefined'){
            window.location.href = d.url;
        }else{
            parent.layer.iframeSrc(_iframe, d.url);
        }
    }
    //  渲染权限菜单
    see.GroupAuthEdit = function (data,fun = ''){
        let _temp = see.EachAuth(data);
        $(`._authrulelist`).html(_temp);
        layform.render('checkbox');
        if(typeof fun === 'function'){
            fun();
        }
    }
    //  处理权限
    see.EachAuth = function (data,pid = '0'){
        let authtemp = ``;
        $.each(data,function (k,v){
            if(v.pid.toString() === pid.toString()){
                let _class = v.pid.toString() === '0' ? `` : `ery-pad-lr20`,
                    _checked = v.default ? `checked` : ``,
                    _addtemp = ``,
                    _res = see.EachAuth(data,v.id);
                if(v.action_part){
                    let _readcheched = v.action_default && $.inArray(`read`,v.action_default) > -1 ? `checked` : ``,
                        _createcheched = v.action_default && $.inArray(`create`,v.action_default) > -1 ? `checked` : ``,
                        _editcheched = v.action_default && $.inArray(`edit`,v.action_default) > -1 ? `checked` : ``,
                        _delcheched = v.action_default && $.inArray(`del`,v.action_default) > -1 ? `checked` : ``;
                    _addtemp += v.action_part.read ? `<div class="ery-pad-lr10 _cid" data-id="${v.id}"><input type="checkbox" class="aid" name="action[${v.id}][]" title="查看" value="read" lay-skin="primary" lay-filter="authcheckbox" ${_readcheched}></div>` : '';
                    _addtemp += v.action_part.create ? `<div class="ery-pad-lr10 _cid" data-id="${v.id}"><input type="checkbox" class="aid" name="action[${v.id}][]" title="添加" value="create" lay-skin="primary" lay-filter="authcheckbox" ${_createcheched}></div>` : '';
                    _addtemp += v.action_part.edit ? `<div class="ery-pad-lr10 _cid" data-id="${v.id}"><input type="checkbox" class="aid" name="action[${v.id}][]" title="编辑" value="edit" lay-skin="primary" lay-filter="authcheckbox" ${_editcheched}></div>` : '';
                    _addtemp += v.action_part.del ? `<div class="ery-pad-lr10 _cid" data-id="${v.id}"><input type="checkbox" class="aid" name="action[${v.id}][]" title="删除" value="del" lay-skin="primary" lay-filter="authcheckbox" ${_delcheched}></div>` : '';
                }
                _res = _res.length > 0 ? `<ul class="layout ery-fex-l ery-fex-column ery-pad-tb5">${_res}</ul>` : _res;
                authtemp += `<li class="layout ery-fex-l _mid  ${_class} ery-pad-tb5" data-pid="${v.pid}" data-id="${v.id}"><input type="checkbox" class="_mid${v.id} _pid${v.pid}" name="mid[]" title="${v.title}" value="${v.id}" lay-skin="primary" lay-filter="authcheckbox" ${_checked}>${_addtemp}${_res}</li>`;
            }
        });
        return authtemp;
    }
    //  获取用户菜单
    see.MapMenuList = function (boxname){
        see.AppGet('/admin/index/menu.html',{},function (res){
            let temp = see.EachWinMunuList(res.data);
            $(`.${boxname}`).html(temp);
        });
    }
    //  渲染左侧菜单
    see.EachWinMunuList = function (data,pid = '0',level = 0){
        let _padt = 15 * (level + 1),
            _padd = 15 * (level + 1),
            temp = '';
        data.forEach((v) => {
            if (v.pid.toString() === pid.toString()) {
                let _v = see.EachWinMunuList(data, v.id, level + 1),
                    _icon = v.icon_type.toString() === '0' ? `<i class="${v.icon} ery-mag-r10" title="${v.title}"></i>` : `<img src="${v.icon}" class="ery-img-responsive" alt="${v.title}">`;
                v.icon = v.icon.length > '0' ? _icon : '';
                if (_v.length > 0) {
                    temp += `<li class="layout ery-fex-l ery-fex-column map-menu-libox">
        <div class="layout ery-fex ery-fex-itemsc map-menu-lititle map-click" data-type="MenuIcon" data-cid="${v.id}">
          <div class="ery-fex-l ery-fex-itemsc" style="padding: 10px 10px 10px ${_padt}px">${v.icon} <span class="ery-text-f14 map-menu-litext">${v.title}</span></div>
          <i class="im-icon im-right win-icon${v.id} ery-mag-r10"></i>
        </div>
        <ul class="layout ery-fex-l ery-fex-column map-menu-ul map-menu-ul${v.id} ery-hidden">${_v}</ul>
      </li>`;
                } else {
                    temp += `<li class="layout ery-fex-l ery-fex-itemsc ery-text-lh map-click map-menu-li" data-type="ViewTab" data-url="${v.url}" data-title="${v.title}" data-cid="${v.id}" style="padding: 10px 10px 10px ${_padd}px">${v.icon} <span class="ery-text-f14 map-menu-litext">${v.title}</span></li>`;
                }
            }
        });
        return temp;
    }
    //  左侧菜单点击事件
    see.MenuIcon = function (o){
        let d = $(o).data();
        if($(o).hasClass(`open`)){
            $(o).removeClass(`open`).find(`i.im-unfold`).addClass(`im-right`).removeClass(`im-unfold`).closest(`li`).find(`.map-menu-ul`).addClass(`ery-hidden`);
            return false;
        }
        if(typeof d !== 'undefined') {
            $(`.map-menu-ul${d.cid}`).removeClass(`ery-hidden`);
            $(o).addClass(`open`).find(`i.im-right`).addClass(`im-unfold`).removeClass(`im-right`);
        }
    }
    //  增加右侧内容页面
    see.ViewTab = function (o){
        let d = $(o).data(),
            _add = $(`.map-nav-li${d.cid}`).length;
        if(_add < `1`){
            $(`.map-nav-box`).append(`<li lay-id="${d.cid}"></li>`);
            element.tabAdd(`maptab`, {
                title: d.title,
                content: `<iframe id="iframe${d.cid}" data-frameid="${d.cid}" scrolling="auto" src="${d.url}" style="width:100%;height:100%;" allowfullscreen="true" frameborder="0"></iframe>`,
                id: d.cid,
                change: true,
            });
            $(`li[lay-id="${d.cid}"]`).addClass(`map-nav-li map-nav-li${d.cid} ery-fex-l ery-fex-nowrap`).html(`<span class="map-nav-active"></span><span class="map-nav-title">${d.title}</span><i class="layui-icon layui-icon-close layui-unselect layui-tab-close"></i>`).click();
        }
        $(`li[lay-id="${d.cid}"]`).click();
        element.render('tab', 'maptab');
        see.TabWidth();
    }
    //  计算宽度
    see.TabWidth = function (){
        const $ul = $('.map-nav-ul'),
            containerWidth = $ul.width() - 120,
            $liList = $('.map-nav-li');
        let translate = 0;

        $.each($liList,function (totalWidth, li){
            if ($(li).hasClass('layui-this')) {
                translate += 100;
                return false;
            }
            const liWidth = $(li).width();
            translate += liWidth + 30;
        })
        translate = containerWidth - translate;
        translate = translate < 1 ? translate : 0;
        $('.map-nav-box').css('transform', `translate(${translate}px)`);
    }
    //  左右步长
    see.StepTab = function (o){
        const $o = $(o),
            d = $o.data(),
            $ul = $('.map-nav-ul'),
            $box = $('.map-nav-box'),
            $liList = $('.map-nav-li'),
            w = $ul.width() - 120,
            calculateWidth = ($element) => $element.width() + 31;
        let _w =  $liList.toArray().reduce((totalWidth, li) => totalWidth + calculateWidth($(li)), 0),
            translate = 0;
        if (w < _w) {
            const _tx = parseFloat($box.css('transform').split(',')[4]);
            translate = 0 - _tx;
            translate = w + translate + 100;
            if (d.direction.toString() === 'right') {
                if (_w > translate) {
                    translate = _tx - 100;
                    $box.css('transform', `translate(${translate}px)`);
                }
            } else {
                if (_tx < 0) {
                    translate = (_tx + 100) < 0 ? _tx + 100 : 0;
                    $box.css('transform', `translate(${translate}px)`);
                }
            }
        }
    }
    //  刷新右侧页面
    see.RefreshWind = function (){
        const $currentIframe = $('.layui-tab-item.layui-show').find('iframe');
        $currentIframe.attr('src', $currentIframe.attr('src'));
    }
    //  左侧菜单收缩
    see.LeftStop = function (o){
        const $element = $(o),
            $icon = $element.find('.im-icon'),
            $mapLeft = $('.map-left'),
            $mapRight = $('.map-right'),
            $mapTop = $('.map-top');

        if ($icon.hasClass('im-zhedie-shouqi')) {
            $icon.removeClass('im-zhedie-shouqi').addClass('im-zhedie-zhankai');
            $mapLeft.addClass('min');
            $mapRight.addClass('open');
            $mapTop.addClass('open');
        } else {
            $icon.removeClass('im-zhedie-zhankai').addClass('im-zhedie-shouqi');
            $mapLeft.removeClass('min');
            $mapRight.removeClass('open');
            $mapTop.removeClass('open');
        }
    }
    //  安全退出
    see.OutLogin = function (o){
        let d = $(o).data();
        see.AppPost(d.url,'',function (res){
            if(res.code.toString() === '1'){
                window.location.reload();
            }
        });
    }
    //  获取登录日志
    see.GetUserLogin = function (o,title = ''){
        see.AppGet(`/admin/log_user/getday.html`,{},function (res){
            let xAxis = [],
                series_bar = [],
                series_line = [];
            $.each(res.data,function (k,v){
                xAxis.push(v.time);
                series_bar.push(v.log_num);
                series_line.push(v.user_log_num);
            });
            EchartsView(o, {
                title: {
                    text: title,
                    left: 'center',
                },
                legend: {
                    left: 'left',
                },
                tooltip: {
                    trigger: 'axis',
                },
                xAxis: [
                    {
                        type: 'category',
                        axisTick: {
                            alignWithLabel: true
                        },
                        data: xAxis
                    },{
                        type: 'category',
                        show: false,
                        data: xAxis
                    },
                ],
                yAxis: [
                    {
                        type: 'value',
                        name: '用户',
                        splitLine:{
                            show:false // 不显示网格线
                        },
                        start: 'start',
                        min: 0,
                    },{
                        type: 'value',
                        name: '登录次数',
                        min: 0,
                    }
                ],
                series: [
                    {
                        name: '登录次数',
                        type: 'bar',
                        xAxisIndex: 1,
                        yAxisIndex: 1,
                        data:series_bar
                    }, {
                        name: '用户',
                        type: 'line',
                        data:series_line
                    }
                ]
            });
        });
    }
    let EchartsView = function (o,data){
        let ViewTemp = echarts.init($(`#${o}`).get(0)),
            option;
        option = {
            title: data.title ? data.title : {},
            tooltip: data.tooltip ? data.tooltip : {},
            legend: data.legend ? data.legend : {},
            toolbox: {
                show: true,
                feature: {
                    dataZoom: {},
                    dataView: {},
                    saveAsImage: {}
                }
            },
            grid: data.grid ? data.grid : {
                left: '3%',
                right: '3%',
                bottom: '3%',
                containLabel: true
            },
            xAxis: data.xAxis ? data.xAxis : [],
            yAxis:  data.yAxis ? data.yAxis : [],
            series: data.series ? data.series : [],
        };
        option && ViewTemp.setOption(option);
    };
    //  切换顶部菜单
    element.on('tab(maptab)', function(data){
        let d = $(this).attr(`lay-id`),
            _tab = $(`.map-menu-li[data-cid='${d}']`);
        if(!_tab.hasClass(`open`)){
            $(`.map-menu-li`).removeClass(`open`);
            _tab.addClass(`open`);
            _tab = _tab.closest(`.map-menu-libox`).find(`.map-menu-lititle`);
            if(!_tab.hasClass(`open`)){
                see.MenuIcon(_tab);
            }
        }
        see.TabWidth();
    });
    $(`.map-nav-box`).on('click','.layui-tab-close',function (){
        let _this = $(this).closest(`li`);
        if(_this.hasClass(`layui-this`)){
            _this.prev().click();
        }
        _this.remove();
        let d = _this.attr(`lay-id`);
        $(`#iframe${d}`).closest(`.layui-tab-item`).remove();
        see.TabWidth();
    });
    layform.on('submit(formbasebtn)', function(data){
        let uri = data.form.action;
        see.AppPost(uri,data.field,success = function (res) {
            layer.msg(res.msg);
            if (res.code.toString() === '1') {
                let _iframe = parent.layer.getFrameIndex(window.name);
                if(typeof _iframe !== 'undefined'){
                    parent.layer.close(_iframe);
                }
            }
        });
        return false;
    });
    layform.on('submit(formthisbtn)', function(data){
        let uri = data.form.action;
        see.AppPost(uri,data.field,success = function (res) {
            layer.msg(res.msg);
        });
        return false;
    });
    layform.on('submit(loginbtn)', function(data){
        let uri = data.form.action;
        see.AppPost(uri,data.field,success = function (res) {
            layer.msg(res.msg);
            if (res.code.toString() === '1') {
                window.location.href = res.url;
            } else {
                $(`._captcha`).click();
            }
        });
        return false;
    });
    $("body").on('click', ".map-click", function () {
        let a = $(this),
            b = a.data("type");
        see[b] ? see[b].call(this, a) : ""
    });
    exports("app", see);
});