layui.define(function(exports){
    const layer = layui.layer,
        layform = layui.form;
    let eru = {};
    //  渲染到表格
    eru.viewTable = function(data,flod = '0'){
        let res = [];
        $.each(data,function (k,v){
            let _v = {
                field: v.field ?? ``,
                title: v.title,
                fieldTitle: v.title_edit ?? ``,
                align: v.textalign ?? `left`,
                sort: v.sort ? v.sort : false,
            }
            if(v.width){
                _v.width = v.width.lastIndexOf(`%`) < `0` ? parseInt(v.width) : v.width;
            }
            if(v.min_width){
                _v.minWidth = v.min_width;
            }
            if(v.max_width){
                _v.maxWidth = v.max_width;
            }
            if(v.fixed){
                _v.fixed = v.fixed;
            }
            _v = TableType(_v,v);
            if(flod !== '0' && v.file === 'title'){
                _v.templet = function(d){
                    return d.title_display
                }
            }
            res.push(_v);
        })
        return res;
    }
    let EditDates = function (o,type = 'date'){
            if(!o){
                return '';
            }
            if(o.split('-').length > '1'){
                return o;
            }
            let date = new Date(o * 1000),
                Y = date.getFullYear(),
                M = (date.getMonth()+1 < 10 ? '0' + (date.getMonth()+1) : date.getMonth()+1),
                D = (date.getDate()<10? '0' + date.getDate() : date.getDate()),
                h = (date.getHours()<10?'0' + date.getHours() : date.getHours()),
                m = (date.getMinutes()<10?'0' + date.getMinutes() : date.getMinutes()),
                s = (date.getSeconds()<10?'0' + date.getSeconds() : date.getSeconds());
            let _res = `${Y}-${M}-${D} ${h}:${m}:${s}`;
            switch (type){
                case 'date':
                    _res = `${Y}-${M}-${D}`;
                    break;
                case 'time':
                    _res = `${h}:${m}:${s}`;
                    break;
            }
            return _res;
        },
        //  处理表格TYPE
        TableType = function (_res,data){
            switch (data.type){
                case 'edit':
                    _res.edit = 'text';
                    break;
                case 'select':
                case 'radio':
                    _res.templet = function(d){
                        if(typeof d[_res.field] === 'undefined'){
                            return '';
                        }
                        let _data = data.list,
                            res = '';
                        $.each(_data,function (k,v){
                            let _v = v.value ?? k;
                            v = v.title ?? v;
                            if(d[_res.field].toString() && d[_res.field].toString() === _v.toString()){
                                res = v;
                            }
                        });
                        return res;
                    }
                    break;
                case 'checkbox':
                    _res.type = `checkbox`;
                    if(data.list){
                        _res.type = 'text';
                        _res.templet = function(d){
                            let _data = data.list,
                                _default = d[data.field].split(','),
                                _restemp = [];
                            $.each(_data,function (k,v){
                                let _v = v.value ?? k;
                                v = v.title ?? v;
                                if($.inArray(_v.toString(),_default) > -1){
                                    _restemp.push(v);
                                }
                            });
                            return _restemp.toString();
                        };

                    }
                    break;
                case 'switch':
                    _res.templet = function(d){
                        let _checked = d[_res.field].toString() === data.default.toString() ? 'checked' : '',
                            _disabled = typeof data.disabled !== 'undefined' && data.disabled.toString() === '1' ? 'disabled' : '',
                            _field = data.field_edit ?? data.field,
                            _v = d[data.pk].toString();
                        return typeof data.list === 'undefined' || $.inArray(d[_field].toString(), data.list) !== -1 ? `<input type="checkbox" name="${_res.field}" value="${_v}" lay-skin="switch" data-id="${data.pk}" lay-text="${data.text}" lay-filter="*" ${_checked} ${_disabled}>` : ``;
                    };
                    break;
                case 'btn':
                    let _title = data.title,
                        _opentitle = data.open ? ` data-type='OpenWind' data-title="${data.opentitle ? data.opentitle : data.title}"` : ``,
                        _icon = data.icon ? `<i class="ery-icon ${data.icon}"></i>` : ``,
                        _field = data.field_edit ? data.field_edit : data.field,
                        _full = data.full ? ` data-full='${data.full}'` : ``,
                        _tip = data.tip ? ` data-tip='${data.tip}'` : ``,
                        _reload = data.reload && data.reload.toString() === '0' ? ` data-reload='0'` : ``,
                        _class = data.class ? data.class : `ery-button-s ery-bg-green`;
                    _title = data.text ? `${_icon}<span class="ery-mag-l5">${_title}</span>` : _icon; // 重新定义标题
                    _class = data.open ? _class + ' map-click' : _class;
                    //  如果是单元格事件，则另外处理
                    if(data.event){
                        _res.event = data.event;
                        _class = `${_class} _${data.event}`;
                    }
                    _res.templet = function(d){
                        let _resurl = EditUrl(data.url,d),
                            _url = ` href='${_resurl}'`;
                        _url = data.open || data.event ? ` data-url='${_resurl}'` : _url;
                        return typeof data.list === 'undefined' || $.inArray(d[_field].toString(), data.list) !== -1 ? `<a class="${_class}" ${_url} ${_tip} ${_opentitle} ${_full} ${_reload}>${_title}</a>` : ``;
                    };
                    break;
                case 'icon':
                    _res.templet = function(d){
                        let _class = data.class ? data.class : ``;
                        return `<i class="${d[data.field]} ${_class}"></i>`;
                    };
                    break;
                case 'image':
                    _res.templet = function(d){
                        let img = d[data.field] ?? '';
                        return `<img src="${img}" class="ery-img-responsive" alt="">`;
                    };
                    break;
                case 'date':
                    _res.templet = function(d){
                        return EditDates(d[data.field],'datetime');
                    };
                    break;
                case 'money':
                    _res.templet = function(d){
                        let _money = d[data.field];
                        if(data.adddel){
                            _money = d.add_type_del.toString() === '1' ? `<span class="ery-text-green">- ${_money}</span>` : `<span class="ery-text-red">+ ${_money}</span>`;
                        }
                        return _money;
                    };
                    break;
                case 'list':
                    _res.type = `normal`;
                    _res.templet = function(d){
                        let _t = [];
                        $.each(d[data.field],function (k,v) {
                            _t.push(data.type_field ? v[data.type_field] : v);
                        });
                        return _t.toString();
                    };
                    break;
                default:
                    _res.type = `normal`;
                    //  默认以处理文本的方式处理
                    if(data.list){
                        _res.templet = function(d) {
                            let _val = data.type_field ? data.type_field : data.field;
                            return $.inArray(d[data.field].toString(), data.list) !== -1 ? d[_val] : ``;
                        }
                    }
                    break;
            }
            return _res;
        },
        /**
         * 处理链接
         * @param url 要处理的参数
         * @param data  要替换的数据
         * @returns {*}
         * @constructor
         */
        EditUrl = function (url,data){
            let _url = url.match(/(__.+?__)/g);
            if(_url && _url.length > 0){
                $.each(_url,function (k,v){
                    let _v = v.substring(2, v.length - 2),
                        _d = new RegExp(v,"g");
                    _v = data[_v].toString().length > 0 ? data[_v] : '';
                    url = url.replace(_d,_v);
                })
            }
            return url;
        };
    //  渲染到表单
    eru.GetFormItem = function (data){
        $.each(data,function (k,v){
            data[k] = {
                template: FormType(v),
                field: v.field,
                group: v.group ? v.group : 'stop'
            };
        });
        return data;
    }
    //  处理表单格式
    let FormType = function (_res){
            let _title = _res.title,
                _required = !!_res.required,
                _type = _res.type,
                _temp = ``,
                _file = _res.field;
            switch (_res.type){
                case 'text':
                case 'textarea':
                case 'number':
                case 'hidden':
                    _temp = SetText(_res);
                    break;
                case 'date':
                case 'datetime':
                    _temp = SetDates(_res);
                    break;
                case 'radio':
                    _temp = SetRadio(_res);
                    break;
                case 'money':
                    _temp = SetMoney(_res);
                    break;
                case 'checkbox':
                    _temp = SetCheckbox(_res);
                    break;
                case 'select':
                    _temp = SetSelect(_res);
                    break;
                case 'icon':
                    _temp = SetIcon(_res);
                    break;
                case 'editor':
                    _temp = SetEditOr(_res);
                    break;
                case 'files':
                case 'images':
                case 'zips':
                    _temp = SetFiles(_res);
                    break;
                case 'file':
                case 'video':
                case 'image':
                case 'zip':
                    _temp = SetFile(_res);
                    break;
                case 'getmodel':
                    _temp = SetGetUrl(_res);
                    break;
                case 'chinafucode':
                    _temp = SetChinaFucode(_res);
                    break;
            }
            _title = _required ? `<span class="ery-text-red">*</span>${_title}` : _title;
            //  判断是否存在联动
            if(_res.file_link){
                _temp += GroupLink(_res.file_link,_res.type,_file,_res.default);
            }
            _type = _res.type_edit && typeof _res.type_edit !== 'undefined' ? _res.type_edit : _type;
            //  判断是否隐藏元素
            let _hidden = _type === 'hidden' ? `display:none;` : ``,
                _boxwidth = _res.boxwidth ? _res.boxwidth : `layout`,
                _tip = _res.tip && typeof _res.tip !== 'undefined' ? `<div class="layout ery-text-black-3 ery-text-f14 ery-pad-lr10 ery-text-lh">${_res.tip}</div>` : ``;
            return SetTemp(_temp,_file,_title,_tip,_hidden,_boxwidth);
        },
        /**
         * 处理input表单。
         * @param data
         * @returns {string}
         * @constructor
         */
        SetText = function (data){
            let _title = data.title_edit && typeof data.title_edit !== 'undefined' ? data.title_edit : data.title,
                _type = data.type_edit && typeof data.type_edit !== 'undefined' ? data.type_edit : data.type,
                _value = typeof data.default !== 'undefined' ? data.default.toString() : ``,
                _required = data.required && typeof data.required !== 'undefined' ? `required='true' lay-verify='required'` : ``,
                _disabled = data.disabled && typeof data.disabled !== 'undefined' ? `disabled='true'` : ``,
                _verify = data.required_list && typeof data.required_list !== 'undefined' ? `lay-verify='${data.required_list}'` : ``,
                _unit = data.unit && typeof data.unit !== 'undefined' ? `<div class="ery-ipt-icon ery-bg-white-4" style='border-top-right-radius: 4px;border-bottom-right-radius: 4px;'>${data.unit}</div>` : ``,
                _inpstyle = _unit ? `style='border-top-right-radius: 0;border-bottom-right-radius: 0;'` : ``;
            let temp =  _type === 'textarea' ?
                `<textarea class="ery-ipt" rows="4" placeholder="请输入${_title}" type="${_type}" name="${data.field}" id="${data.field}" ${_required} ${_verify}  ${_inpstyle}>${_value}</textarea>${_unit}` :
                `<input class="ery-ipt" placeholder="请输入${_title}" type="${_type}" name="${data.field}" value="${_value}" id="${data.field}" ${_required} ${_verify}  ${_inpstyle}  ${_disabled}>${_unit}`;
            if(_unit){
                temp = `<div class="layout ery-form-itemnowarp">${temp}</div>`
            }
            return temp;
        },
        /**
         * 处理Radio
         * @param data
         * @returns {string}
         * @constructor
         */
        SetRadio = function(data){
            let _temp = ``,
                _default = data.default.toString() && typeof data.default !== 'undefined' ? data.default.toString() : '';
            $.each(data.list,function (k,v){
                let _title = typeof v.title !== 'undefined' && v.title.toString() ? v.title.toString() : v,
                    _value = typeof v.value !== 'undefined' && v.value.toString() ? v.value.toString() : v.toString(),
                    _checked = _value === _default ? `checked` : ``;
                _temp += `<input type="radio" name="${data.field}" value="${_value}" title="${_title}" ${_checked} lay-filter="${data.field}">`;
            });
            return _temp;
        },
        SetCheckbox = function(data){
            if(data.type_edit && typeof data.type_edit !== 'undefined' && data.type_edit === 'select_checkbox'){
                return SetSelectCheckbox(data);
            }
            let _temp = ``,
                _default = data.default && typeof data.default !== 'undefined' ? data.default : [],
                _required = data.required && typeof data.required !== 'undefined' ? ` required='true' lay-verify='required'` : ``,
                _disabled = data.disabled && typeof data.disabled !== 'undefined' ? `disabled='true'` : ``,
                _verify = data.required_list && typeof data.required_list !== 'undefined' ? ` lay-verify='${data.required_list}'` : ``;
            $.each(data.list,function (k,v){
                let _checked = $.inArray(v.value.toString(), _default) !== -1 ? 'checked' : '';
                _temp += `<input type="checkbox" name="${data.field}[]" value="${v.value}" title="${v.title}" ${_checked} ${_required} ${_verify}  ${_disabled}  lay-filter="${data.field}" lay-skin="primary">`;
            });
            return _temp;
        },
        /**
         * 处理金额
         * @param data
         * @returns {string}
         * @constructor
         */
        SetMoney = function (data){
            let _title = data.title_edit && typeof data.title_edit !== 'undefined' ? data.title_edit : data.title,
                _value = typeof data.default !== 'undefined' ? data.default.toString() : ``,
                _required = data.required && typeof data.required !== 'undefined' ? `required='true' lay-verify='required'` : ``,
                _disabled = data.disabled && typeof data.disabled !== 'undefined' ? `disabled='true'` : ``,
                _verify = data.required_list && typeof data.required_list !== 'undefined' ? `lay-verify='${data.required_list}'` : ``,
                _unit = data.unit && typeof data.unit !== 'undefined' ? `<div class="ery-ipt-icon ery-bg-white-4" style='border-top-right-radius: 4px;border-bottom-right-radius: 4px;'>${data.unit}</div>` : ``,
                _inpstyle = _unit ? `style='border-top-right-radius: 0;border-bottom-right-radius: 0;'` : ``;

            let temp = `<input class="ery-ipt" placeholder="请输入${_title}" type="text" name="${data.field}" value="${_value}" id="${data.field}" ${_required} ${_verify}  ${_inpstyle}  ${_disabled}>${_unit}`;
            if(_unit){
                temp = `<div class="layout ery-form-itemnowarp">${temp}</div>`
            }
            return temp;
        },
        /**
         * 处理Select
         * @param data
         * @returns {string}
         * @constructor
         */
        SetSelect = function(data){
            let _temp = ``,
                _default = data.default.toString().length > '0' && typeof data.default !== 'undefined' ? data.default.toString() : '',
                _required = data.required && typeof data.required !== 'undefined' ? ` required='true' lay-verify='required'` : ``,
                _verify = data.required_list && typeof data.required_list !== 'undefined' ? ` lay-verify='${data.required_list}'` : ``,
                _disabled = data.disabled && typeof data.disabled !== 'undefined' ? `disabled='true'` : ``,
                _selecttitle = data.title_edit && typeof data.title_edit !== 'undefined' ? `请选择${data.title_edit}` : `请选择${data.title}`;
            if(data.text){
                _temp += `<option value="">${_selecttitle}</option>`;
            }
            $.each(data.list, function (k, v) {
                let _selected = v.value.toString() === _default ? `selected` : ``;
                _temp += `<option value="${v.value}" ${_selected}>${v.title}</option>`;
            });
            return `<select name="${data.field}" id="${data.field}" ${_required} ${_verify} ${_disabled} lay-filter="${data.field}">${_temp}</select>`;
        },
        /**
         * 处理icon图标
         * @param data
         * @constructor
         */
        SetIcon = function(data){
            let _value = data.default && typeof data.default !== 'undefined' ? data.default : `im-icon im-add`,
                _del = data.default.length === 0 ? `style='display: none'` : ``;
            return `<div class="ery-fex-l ery-fex-itemsc"> <div class="ery-fex-c ery-fex-itemsc ery-bor ery-bor-white-3" style="width: 50px;height: 50px;"> <i class="${data.field}icon ${_value}" style="font-size: 2rem" onclick="${data.field}icon()" data-cid="_im-icon"></i> </div> <div class="ery-mag-l15"> <a class="ery-button-s ery-bor-green" onclick="${data.field}icon()" data-cid="_im-icon">选择图标</a> <a class="ery-button-s ery-bor-red ery-mag-l5 ${data.field}del" onclick="del${data.field}()" ${_del}>删除图标</a> </div> </div><input type="hidden" class="ery-ipt ${data.field}val" name="${data.field}" value="${_value}"> <script> let _icon = $('._im-icon'); if(_icon.length === 0){ $.get('/hook/piece.html',{n:'icon'},function (res){ $('body').append(\`<ul class='_im-icon ery-fex-l' style='display: none;'></ul>\`); if(res.code.toString() === '0'){ layer.msg('获取图标失败'); return false; } $.each(res.data,function(k,v) { $('._im-icon').append(\`<li class='ery-pad-a15'><i class='im-icon \${v}' style='font-size:3rem;' onclick='set${data.field}(this)'></i></li>\`); }); }); } 
 function ${data.field}icon(){ layer.open({ type: 1, title: "选择图标", content: $('._im-icon'), area:['50%','50%'], }); } function set${data.field}(o){ $(\`.${data.field}icon\`).attr('class',$(o).attr('class')).addClass(\`${data.field}icon\`); $(\`.${data.field}val\`).val($(o).attr('class')); $(\`.${data.field}del\`).show(); layer.closeAll('page'); } function del${data.field}(){ $(\`.${data.field}icon\`).attr('class','im-icon im-add ${data.field}icon'); $(\`.${data.field}val\`).val(''); $(\`.${data.field}del\`).hide(); } </script>`;
        },
        /**
         * 单文件 / 单图片上传
         * @param data
         * @returns {string}
         * @constructor
         */
        SetFile = function (data){
            let _value = typeof data.default !== 'undefined' ? data.default.toString() : ``,
                _required = data.required && typeof data.required !== 'undefined' ? `required='true'` : ``,
                _img = _value ? `<img src="${_value}" class="ery-img-responsive">` : `<i class="im-icon im-upload ery-text-f20"></i>`,
                _del = _value ? `<i class="im-icon im-delete ery-text-red ery-pos-a" onclick="${data.field}del(this)" style="background-color: rgba(255,255,255,0.3);top: 0;right: 0;"></i>` : ``,
                _script = `<script>
    let ${data.field}upload = new EruUpload({
        monitor:"._${data.field}box",
        url:'/hook/upload/save.html',
        autoup:true,
    });
    ${data.field}upload.before = function (o,d){
        let t = \`<img src='\$\{o.icon\}' class='ery-img-responsive'>\`;
    if(d.exp && d.exp !== 'image'){
        t = \`<i class="im-icon im-file" style='font-size:3rem;'></i>\`;
    }
    \$(d.monitor).html(t);
}
    ${data.field}upload.success = function (res,obj,conf){
    if(res.code.toString() === '1'){
        \$(\`._${data.field}val\`).val(res.data.url);
    }
}
function ${data.field}del(o){
    \$(\`._${data.field}box\`).html(\`<i class="im-icon im-upload ery-text-f20"></i>\`);
    \$(\`._${data.field}val\`).val(\`\`);
    \$(o).remove();
}
</script>`;
            switch (data.type){
                case 'zip':
                    _img = `<i class="im-icon im-fuwuqi ery-text-f20"></i>`;
                    break;
                case 'file':
                    _img = `<i class="im-icon im-file ery-text-f20"></i>`;
                    break;
                case 'video':
                    _img = `<video src="${_value}"></video>`;
                    break;
            }
            return `<div class="ery-upload-box"><div class="ery-bg-imgbox ery-bor ery-bor-white-3">
    <div class="ery-bg-img ery-fex-c ery-fex-itemsc _${data.field}box" data-name="${data.field}" data-exp="${data.type}" data-filenum="1">${_img}</div>${_del}
</div><input class="layout _${data.field}val" type="hidden" name="${data.field}" value="${_value}" ${_required}></div>${_script}`;
        },
        /**
         * 多文件 / 多图片上传
         * @param data
         * @returns {string}
         * @constructor
         */
        SetFiles = function (data){
            let _type = data.type === 'images' ? 'image/*' : '',
                _list = typeof data.default !== 'undefined' ? data.default : ``,
                _img = data.type === 'images' ? `` : `<i class="im-icon im-upload"></i>`,
                _temp = ``;
            if(_list){
                $.each(_list,function (k,v){
                    _temp += `<div class="ery-upload-box ery-pad-a10 _${data.field}${k}">
    <div class="ery-bg-imgbox ery-bor ery-bor-white-3">
    <div class="ery-bg-img ery-fex-c ery-fex-itemsc">
    <img src="${v.url}" onerror="this.src='/public/static/image/imgnone.jpg'" class="ery-img-responsive">
    <input type="hidden" class="${data.field}${k}title" name="${data.field}[${k}][title]" value="${v.title}">
    <input type="hidden" class="${data.field}${k}url" name="${data.field}[${k}][url]" value="${v.url}">
    <input type="hidden" class="${data.field}${k}size" name="${data.field}[${k}][size]" value="${v.size}">
    </div>
    <div class="ery-upload-delicon" onclick="del${data.field}(this)"><i class="im-icon im-delete"></i></div>
    </div>
    </div>`;
                });
            }
            return `<div class="layout ery-fex-l _${data.field}list"><div class="ery-upload-box ery-pad-a10">
<div class="ery-bg-imgbox ery-bor ery-bor-white-3">
    <div class="ery-bg-img ery-fex-c ery-fex-itemsc _${data.field}box" data-name="${data.field}">
    <i class="im-icon im-upload"></i>
    </div>
</div>
</div>
${_temp}
</div><script>
let ${data.field}upload = new EruUpload({
        monitor:"._${data.field}box",
        url:'/hook/upload/save.html',
        autoup:true,
        filetype: '${_type}',
        multiple:true,
});
${data.field}upload.before = function (obj,conf){
    let t = \`<div class="ery-upload-box ery-pad-a10 _\${obj.md5}">
<div class="ery-bg-imgbox ery-bor ery-bor-white-3">
<div class="ery-bg-img ery-fex-c ery-fex-itemsc">
<img src="\${obj.icon}" onerror="this.src='/public/static/image/file.png'" class="ery-img-responsive">
<input type="hidden" class="\${obj.md5}title" name="\${conf.name}[\${obj.md5}][title]" value="">
<input type="hidden" class="\${obj.md5}url" name="\${conf.name}[\${obj.md5}][url]" value="">
<input type="hidden" class="\${obj.md5}size" name="\${conf.name}[\${obj.md5}][size]" value="">
</div>
<div class="ery-upload-delicon" onclick="del${data.field}(this)"><i class="im-icon im-delete"></i></div>
</div>
</div>\`;
    $(\`._\${conf.name}list\`).append(t);
}
${data.field}upload.success = function (res,obj){
    if(res.code.toString() === '1'){
        \$(\`.\${obj.md5}title\`).val(res.data.title);
        \$(\`.\${obj.md5}url\`).val(res.data.url);
        \$(\`.\${obj.md5}size\`).val(res.data.size);
    }
}
function del${data.field}(o){
    \$(o).closest('.ery-upload-box').remove();
}
</script>`;
        },
        /**
         * 处理富文本编辑器
         * @param data
         * @returns {string}
         * @constructor
         */
        SetEditOr = function (data){
            let _value = data.default && typeof data.default !== 'undefined' ? data.default : ``;
            return `<div id="editor-container"></div>
        <textarea name="${data.field}" class="_${data.field} ery-hidden">${_value}</textarea>
<script>
let E = window.wangEditor,
        ${data.field}editor = new E('#editor-container');
    ${data.field}editor.config.fontSizes = {
        'x-small': { name: '12px', value: '1' },
        'small': { name: '14px', value: '2' },
        'normal': { name: '16px', value: '3' },
        'large': { name: '18px', value: '4' },
        'x-large': { name: '24px', value: '5' },
        'xx-large': { name: '32px', value: '6' },
        'xxx-large': { name: '48px', value: '7' },
    };
    ${data.field}editor.config.colors = [
        '#000000',
        '#333333',
        '#666666',
        '#999999',
        
        '#cc0033',
        '#FF3300',
        '#FF0000',
        '#FF0066',
        
        '#000066',
        '#000099',
        '#0000CC',
        '#0000FF',
        
        '#006600',
        '#009900',
        '#00CC00',
        '#00FF00',
        
        '#FF6600',
        '#FF9900',
        '#FFCC00',
        '#FFFF00',
    ];
    ${data.field}editor.config.uploadImgServer = '/hook/upload/wangeditor.html';
    ${data.field}editor.config.height = 480;
    ${data.field}editor.config.onchange = function (html) {
        $('._${data.field}').val(html)
    };
    ${data.field}editor.create();
    ${data.field}editor.txt.html(\`${_value}\`);
</script>`;
        },
        /**
         * 调用其他模块
         * @param data
         * @returns
         * @constructor
         */
        SetGetUrl = function (data){
            let _required = data.required && typeof data.required !== 'undefined' ? `required='true' lay-verify='required'` : ``,
                _temp = `<div class='layout ery-mag-b10'><input class="_${data.field}so ery-ipt" placeholder="搜索${data.title}" value=""></div><div class='_${data.field}list'></div><div class='_${data.field}page'></div><input name="${data.field}" type="hidden" class="_${data.field}val" value="${data.default}" ${_required}>`;
            if(data.gettype.toString() === '0'){
                _temp = `<div class='layout ery-mag-b10'><input class="_${data.field}so ery-ipt" placeholder="搜索${data.title}" value=""></div><div class='_${data.field}list'></div><div class='_${data.field}page'></div>`;
            } else if(data.gettype.toString() === '2'){
                _temp = `<select name="${data.field}" class='_${data.field}list' id="${data.field}" ${_required} lay-filter="${data.field}" lay-search></select>`;
            }
            return `${_temp}
<script>
            layui.use(['eruyun_table','form'],function (){
                let erutable = layui.eruyun_table,
                    layform = layui.form,
                    _${data.field}pages = false,
                    _${data.field}getweb = {total:0,per_page:0,current_page:0,last_page:0},
                    _${data.field}temp = function (_data){
                        _data = JSON.parse(_data);
                        if('${data.gettype}' === '0'){
                            let checked = _data.${data.fielddata.value}.toString() === '${data.default}' ? 'checked' : '';
                            return \`<input type='radio' name="${data.field}" value='\${_data.${data.fielddata.value}}' title='\${_data.${data.fielddata.title}}' lay-filter="${data.field}" \${checked}>\`;
                        }else if('${data.gettype}' === '1') {
                            let _default = '${data.default}';
                                _default = _default.split(',');
                            let checked = $.inArray(_data.${data.fielddata.value}.toString(),_default) > -1 ? 'checked' : '';
                                return \`<input type='checkbox' name="_${data.field}[]" value='\${_data.${data.fielddata.value}}' title='\${_data.${data.fielddata.title}}' lay-skin="primary" lay-filter="${data.field}" \${checked}>\`;
                        }else{
                             let _selected = _data.${data.fielddata.value}.toString() === '${data.default}' ? 'selected' : '';
                             return \`<option value="\${_data.${data.fielddata.value}}" \${_selected}>\${_data.${data.fielddata.title}}</option>\`;
                        }
                    },
                     _${data.field}click = function (){
                        let _getweb = _${data.field}getweb;
                        $('.${data.field}gopage').click(function (o){
                            let _d = $(o.target).data();
                            _getweb.current_page = _d.page;
                            _get${data.field}list();
                        });
                     },
                    _get${data.field}list = function (_data = {},success = ''){
                        if(_${data.field}pages){
                            _data.page = _${data.field}getweb.current_page;
                            _data.limit = _${data.field}getweb.per_page;
                        }
                        erutable.GetUrl('${data.geturl}',_data,function (res){
                            if(res.data.total){
                                _${data.field}pages = true;
                                _${data.field}getweb = {total:res.data.total,per_page:res.data.per_page,current_page:res.data.current_page,last_page:res.data.last_page};
                                let _p = _${data.field}getweb.current_page * 1 - 1,
                                    _n = _${data.field}getweb.current_page * 1 + 1,
                                    _pbtn = _p > 0 ? '${data.field}gopage' : 'layui-disabled',
                                    _nbtn = _n > _${data.field}getweb.last_page ? 'layui-disabled' : '${data.field}gopage';
                                $('._${data.field}page').html(\`<div class="layui-box layui-laypage layui-laypage-default"><a class="layui-laypage-prev \${_pbtn}" data-page="\${_p}">上一页</a><a class="layui-laypage-next \${_nbtn}" data-page="\${_n}">下一页</a></div>\`);
                                _${data.field}click();
                            }
                            if(typeof success == 'function'){
                                return success(res);
                            }
                            let _list = res.data.total ? res.data.data : res.data,
                                _temp = \`\`;
                            if ('${data.gettype}'.toString() === '2'){
                               _temp += '<option value="" >请选择${data.title}</option>';
                            }
                            $.each(_list,function (k,v){
                                _temp += _${data.field}temp(JSON.stringify(v));
                            });
                            if(_${data.field}pages){
                                _temp = \`<div class='ery-fex-l ery-fex-column'>\${_temp}</div>\`;
                            } 
                            $('._${data.field}list').html(_temp);
                            if ('${data.gettype}'.toString() === '0'){
                                layform.render('radio');
                            }else if ('${data.gettype}'.toString() === '1'){
                                layform.render('checkbox');
                            }else if ('${data.gettype}'.toString() === '2'){
                                layform.render('select');
                            }
                        });
                    };
                layform.on('checkbox(${data.field})', function(data){
                    let _data = $(\`._${data.field}val\`).val();
                    _data = _data.split(',');
                    if(data.elem.checked){
                        _data.push(data.value);
                    } else {
                        $.each(_data,function(index,item) {
                            if(item.toString() === data.value.toString()){
                                _data.splice(index,1);
                            }
                        });
                    }
                    $('._${data.field}val').val(_data.toString());
                });
                $('._${data.field}so').bind("input propertychange",function(){
                        _${data.field}getweb.current_page = 1;
                        _get${data.field}list({key:\$(this).val()});
                });
                _get${data.field}list();
})
</script>`;
        },
        /**
         * 处理时间
         * @param data
         * @returns {`<input class="ery-ipt" placeholder="请选择${*}" type="text" name="${*}" value="${*|string|string}" id="${*}" ${string|string} ${string}  ${string|string}><script>
layui.use('laydate', function(){
  let laydate = layui.laydate;
  laydate.render({
    elem: '#${*}',
    type: '${string}',
  });
});
</script>`}
         * @constructor
         */
        SetDates = function (data){
            let _title = data.title_edit && typeof data.title_edit !== 'undefined' ? data.title_edit : data.title,
                _value = typeof data.default !== 'undefined' ? data.default.toString() : ``,
                _required = data.required && typeof data.required !== 'undefined' ? `required='true' lay-verify='required'` : ``,
                _disabled = data.disabled && typeof data.disabled !== 'undefined' ? `disabled='true'` : ``,
                _verify = data.required_list && typeof data.required_list !== 'undefined' ? `lay-verify='${data.required_list}'` : ``;
            _value = _value.length > 0 ? EditDates(_value) : _value;
            return `<input class="ery-ipt" placeholder="请选择${_title}" type="text" name="${data.field}" value="${_value}" id="${data.field}" ${_required} ${_verify}  ${_disabled}><script>
layui.use(function(){
  const laydate = layui.laydate;
  laydate.render({
    elem: '#${data.field}',
    type: '${data.type}',
  });
});
</script>`;
        },
        /**
         * 处理表单联动
         * @param linkdata 联动数据
         * @param type  联动类型
         * @param _file  联动字段
         * @param _val 默认值
         * @returns {string}
         * @constructor
         */
        GroupLink = function(linkdata,type,_file,_val= null){
            linkdata = JSON.stringify(linkdata);
            _val = _val === null ? -1 : _val;
            return `<script> layui.use('form', function(){ let layform = layui.form; function ${_file}${type}(o){ let _show = ${linkdata}; $.each(_show,function (k,v){ if(o.toString() === k.toString()){ return true;} $.each(v,function (k1,v1){ $(\`._\${v1}\`).addClass('ery-hidden');});}); if(!_show[o]){ return true;}  $.each(_show[o],function (k,v){ $(\`._\${v}\`).removeClass('ery-hidden');});} layform.on('${type}(${_file})',function(data){ ${_file}${type}(data.value);}); ${_file}${type}('${_val}');});</script>`;
        },
        /**
         * 组合表单
         * @param ipt 表单样式
         * @param file 表单字段
         * @param title 标题
         * @param tip   提示
         * @param hidden    是否隐藏
         * @param boxwidth    盒子宽度
         * @returns {string}
         * @constructor
         */
        SetTemp = function(ipt,file,title,tip='',hidden= '',boxwidth = ''){
            return `<div class="${boxwidth} ery-form-group ery-mag-b20 _${file}" style='${hidden}'><label class="ery-label _${file}-label" for="${file}">${title}</label><div class="ery-form-item _${file}-cont">${ipt}${tip}</div></div>`;
        };
    // 渲染到表单
    eru.ViewForm = function(classname,trlist,fun = ''){
        $.each(trlist,function (k,v){
            if(v.group.toString() !== 'stop'){
                $(`.${classname}${v.group}`).before(v.template);
            } else {
                $(`.${classname}`).before(v.template);
            }
        });
        layform.render();
        if(typeof fun === 'function'){
            fun();
        }
    }
    //  提交数据
    eru.PostUrl = function (url,data = '',success = ''){
        $.post(url,data,function(res){
            if(typeof success === 'function'){
                success(res);
                return false;
            }
            layer.msg(res.msg);
            if(res.url){
                window.location.href = res.url;
            }
        });
    };
    eru.GetUrl = function (url,data = '',fun = '') {
        $.get(url,data,function (res) {
            layer.closeAll('loading');
            if(typeof fun == "function"){
                fun(res);
            } else {
                layer.msg(res.msg,{},function () {
                    if(res.code.toString() === '1'){
                        return true;
                    }else if (res.code.toString() === '0'){
                        return false;
                    }
                })
            }
        }).fail(function () {
            layer.closeAll('loading');
            layer.alert('系统错误，请稍后再试！');
        });
    }

    //输出 wormtable 接口
    exports('eruyun_table', eru);
});